"use strict";function _typeof(obj){"@babel/helpers - typeof";if(typeof Symbol==="function"&&typeof Symbol.iterator==="symbol"){_typeof=function _typeof(obj){return typeof obj}}else{_typeof=function _typeof(obj){return obj&&typeof Symbol==="function"&&obj.constructor===Symbol&&obj!==Symbol.prototype?"symbol":typeof obj}}return _typeof(obj)}(function($){var Canvas=function Canvas(cls,container){var element=container.getElementsByClassName(cls)[0];if(!element){element=document.createElement("canvas");element.className=cls;element.style.direction="ltr";element.style.position="absolute";element.style.left="0px";element.style.top="0px";container.appendChild(element);if(!element.getContext){throw new Error("Canvas is not available.")}}this.element=element;var context=this.context=element.getContext("2d");this.pixelRatio=$.plot.browser.getPixelRatio(context);var width=$(container).width();var height=$(container).height();this.resize(width,height);this.SVGContainer=null;this.SVG={};this._textCache={}};Canvas.prototype.resize=function(width,height){var minSize=10;width=width<minSize?minSize:width;height=height<minSize?minSize:height;var element=this.element,context=this.context,pixelRatio=this.pixelRatio;if(this.width!==width){element.width=width*pixelRatio;element.style.width=width+"px";this.width=width}if(this.height!==height){element.height=height*pixelRatio;element.style.height=height+"px";this.height=height}context.restore();context.save();context.scale(pixelRatio,pixelRatio)};Canvas.prototype.clear=function(){this.context.clearRect(0,0,this.width,this.height)};Canvas.prototype.render=function(){var cache=this._textCache;for(var layerKey in cache){if(hasOwnProperty.call(cache,layerKey)){var layer=this.getSVGLayer(layerKey),layerCache=cache[layerKey];var display=layer.style.display;layer.style.display="none";for(var styleKey in layerCache){if(hasOwnProperty.call(layerCache,styleKey)){var styleCache=layerCache[styleKey];for(var key in styleCache){if(hasOwnProperty.call(styleCache,key)){var val=styleCache[key],positions=val.positions;for(var i=0,position;positions[i];i++){position=positions[i];if(position.active){if(!position.rendered){layer.appendChild(position.element);position.rendered=true}}else{positions.splice(i--,1);if(position.rendered){while(position.element.firstChild){position.element.removeChild(position.element.firstChild)}position.element.parentNode.removeChild(position.element)}}}if(positions.length===0){if(val.measured){val.measured=false}else{delete styleCache[key]}}}}}}layer.style.display=display}}};Canvas.prototype.getSVGLayer=function(classes){var layer=this.SVG[classes];if(!layer){var svgElement;if(!this.SVGContainer){this.SVGContainer=document.createElement("div");this.SVGContainer.className="flot-svg";this.SVGContainer.style.position="absolute";this.SVGContainer.style.top="0px";this.SVGContainer.style.left="0px";this.SVGContainer.style.height="100%";this.SVGContainer.style.width="100%";this.SVGContainer.style.pointerEvents="none";this.element.parentNode.appendChild(this.SVGContainer);svgElement=document.createElementNS("http://www.w3.org/2000/svg","svg");svgElement.style.width="100%";svgElement.style.height="100%";this.SVGContainer.appendChild(svgElement)}else{svgElement=this.SVGContainer.firstChild}layer=document.createElementNS("http://www.w3.org/2000/svg","g");layer.setAttribute("class",classes);layer.style.position="absolute";layer.style.top="0px";layer.style.left="0px";layer.style.bottom="0px";layer.style.right="0px";svgElement.appendChild(layer);this.SVG[classes]=layer}return layer};Canvas.prototype.getTextInfo=function(layer,text,font,angle,width){var textStyle,layerCache,styleCache,info;text=""+text;if(_typeof(font)==="object"){textStyle=font.style+" "+font.variant+" "+font.weight+" "+font.size+"px/"+font.lineHeight+"px "+font.family}else{textStyle=font}layerCache=this._textCache[layer];if(layerCache==null){layerCache=this._textCache[layer]={}}styleCache=layerCache[textStyle];if(styleCache==null){styleCache=layerCache[textStyle]={}}var key=generateKey(text);info=styleCache[key];if(!info){var element=document.createElementNS("http://www.w3.org/2000/svg","text");if(text.indexOf("<br>")!==-1){addTspanElements(text,element,-9999)}else{var textNode=document.createTextNode(text);element.appendChild(textNode)}element.style.position="absolute";element.style.maxWidth=width;element.setAttributeNS(null,"x",-9999);element.setAttributeNS(null,"y",-9999);if(_typeof(font)==="object"){element.style.font=textStyle;element.style.fill=font.fill}else if(typeof font==="string"){element.setAttribute("class",font)}this.getSVGLayer(layer).appendChild(element);var elementRect=element.getBBox();info=styleCache[key]={width:elementRect.width,height:elementRect.height,measured:true,element:element,positions:[]};while(element.firstChild){element.removeChild(element.firstChild)}element.parentNode.removeChild(element)}info.measured=true;return info};function updateTransforms(element,transforms){element.transform.baseVal.clear();if(transforms){transforms.forEach(function(t){element.transform.baseVal.appendItem(t)})}}Canvas.prototype.addText=function(layer,x,y,text,font,angle,width,halign,valign,transforms){var info=this.getTextInfo(layer,text,font,angle,width),positions=info.positions;if(halign==="center"){x-=info.width/2}else if(halign==="right"){x-=info.width}if(valign==="middle"){y-=info.height/2}else if(valign==="bottom"){y-=info.height}y+=.75*info.height;for(var i=0,position;positions[i];i++){position=positions[i];if(position.x===x&&position.y===y&&position.text===text){position.active=true;updateTransforms(position.element,transforms);return}else if(position.active===false){position.active=true;position.text=text;if(text.indexOf("<br>")!==-1){y-=.25*info.height;addTspanElements(text,position.element,x)}else{position.element.textContent=text}position.element.setAttributeNS(null,"x",x);position.element.setAttributeNS(null,"y",y);position.x=x;position.y=y;updateTransforms(position.element,transforms);return}}position={active:true,rendered:false,element:positions.length?info.element.cloneNode():info.element,text:text,x:x,y:y};positions.push(position);if(text.indexOf("<br>")!==-1){y-=.25*info.height;addTspanElements(text,position.element,x)}else{position.element.textContent=text}position.element.setAttributeNS(null,"x",x);position.element.setAttributeNS(null,"y",y);position.element.style.textAlign=halign;updateTransforms(position.element,transforms)};var addTspanElements=function addTspanElements(text,element,x){var lines=text.split("<br>"),tspan,i,offset;for(i=0;i<lines.length;i++){if(!element.childNodes[i]){tspan=document.createElementNS("http://www.w3.org/2000/svg","tspan");element.appendChild(tspan)}else{tspan=element.childNodes[i]}tspan.textContent=lines[i];offset=(i===0?0:1)+"em";tspan.setAttributeNS(null,"dy",offset);tspan.setAttributeNS(null,"x",x)}};Canvas.prototype.removeText=function(layer,x,y,text,font,angle){var info,htmlYCoord;if(text==null){var layerCache=this._textCache[layer];if(layerCache!=null){for(var styleKey in layerCache){if(hasOwnProperty.call(layerCache,styleKey)){var styleCache=layerCache[styleKey];for(var key in styleCache){if(hasOwnProperty.call(styleCache,key)){var positions=styleCache[key].positions;positions.forEach(function(position){position.active=false})}}}}}}else{info=this.getTextInfo(layer,text,font,angle);positions=info.positions;positions.forEach(function(position){htmlYCoord=y+.75*info.height;if(position.x===x&&position.y===htmlYCoord&&position.text===text){position.active=false}})}};Canvas.prototype.clearCache=function(){var cache=this._textCache;for(var layerKey in cache){if(hasOwnProperty.call(cache,layerKey)){var layer=this.getSVGLayer(layerKey);while(layer.firstChild){layer.removeChild(layer.firstChild)}}}this._textCache={}};function generateKey(text){return text.replace(/0|1|2|3|4|5|6|7|8|9/g,"0")}if(!window.Flot){window.Flot={}}window.Flot.Canvas=Canvas})(jQuery);"use strict";(function($){$.color={};$.color.make=function(r,g,b,a){var o={};o.r=r||0;o.g=g||0;o.b=b||0;o.a=a!=null?a:1;o.add=function(c,d){for(var i=0;i<c.length;++i){o[c.charAt(i)]+=d}return o.normalize()};o.scale=function(c,f){for(var i=0;i<c.length;++i){o[c.charAt(i)]*=f}return o.normalize()};o.toString=function(){if(o.a>=1){return"rgb("+[o.r,o.g,o.b].join(",")+")"}else{return"rgba("+[o.r,o.g,o.b,o.a].join(",")+")"}};o.normalize=function(){function clamp(min,value,max){return value<min?min:value>max?max:value}o.r=clamp(0,parseInt(o.r),255);o.g=clamp(0,parseInt(o.g),255);o.b=clamp(0,parseInt(o.b),255);o.a=clamp(0,o.a,1);return o};o.clone=function(){return $.color.make(o.r,o.b,o.g,o.a)};return o.normalize()};$.color.extract=function(elem,css){var c;do{c=elem.css(css).toLowerCase();if(c!==""&&c!=="transparent"){break}elem=elem.parent()}while(elem.length&&!$.nodeName(elem.get(0),"body"));if(c==="rgba(0, 0, 0, 0)"){c="transparent"}return $.color.parse(c)};$.color.parse=function(str){var res,m=$.color.make;res=/rgb\(\s*([0-9]{1,3})\s*,\s*([0-9]{1,3})\s*,\s*([0-9]{1,3})\s*\)/.exec(str);if(res){return m(parseInt(res[1],10),parseInt(res[2],10),parseInt(res[3],10))}res=/rgba\(\s*([0-9]{1,3})\s*,\s*([0-9]{1,3})\s*,\s*([0-9]{1,3})\s*,\s*([0-9]+(?:\.[0-9]+)?)\s*\)/.exec(str);if(res){return m(parseInt(res[1],10),parseInt(res[2],10),parseInt(res[3],10),parseFloat(res[4]))}res=/rgb\(\s*([0-9]+(?:\.[0-9]+)?)%\s*,\s*([0-9]+(?:\.[0-9]+)?)%\s*,\s*([0-9]+(?:\.[0-9]+)?)%\s*\)/.exec(str);if(res){return m(parseFloat(res[1])*2.55,parseFloat(res[2])*2.55,parseFloat(res[3])*2.55)}res=/rgba\(\s*([0-9]+(?:\.[0-9]+)?)%\s*,\s*([0-9]+(?:\.[0-9]+)?)%\s*,\s*([0-9]+(?:\.[0-9]+)?)%\s*,\s*([0-9]+(?:\.[0-9]+)?)\s*\)/.exec(str);if(res){return m(parseFloat(res[1])*2.55,parseFloat(res[2])*2.55,parseFloat(res[3])*2.55,parseFloat(res[4]))}res=/#([a-fA-F0-9]{2})([a-fA-F0-9]{2})([a-fA-F0-9]{2})/.exec(str);if(res){return m(parseInt(res[1],16),parseInt(res[2],16),parseInt(res[3],16))}res=/#([a-fA-F0-9])([a-fA-F0-9])([a-fA-F0-9])/.exec(str);if(res){return m(parseInt(res[1]+res[1],16),parseInt(res[2]+res[2],16),parseInt(res[3]+res[3],16))}var name=$.trim(str).toLowerCase();if(name==="transparent"){return m(255,255,255,0)}else{res=lookupColors[name]||[0,0,0];return m(res[0],res[1],res[2])}};var lookupColors={aqua:[0,255,255],azure:[240,255,255],beige:[245,245,220],black:[0,0,0],blue:[0,0,255],brown:[165,42,42],cyan:[0,255,255],darkblue:[0,0,139],darkcyan:[0,139,139],darkgrey:[169,169,169],darkgreen:[0,100,0],darkkhaki:[189,183,107],darkmagenta:[139,0,139],darkolivegreen:[85,107,47],darkorange:[255,140,0],darkorchid:[153,50,204],darkred:[139,0,0],darksalmon:[233,150,122],darkviolet:[148,0,211],fuchsia:[255,0,255],gold:[255,215,0],green:[0,128,0],indigo:[75,0,130],khaki:[240,230,140],lightblue:[173,216,230],lightcyan:[224,255,255],lightgreen:[144,238,144],lightgrey:[211,211,211],lightpink:[255,182,193],lightyellow:[255,255,224],lime:[0,255,0],magenta:[255,0,255],maroon:[128,0,0],navy:[0,0,128],olive:[128,128,0],orange:[255,165,0],pink:[255,192,203],purple:[128,0,128],violet:[128,0,128],red:[255,0,0],silver:[192,192,192],white:[255,255,255],yellow:[255,255,0]}})(jQuery);"use strict";function _typeof(obj){"@babel/helpers - typeof";if(typeof Symbol==="function"&&typeof Symbol.iterator==="symbol"){_typeof=function _typeof(obj){return typeof obj}}else{_typeof=function _typeof(obj){return obj&&typeof Symbol==="function"&&obj.constructor===Symbol&&obj!==Symbol.prototype?"symbol":typeof obj}}return _typeof(obj)}(function($){"use strict";var Canvas=window.Flot.Canvas;function defaultTickGenerator(axis){var ticks=[],start=$.plot.saturated.saturate($.plot.saturated.floorInBase(axis.min,axis.tickSize)),i=0,v=Number.NaN,prev;if(start===-Number.MAX_VALUE){ticks.push(start);start=$.plot.saturated.floorInBase(axis.min+axis.tickSize,axis.tickSize)}do{prev=v;v=$.plot.saturated.multiplyAdd(axis.tickSize,i,start);ticks.push(v);++i}while(v<axis.max&&v!==prev);return ticks}function defaultTickFormatter(value,axis,precision){var oldTickDecimals=axis.tickDecimals,expPosition=(""+value).indexOf("e");if(expPosition!==-1){return expRepTickFormatter(value,axis,precision)}if(precision>0){axis.tickDecimals=precision}var factor=axis.tickDecimals?parseFloat("1e"+axis.tickDecimals):1,formatted=""+Math.round(value*factor)/factor;if(axis.tickDecimals!=null){var decimal=formatted.indexOf("."),decimalPrecision=decimal===-1?0:formatted.length-decimal-1;if(decimalPrecision<axis.tickDecimals){var decimals=(""+factor).substr(1,axis.tickDecimals-decimalPrecision);formatted=(decimalPrecision?formatted:formatted+".")+decimals}}axis.tickDecimals=oldTickDecimals;return formatted}function expRepTickFormatter(value,axis,precision){var expPosition=(""+value).indexOf("e"),exponentValue=parseInt((""+value).substr(expPosition+1)),tenExponent=expPosition!==-1?exponentValue:value>0?Math.floor(Math.log(value)/Math.LN10):0,roundWith=parseFloat("1e"+tenExponent),x=value/roundWith;if(precision){var updatedPrecision=recomputePrecision(value,precision);return(value/roundWith).toFixed(updatedPrecision)+"e"+tenExponent}if(axis.tickDecimals>0){return x.toFixed(recomputePrecision(value,axis.tickDecimals))+"e"+tenExponent}return x.toFixed()+"e"+tenExponent}function recomputePrecision(num,precision){var log10Value=Math.log(Math.abs(num))*Math.LOG10E,newPrecision=Math.abs(log10Value+precision);return newPrecision<=20?Math.floor(newPrecision):20}function Plot(placeholder,data_,options_,plugins){var series=[],options={colors:["#edc240","#afd8f8","#cb4b4b","#4da74d","#9440ed"],xaxis:{show:null,position:"bottom",mode:null,font:null,color:null,tickColor:null,transform:null,inverseTransform:null,min:null,max:null,autoScaleMargin:null,autoScale:"exact",windowSize:null,growOnly:null,ticks:null,tickFormatter:null,showTickLabels:"major",labelWidth:null,labelHeight:null,reserveSpace:null,tickLength:null,showMinorTicks:null,showTicks:null,gridLines:null,alignTicksWithAxis:null,tickDecimals:null,tickSize:null,minTickSize:null,offset:{below:0,above:0},boxPosition:{centerX:0,centerY:0}},yaxis:{autoScaleMargin:.02,autoScale:"loose",growOnly:null,position:"left",showTickLabels:"major",offset:{below:0,above:0},boxPosition:{centerX:0,centerY:0}},xaxes:[],yaxes:[],series:{points:{show:false,radius:3,lineWidth:2,fill:true,fillColor:"#ffffff",symbol:"circle"},lines:{lineWidth:1,fill:false,fillColor:null,steps:false},bars:{show:false,lineWidth:2,horizontal:false,barWidth:.8,fill:true,fillColor:null,align:"left",zero:true},shadowSize:3,highlightColor:null},grid:{show:true,aboveData:false,color:"#545454",backgroundColor:null,borderColor:null,tickColor:null,margin:0,labelMargin:5,axisMargin:8,borderWidth:1,minBorderMargin:null,markings:null,markingsColor:"#f4f4f4",markingsLineWidth:2,clickable:false,hoverable:false,autoHighlight:true,mouseActiveRadius:15},interaction:{redrawOverlayInterval:1e3/60},hooks:{}},surface=null,overlay=null,eventHolder=null,ctx=null,octx=null,xaxes=[],yaxes=[],plotOffset={left:0,right:0,top:0,bottom:0},plotWidth=0,plotHeight=0,hooks={processOptions:[],processRawData:[],processDatapoints:[],processOffset:[],setupGrid:[],adjustSeriesDataRange:[],setRange:[],drawBackground:[],drawSeries:[],drawAxis:[],draw:[],findNearbyItems:[],axisReserveSpace:[],bindEvents:[],drawOverlay:[],resize:[],shutdown:[]},plot=this;var eventManager={};var redrawTimeout=null;plot.setData=setData;plot.setupGrid=setupGrid;plot.draw=draw;plot.getPlaceholder=function(){return placeholder};plot.getCanvas=function(){return surface.element};plot.getSurface=function(){return surface};plot.getEventHolder=function(){return eventHolder[0]};plot.getPlotOffset=function(){return plotOffset};plot.width=function(){return plotWidth};plot.height=function(){return plotHeight};plot.offset=function(){var o=eventHolder.offset();o.left+=plotOffset.left;o.top+=plotOffset.top;return o};plot.getData=function(){return series};plot.getAxes=function(){var res={};$.each(xaxes.concat(yaxes),function(_,axis){if(axis){res[axis.direction+(axis.n!==1?axis.n:"")+"axis"]=axis}});return res};plot.getXAxes=function(){return xaxes};plot.getYAxes=function(){return yaxes};plot.c2p=canvasToCartesianAxisCoords;plot.p2c=cartesianAxisToCanvasCoords;plot.getOptions=function(){return options};plot.triggerRedrawOverlay=triggerRedrawOverlay;plot.pointOffset=function(point){return{left:parseInt(xaxes[axisNumber(point,"x")-1].p2c(+point.x)+plotOffset.left,10),top:parseInt(yaxes[axisNumber(point,"y")-1].p2c(+point.y)+plotOffset.top,10)}};plot.shutdown=shutdown;plot.destroy=function(){shutdown();placeholder.removeData("plot").empty();series=[];options=null;surface=null;overlay=null;eventHolder=null;ctx=null;octx=null;xaxes=[];yaxes=[];hooks=null;plot=null};plot.resize=function(){var width=placeholder.width(),height=placeholder.height();surface.resize(width,height);overlay.resize(width,height);executeHooks(hooks.resize,[width,height])};plot.clearTextCache=function(){surface.clearCache();overlay.clearCache()};plot.autoScaleAxis=autoScaleAxis;plot.computeRangeForDataSeries=computeRangeForDataSeries;plot.adjustSeriesDataRange=adjustSeriesDataRange;plot.findNearbyItem=findNearbyItem;plot.findNearbyItems=findNearbyItems;plot.findNearbyInterpolationPoint=findNearbyInterpolationPoint;plot.computeValuePrecision=computeValuePrecision;plot.computeTickSize=computeTickSize;plot.addEventHandler=addEventHandler;plot.hooks=hooks;var MINOR_TICKS_COUNT_CONSTANT=$.plot.uiConstants.MINOR_TICKS_COUNT_CONSTANT;var TICK_LENGTH_CONSTANT=$.plot.uiConstants.TICK_LENGTH_CONSTANT;initPlugins(plot);setupCanvases();parseOptions(options_);setData(data_);setupGrid(true);draw();bindEvents();function executeHooks(hook,args){args=[plot].concat(args);for(var i=0;i<hook.length;++i){hook[i].apply(this,args)}}function initPlugins(){var classes={Canvas:Canvas};for(var i=0;i<plugins.length;++i){var p=plugins[i];p.init(plot,classes);if(p.options){$.extend(true,options,p.options)}}}function parseOptions(opts){$.extend(true,options,opts);if(opts&&opts.colors){options.colors=opts.colors}if(options.xaxis.color==null){options.xaxis.color=$.color.parse(options.grid.color).scale("a",.22).toString()}if(options.yaxis.color==null){options.yaxis.color=$.color.parse(options.grid.color).scale("a",.22).toString()}if(options.xaxis.tickColor==null){options.xaxis.tickColor=options.grid.tickColor||options.xaxis.color}if(options.yaxis.tickColor==null){options.yaxis.tickColor=options.grid.tickColor||options.yaxis.color}if(options.grid.borderColor==null){options.grid.borderColor=options.grid.color}if(options.grid.tickColor==null){options.grid.tickColor=$.color.parse(options.grid.color).scale("a",.22).toString()}var i,axisOptions,axisCount,fontSize=placeholder.css("font-size"),fontSizeDefault=fontSize?+fontSize.replace("px",""):13,fontDefaults={style:placeholder.css("font-style"),size:Math.round(.8*fontSizeDefault),variant:placeholder.css("font-variant"),weight:placeholder.css("font-weight"),family:placeholder.css("font-family")};axisCount=options.xaxes.length||1;for(i=0;i<axisCount;++i){axisOptions=options.xaxes[i];if(axisOptions&&!axisOptions.tickColor){axisOptions.tickColor=axisOptions.color}axisOptions=$.extend(true,{},options.xaxis,axisOptions);options.xaxes[i]=axisOptions;if(axisOptions.font){axisOptions.font=$.extend({},fontDefaults,axisOptions.font);if(!axisOptions.font.color){axisOptions.font.color=axisOptions.color}if(!axisOptions.font.lineHeight){axisOptions.font.lineHeight=Math.round(axisOptions.font.size*1.15)}}}axisCount=options.yaxes.length||1;for(i=0;i<axisCount;++i){axisOptions=options.yaxes[i];if(axisOptions&&!axisOptions.tickColor){axisOptions.tickColor=axisOptions.color}axisOptions=$.extend(true,{},options.yaxis,axisOptions);options.yaxes[i]=axisOptions;if(axisOptions.font){axisOptions.font=$.extend({},fontDefaults,axisOptions.font);if(!axisOptions.font.color){axisOptions.font.color=axisOptions.color}if(!axisOptions.font.lineHeight){axisOptions.font.lineHeight=Math.round(axisOptions.font.size*1.15)}}}for(i=0;i<options.xaxes.length;++i){getOrCreateAxis(xaxes,i+1).options=options.xaxes[i]}for(i=0;i<options.yaxes.length;++i){getOrCreateAxis(yaxes,i+1).options=options.yaxes[i]}$.each(allAxes(),function(_,axis){axis.boxPosition=axis.options.boxPosition||{centerX:0,centerY:0}});for(var n in hooks){if(options.hooks[n]&&options.hooks[n].length){hooks[n]=hooks[n].concat(options.hooks[n])}}executeHooks(hooks.processOptions,[options])}function setData(d){var oldseries=series;series=parseData(d);fillInSeriesOptions();processData(oldseries)}function parseData(d){var res=[];for(var i=0;i<d.length;++i){var s=$.extend(true,{},options.series);if(d[i].data!=null){s.data=d[i].data;delete d[i].data;$.extend(true,s,d[i]);d[i].data=s.data}else{s.data=d[i]}res.push(s)}return res}function axisNumber(obj,coord){var a=obj[coord+"axis"];if(_typeof(a)==="object"){a=a.n}if(typeof a!=="number"){a=1}return a}function allAxes(){return xaxes.concat(yaxes).filter(function(a){return a})}function canvasToCartesianAxisCoords(pos){var res={},i,axis;for(i=0;i<xaxes.length;++i){axis=xaxes[i];if(axis&&axis.used){res["x"+axis.n]=axis.c2p(pos.left)}}for(i=0;i<yaxes.length;++i){axis=yaxes[i];if(axis&&axis.used){res["y"+axis.n]=axis.c2p(pos.top)}}if(res.x1!==undefined){res.x=res.x1}if(res.y1!==undefined){res.y=res.y1}return res}function cartesianAxisToCanvasCoords(pos){var res={},i,axis,key;for(i=0;i<xaxes.length;++i){axis=xaxes[i];if(axis&&axis.used){key="x"+axis.n;if(pos[key]==null&&axis.n===1){key="x"}if(pos[key]!=null){res.left=axis.p2c(pos[key]);break}}}for(i=0;i<yaxes.length;++i){axis=yaxes[i];if(axis&&axis.used){key="y"+axis.n;if(pos[key]==null&&axis.n===1){key="y"}if(pos[key]!=null){res.top=axis.p2c(pos[key]);break}}}return res}function getOrCreateAxis(axes,number){if(!axes[number-1]){axes[number-1]={n:number,direction:axes===xaxes?"x":"y",options:$.extend(true,{},axes===xaxes?options.xaxis:options.yaxis)}}return axes[number-1]}function fillInSeriesOptions(){var neededColors=series.length,maxIndex=-1,i;for(i=0;i<series.length;++i){var sc=series[i].color;if(sc!=null){neededColors--;if(typeof sc==="number"&&sc>maxIndex){maxIndex=sc}}}if(neededColors<=maxIndex){neededColors=maxIndex+1}var c,colors=[],colorPool=options.colors,colorPoolSize=colorPool.length,variation=0,definedColors=Math.max(0,series.length-neededColors);for(i=0;i<neededColors;i++){c=$.color.parse(colorPool[(definedColors+i)%colorPoolSize]||"#666");if(i%colorPoolSize===0&&i){if(variation>=0){if(variation<.5){variation=-variation-.2}else variation=0}else variation=-variation}colors[i]=c.scale("rgb",1+variation)}var colori=0,s;for(i=0;i<series.length;++i){s=series[i];if(s.color==null){s.color=colors[colori].toString();++colori}else if(typeof s.color==="number"){s.color=colors[s.color].toString()}if(s.lines.show==null){var v,show=true;for(v in s){if(s[v]&&s[v].show){show=false;break}}if(show){s.lines.show=true}}if(s.lines.zero==null){s.lines.zero=!!s.lines.fill}s.xaxis=getOrCreateAxis(xaxes,axisNumber(s,"x"));s.yaxis=getOrCreateAxis(yaxes,axisNumber(s,"y"))}}function processData(prevSeries){var topSentry=Number.POSITIVE_INFINITY,bottomSentry=Number.NEGATIVE_INFINITY,i,j,k,m,s,points,ps,val,f,p,data,format;function updateAxis(axis,min,max){if(min<axis.datamin&&min!==-Infinity){axis.datamin=min}if(max>axis.datamax&&max!==Infinity){axis.datamax=max}}function reusePoints(prevSeries,i){if(prevSeries&&prevSeries[i]&&prevSeries[i].datapoints&&prevSeries[i].datapoints.points){return prevSeries[i].datapoints.points}return[]}$.each(allAxes(),function(_,axis){if(axis.options.growOnly!==true){axis.datamin=topSentry;axis.datamax=bottomSentry}else{if(axis.datamin===undefined){axis.datamin=topSentry}if(axis.datamax===undefined){axis.datamax=bottomSentry}}axis.used=false});for(i=0;i<series.length;++i){s=series[i];s.datapoints={points:[]};if(s.datapoints.points.length===0){s.datapoints.points=reusePoints(prevSeries,i)}executeHooks(hooks.processRawData,[s,s.data,s.datapoints])}for(i=0;i<series.length;++i){s=series[i];data=s.data;format=s.datapoints.format;if(!format){format=[];format.push({x:true,y:false,number:true,required:true,computeRange:s.xaxis.options.autoScale!=="none",defaultValue:null});format.push({x:false,y:true,number:true,required:true,computeRange:s.yaxis.options.autoScale!=="none",defaultValue:null});if(s.stack||s.bars.show||s.lines.show&&s.lines.fill){var expectedPs=s.datapoints.pointsize!=null?s.datapoints.pointsize:s.data&&s.data[0]&&s.data[0].length?s.data[0].length:3;if(expectedPs>2){format.push({x:false,y:true,number:true,required:false,computeRange:s.yaxis.options.autoScale!=="none",defaultValue:0})}}s.datapoints.format=format}s.xaxis.used=s.yaxis.used=true;if(s.datapoints.pointsize!=null)continue;s.datapoints.pointsize=format.length;ps=s.datapoints.pointsize;points=s.datapoints.points;for(j=k=0;j<data.length;++j,k+=ps){p=data[j];var nullify=p==null;if(!nullify){for(m=0;m<ps;++m){val=p[m];f=format[m];if(f){if(f.number&&val!=null){val=+val;if(isNaN(val)){val=null}}if(val==null){if(f.required)nullify=true;if(f.defaultValue!=null)val=f.defaultValue}}points[k+m]=val}}if(nullify){for(m=0;m<ps;++m){val=points[k+m];if(val!=null){f=format[m];if(f.computeRange){if(f.x){updateAxis(s.xaxis,val,val)}if(f.y){updateAxis(s.yaxis,val,val)}}}points[k+m]=null}}}points.length=k}for(i=0;i<series.length;++i){s=series[i];executeHooks(hooks.processDatapoints,[s,s.datapoints])}for(i=0;i<series.length;++i){s=series[i];format=s.datapoints.format;if(format.every(function(f){return!f.computeRange})){continue}var range=plot.adjustSeriesDataRange(s,plot.computeRangeForDataSeries(s));executeHooks(hooks.adjustSeriesDataRange,[s,range]);updateAxis(s.xaxis,range.xmin,range.xmax);updateAxis(s.yaxis,range.ymin,range.ymax)}$.each(allAxes(),function(_,axis){if(axis.datamin===topSentry){axis.datamin=null}if(axis.datamax===bottomSentry){axis.datamax=null}})}function setupCanvases(){placeholder.css("padding",0).children().filter(function(){return!$(this).hasClass("flot-overlay")&&!$(this).hasClass("flot-base")}).remove();if(placeholder.css("position")==="static"){placeholder.css("position","relative")}surface=new Canvas("flot-base",placeholder[0]);overlay=new Canvas("flot-overlay",placeholder[0]);ctx=surface.context;octx=overlay.context;eventHolder=$(overlay.element).unbind();var existing=placeholder.data("plot");if(existing){existing.shutdown();overlay.clear()}placeholder.data("plot",plot)}function bindEvents(){executeHooks(hooks.bindEvents,[eventHolder])}function addEventHandler(event,handler,eventHolder,priority){var key=eventHolder+event;var eventList=eventManager[key]||[];eventList.push({event:event,handler:handler,eventHolder:eventHolder,priority:priority});eventList.sort(function(a,b){return b.priority-a.priority});eventList.forEach(function(eventData){eventData.eventHolder.unbind(eventData.event,eventData.handler);eventData.eventHolder.bind(eventData.event,eventData.handler)});eventManager[key]=eventList}function shutdown(){if(redrawTimeout){clearTimeout(redrawTimeout)}executeHooks(hooks.shutdown,[eventHolder])}function setTransformationHelpers(axis){function identity(x){return x}var s,m,t=axis.options.transform||identity,it=axis.options.inverseTransform;if(axis.direction==="x"){if(isFinite(t(axis.max)-t(axis.min))){s=axis.scale=plotWidth/Math.abs(t(axis.max)-t(axis.min))}else{s=axis.scale=1/Math.abs($.plot.saturated.delta(t(axis.min),t(axis.max),plotWidth))}m=Math.min(t(axis.max),t(axis.min))}else{if(isFinite(t(axis.max)-t(axis.min))){s=axis.scale=plotHeight/Math.abs(t(axis.max)-t(axis.min))}else{s=axis.scale=1/Math.abs($.plot.saturated.delta(t(axis.min),t(axis.max),plotHeight))}s=-s;m=Math.max(t(axis.max),t(axis.min))}if(t===identity){axis.p2c=function(p){if(isFinite(p-m)){return(p-m)*s}else{return(p/4-m/4)*s*4}}}else{axis.p2c=function(p){var tp=t(p);if(isFinite(tp-m)){return(tp-m)*s}else{return(tp/4-m/4)*s*4}}}if(!it){axis.c2p=function(c){return m+c/s}}else{axis.c2p=function(c){return it(m+c/s)}}}function measureTickLabels(axis){var opts=axis.options,ticks=opts.showTickLabels!=="none"&&axis.ticks?axis.ticks:[],showMajorTickLabels=opts.showTickLabels==="major"||opts.showTickLabels==="all",showEndpointsTickLabels=opts.showTickLabels==="endpoints"||opts.showTickLabels==="all",labelWidth=opts.labelWidth||0,labelHeight=opts.labelHeight||0,legacyStyles=axis.direction+"Axis "+axis.direction+axis.n+"Axis",layer="flot-"+axis.direction+"-axis flot-"+axis.direction+axis.n+"-axis "+legacyStyles,font=opts.font||"flot-tick-label tickLabel";for(var i=0;i<ticks.length;++i){var t=ticks[i];var label=t.label;if(!t.label||showMajorTickLabels===false&&i>0&&i<ticks.length-1||showEndpointsTickLabels===false&&(i===0||i===ticks.length-1)){continue}if(_typeof(t.label)==="object"){label=t.label.name}var info=surface.getTextInfo(layer,label,font);labelWidth=Math.max(labelWidth,info.width);labelHeight=Math.max(labelHeight,info.height)}axis.labelWidth=opts.labelWidth||labelWidth;axis.labelHeight=opts.labelHeight||labelHeight}function allocateAxisBoxFirstPhase(axis){executeHooks(hooks.axisReserveSpace,[axis]);var lw=axis.labelWidth,lh=axis.labelHeight,pos=axis.options.position,isXAxis=axis.direction==="x",tickLength=axis.options.tickLength,showTicks=axis.options.showTicks,showMinorTicks=axis.options.showMinorTicks,gridLines=axis.options.gridLines,axisMargin=options.grid.axisMargin,padding=options.grid.labelMargin,innermost=true,outermost=true,found=false;$.each(isXAxis?xaxes:yaxes,function(i,a){if(a&&(a.show||a.reserveSpace)){if(a===axis){found=true}else if(a.options.position===pos){if(found){outermost=false}else{innermost=false}}}});if(outermost){axisMargin=0}if(tickLength==null){tickLength=TICK_LENGTH_CONSTANT}if(showTicks==null){showTicks=true}if(showMinorTicks==null){showMinorTicks=true}if(gridLines==null){if(innermost){gridLines=true}else{gridLines=false}}if(!isNaN(+tickLength)){padding+=showTicks?+tickLength:0}if(isXAxis){lh+=padding;if(pos==="bottom"){plotOffset.bottom+=lh+axisMargin;axis.box={top:surface.height-plotOffset.bottom,height:lh}}else{axis.box={top:plotOffset.top+axisMargin,height:lh};plotOffset.top+=lh+axisMargin}}else{lw+=padding;if(pos==="left"){axis.box={left:plotOffset.left+axisMargin,width:lw};plotOffset.left+=lw+axisMargin}else{plotOffset.right+=lw+axisMargin;axis.box={left:surface.width-plotOffset.right,width:lw}}}axis.position=pos;axis.tickLength=tickLength;axis.showMinorTicks=showMinorTicks;axis.showTicks=showTicks;axis.gridLines=gridLines;axis.box.padding=padding;axis.innermost=innermost}function allocateAxisBoxSecondPhase(axis){if(axis.direction==="x"){axis.box.left=plotOffset.left-axis.labelWidth/2;axis.box.width=surface.width-plotOffset.left-plotOffset.right+axis.labelWidth}else{axis.box.top=plotOffset.top-axis.labelHeight/2;axis.box.height=surface.height-plotOffset.bottom-plotOffset.top+axis.labelHeight}}function adjustLayoutForThingsStickingOut(){var minMargin=options.grid.minBorderMargin,i;if(minMargin==null){minMargin=0;for(i=0;i<series.length;++i){minMargin=Math.max(minMargin,2*(series[i].points.radius+series[i].points.lineWidth/2))}}var a,offset={},margins={left:minMargin,right:minMargin,top:minMargin,bottom:minMargin};$.each(allAxes(),function(_,axis){if(axis.reserveSpace&&axis.ticks&&axis.ticks.length){if(axis.direction==="x"){margins.left=Math.max(margins.left,axis.labelWidth/2);margins.right=Math.max(margins.right,axis.labelWidth/2)}else{margins.bottom=Math.max(margins.bottom,axis.labelHeight/2);margins.top=Math.max(margins.top,axis.labelHeight/2)}}});for(a in margins){offset[a]=margins[a]-plotOffset[a]}$.each(xaxes.concat(yaxes),function(_,axis){alignAxisWithGrid(axis,offset,function(offset){return offset>0})});plotOffset.left=Math.ceil(Math.max(margins.left,plotOffset.left));plotOffset.right=Math.ceil(Math.max(margins.right,plotOffset.right));plotOffset.top=Math.ceil(Math.max(margins.top,plotOffset.top));plotOffset.bottom=Math.ceil(Math.max(margins.bottom,plotOffset.bottom))}function alignAxisWithGrid(axis,offset,isValid){if(axis.direction==="x"){if(axis.position==="bottom"&&isValid(offset.bottom)){axis.box.top-=Math.ceil(offset.bottom)}if(axis.position==="top"&&isValid(offset.top)){axis.box.top+=Math.ceil(offset.top)}}else{if(axis.position==="left"&&isValid(offset.left)){axis.box.left+=Math.ceil(offset.left)}if(axis.position==="right"&&isValid(offset.right)){axis.box.left-=Math.ceil(offset.right)}}}function setupGrid(autoScale){var i,a,axes=allAxes(),showGrid=options.grid.show;for(a in plotOffset){plotOffset[a]=0}executeHooks(hooks.processOffset,[plotOffset]);for(a in plotOffset){if(_typeof(options.grid.borderWidth)==="object"){plotOffset[a]+=showGrid?options.grid.borderWidth[a]:0}else{plotOffset[a]+=showGrid?options.grid.borderWidth:0}}$.each(axes,function(_,axis){var axisOpts=axis.options;axis.show=axisOpts.show==null?axis.used:axisOpts.show;axis.reserveSpace=axisOpts.reserveSpace==null?axis.show:axisOpts.reserveSpace;setupTickFormatter(axis);executeHooks(hooks.setRange,[axis,autoScale]);setRange(axis,autoScale)});if(showGrid){plotWidth=surface.width-plotOffset.left-plotOffset.right;plotHeight=surface.height-plotOffset.bottom-plotOffset.top;var allocatedAxes=$.grep(axes,function(axis){return axis.show||axis.reserveSpace});$.each(allocatedAxes,function(_,axis){setupTickGeneration(axis);setMajorTicks(axis);snapRangeToTicks(axis,axis.ticks,series);setTransformationHelpers(axis);setEndpointTicks(axis,series);measureTickLabels(axis)});for(i=allocatedAxes.length-1;i>=0;--i){allocateAxisBoxFirstPhase(allocatedAxes[i])}adjustLayoutForThingsStickingOut();$.each(allocatedAxes,function(_,axis){allocateAxisBoxSecondPhase(axis)})}if(options.grid.margin){for(a in plotOffset){var margin=options.grid.margin||0;plotOffset[a]+=typeof margin==="number"?margin:margin[a]||0}$.each(xaxes.concat(yaxes),function(_,axis){alignAxisWithGrid(axis,options.grid.margin,function(offset){return offset!==undefined&&offset!==null})})}plotWidth=surface.width-plotOffset.left-plotOffset.right;plotHeight=surface.height-plotOffset.bottom-plotOffset.top;$.each(axes,function(_,axis){setTransformationHelpers(axis)});if(showGrid){drawAxisLabels()}executeHooks(hooks.setupGrid,[])}function widenMinMax(minimum,maximum){var min=minimum===undefined?null:minimum;var max=maximum===undefined?null:maximum;var delta=max-min;if(delta===0){var widen=max===0?1:.01;var wmin=null;if(min==null){wmin-=widen}if(max==null||min!=null){max+=widen}if(wmin!=null){min=wmin}}return{min:min,max:max}}function autoScaleAxis(axis){var opts=axis.options,min=opts.min,max=opts.max,datamin=axis.datamin,datamax=axis.datamax,delta;switch(opts.autoScale){case"none":min=+(opts.min!=null?opts.min:datamin);max=+(opts.max!=null?opts.max:datamax);break;case"loose":if(datamin!=null&&datamax!=null){min=datamin;max=datamax;delta=$.plot.saturated.saturate(max-min);var margin=typeof opts.autoScaleMargin==="number"?opts.autoScaleMargin:.02;min=$.plot.saturated.saturate(min-delta*margin);max=$.plot.saturated.saturate(max+delta*margin);if(min<0&&datamin>=0){min=0}}else{min=opts.min;max=opts.max}break;case"exact":min=datamin!=null?datamin:opts.min;max=datamax!=null?datamax:opts.max;break;case"sliding-window":if(datamax>max){max=datamax;min=Math.max(datamax-(opts.windowSize||100),min)}break}var widenedMinMax=widenMinMax(min,max);min=widenedMinMax.min;max=widenedMinMax.max;if(opts.growOnly===true&&opts.autoScale!=="none"&&opts.autoScale!=="sliding-window"){min=min<datamin?min:datamin!==null?datamin:min;max=max>datamax?max:datamax!==null?datamax:max}axis.autoScaledMin=min;axis.autoScaledMax=max}function setRange(axis,autoScale){var min=typeof axis.options.min==="number"?axis.options.min:axis.min,max=typeof axis.options.max==="number"?axis.options.max:axis.max,plotOffset=axis.options.offset;if(autoScale){autoScaleAxis(axis);min=axis.autoScaledMin;max=axis.autoScaledMax}min=(min!=null?min:-1)+(plotOffset.below||0);max=(max!=null?max:1)+(plotOffset.above||0);if(min>max){var tmp=min;min=max;max=tmp;axis.options.offset={above:0,below:0}}axis.min=$.plot.saturated.saturate(min);axis.max=$.plot.saturated.saturate(max)}function computeValuePrecision(min,max,direction,ticks,tickDecimals){var noTicks=fixupNumberOfTicks(direction,surface,ticks);var delta=$.plot.saturated.delta(min,max,noTicks),dec=-Math.floor(Math.log(delta)/Math.LN10);if(tickDecimals&&dec>tickDecimals){dec=tickDecimals}var magn=parseFloat("1e"+-dec),norm=delta/magn;if(norm>2.25&&norm<3&&dec+1<=tickDecimals){++dec}return isFinite(dec)?dec:0}function computeTickSize(min,max,noTicks,tickDecimals){var delta=$.plot.saturated.delta(min,max,noTicks),dec=-Math.floor(Math.log(delta)/Math.LN10);if(tickDecimals&&dec>tickDecimals){dec=tickDecimals}var magn=parseFloat("1e"+-dec),norm=delta/magn,size;if(norm<1.5){size=1}else if(norm<3){size=2;if(norm>2.25&&(tickDecimals==null||dec+1<=tickDecimals)){size=2.5}}else if(norm<7.5){size=5}else{size=10}size*=magn;return size}function getAxisTickSize(min,max,direction,options,tickDecimals){var noTicks;if(typeof options.ticks==="number"&&options.ticks>0){noTicks=options.ticks}else{noTicks=.3*Math.sqrt(direction==="x"?surface.width:surface.height)}var size=computeTickSize(min,max,noTicks,tickDecimals);if(options.minTickSize!=null&&size<options.minTickSize){size=options.minTickSize}return options.tickSize||size}function fixupNumberOfTicks(direction,surface,ticksOption){var noTicks;if(typeof ticksOption==="number"&&ticksOption>0){noTicks=ticksOption}else{noTicks=.3*Math.sqrt(direction==="x"?surface.width:surface.height)}return noTicks}function setupTickFormatter(axis){var opts=axis.options;if(!axis.tickFormatter){if(typeof opts.tickFormatter==="function"){axis.tickFormatter=function(){var args=Array.prototype.slice.call(arguments);return""+opts.tickFormatter.apply(null,args)}}else{axis.tickFormatter=defaultTickFormatter}}}function setupTickGeneration(axis){var opts=axis.options;var noTicks;noTicks=fixupNumberOfTicks(axis.direction,surface,opts.ticks);axis.delta=$.plot.saturated.delta(axis.min,axis.max,noTicks);var precision=plot.computeValuePrecision(axis.min,axis.max,axis.direction,noTicks,opts.tickDecimals);axis.tickDecimals=Math.max(0,opts.tickDecimals!=null?opts.tickDecimals:precision);axis.tickSize=getAxisTickSize(axis.min,axis.max,axis.direction,opts,opts.tickDecimals);if(!axis.tickGenerator){if(typeof opts.tickGenerator==="function"){axis.tickGenerator=opts.tickGenerator}else{axis.tickGenerator=defaultTickGenerator}}if(opts.alignTicksWithAxis!=null){var otherAxis=(axis.direction==="x"?xaxes:yaxes)[opts.alignTicksWithAxis-1];if(otherAxis&&otherAxis.used&&otherAxis!==axis){var niceTicks=axis.tickGenerator(axis,plot);if(niceTicks.length>0){if(opts.min==null){axis.min=Math.min(axis.min,niceTicks[0])}if(opts.max==null&&niceTicks.length>1){axis.max=Math.max(axis.max,niceTicks[niceTicks.length-1])}}axis.tickGenerator=function(axis){var ticks=[],v,i;for(i=0;i<otherAxis.ticks.length;++i){v=(otherAxis.ticks[i].v-otherAxis.min)/(otherAxis.max-otherAxis.min);v=axis.min+v*(axis.max-axis.min);ticks.push(v)}return ticks};if(!axis.mode&&opts.tickDecimals==null){var extraDec=Math.max(0,-Math.floor(Math.log(axis.delta)/Math.LN10)+1),ts=axis.tickGenerator(axis,plot);if(!(ts.length>1&&/\..*0$/.test((ts[1]-ts[0]).toFixed(extraDec)))){axis.tickDecimals=extraDec}}}}}function setMajorTicks(axis){var oticks=axis.options.ticks,ticks=[];if(oticks==null||typeof oticks==="number"&&oticks>0){ticks=axis.tickGenerator(axis,plot)}else if(oticks){if($.isFunction(oticks)){ticks=oticks(axis)}else{ticks=oticks}}var i,v;axis.ticks=[];for(i=0;i<ticks.length;++i){var label=null;var t=ticks[i];if(_typeof(t)==="object"){v=+t[0];if(t.length>1){label=t[1]}}else{v=+t}if(!isNaN(v)){axis.ticks.push(newTick(v,label,axis,"major"))}}}function newTick(v,label,axis,type){if(label===null){switch(type){case"min":case"max":var precision=getEndpointPrecision(v,axis);label=isFinite(precision)?axis.tickFormatter(v,axis,precision,plot):axis.tickFormatter(v,axis,precision,plot);break;case"major":label=axis.tickFormatter(v,axis,undefined,plot)}}return{v:v,label:label}}function snapRangeToTicks(axis,ticks,series){var anyDataInSeries=function anyDataInSeries(series){return series.some(function(e){return e.datapoints.points.length>0})};if(axis.options.autoScale==="loose"&&ticks.length>0&&anyDataInSeries(series)){axis.min=Math.min(axis.min,ticks[0].v);axis.max=Math.max(axis.max,ticks[ticks.length-1].v)}}function getEndpointPrecision(value,axis){var canvas1=Math.floor(axis.p2c(value)),canvas2=axis.direction==="x"?canvas1+1:canvas1-1,point1=axis.c2p(canvas1),point2=axis.c2p(canvas2),precision=computeValuePrecision(point1,point2,axis.direction,1);return precision}function setEndpointTicks(axis,series){if(isValidEndpointTick(axis,series)){axis.ticks.unshift(newTick(axis.min,null,axis,"min"));axis.ticks.push(newTick(axis.max,null,axis,"max"))}}function isValidEndpointTick(axis,series){if(axis.options.showTickLabels==="endpoints"){return true}if(axis.options.showTickLabels==="all"){var associatedSeries=series.filter(function(s){return s.bars.horizontal?s.yaxis===axis:s.xaxis===axis}),notAllBarSeries=associatedSeries.some(function(s){return!s.bars.show});return associatedSeries.length===0||notAllBarSeries}if(axis.options.showTickLabels==="major"||axis.options.showTickLabels==="none"){return false}}function draw(){surface.clear();executeHooks(hooks.drawBackground,[ctx]);var grid=options.grid;if(grid.show&&grid.backgroundColor){drawBackground()}if(grid.show&&!grid.aboveData){drawGrid()}for(var i=0;i<series.length;++i){executeHooks(hooks.drawSeries,[ctx,series[i],i,getColorOrGradient]);drawSeries(series[i])}executeHooks(hooks.draw,[ctx]);if(grid.show&&grid.aboveData){drawGrid()}surface.render();triggerRedrawOverlay()}function extractRange(ranges,coord){var axis,from,to,key,axes=allAxes();for(var i=0;i<axes.length;++i){axis=axes[i];if(axis.direction===coord){key=coord+axis.n+"axis";if(!ranges[key]&&axis.n===1){key=coord+"axis"}if(ranges[key]){from=ranges[key].from;to=ranges[key].to;break}}}if(!ranges[key]){axis=coord==="x"?xaxes[0]:yaxes[0];from=ranges[coord+"1"];to=ranges[coord+"2"]}if(from!=null&&to!=null&&from>to){var tmp=from;from=to;to=tmp}return{from:from,to:to,axis:axis}}function drawBackground(){ctx.save();ctx.translate(plotOffset.left,plotOffset.top);ctx.fillStyle=getColorOrGradient(options.grid.backgroundColor,plotHeight,0,"rgba(255, 255, 255, 0)");ctx.fillRect(0,0,plotWidth,plotHeight);ctx.restore()}function drawMarkings(){var markings=options.grid.markings,axes;if(markings){if($.isFunction(markings)){axes=plot.getAxes();axes.xmin=axes.xaxis.min;axes.xmax=axes.xaxis.max;axes.ymin=axes.yaxis.min;axes.ymax=axes.yaxis.max;markings=markings(axes)}var i;for(i=0;i<markings.length;++i){var m=markings[i],xrange=extractRange(m,"x"),yrange=extractRange(m,"y");if(xrange.from==null){xrange.from=xrange.axis.min}if(xrange.to==null){xrange.to=xrange.axis.max}if(yrange.from==null){yrange.from=yrange.axis.min}if(yrange.to==null){yrange.to=yrange.axis.max}if(xrange.to<xrange.axis.min||xrange.from>xrange.axis.max||yrange.to<yrange.axis.min||yrange.from>yrange.axis.max){continue}xrange.from=Math.max(xrange.from,xrange.axis.min);xrange.to=Math.min(xrange.to,xrange.axis.max);yrange.from=Math.max(yrange.from,yrange.axis.min);yrange.to=Math.min(yrange.to,yrange.axis.max);var xequal=xrange.from===xrange.to,yequal=yrange.from===yrange.to;if(xequal&&yequal){continue}xrange.from=Math.floor(xrange.axis.p2c(xrange.from));xrange.to=Math.floor(xrange.axis.p2c(xrange.to));yrange.from=Math.floor(yrange.axis.p2c(yrange.from));yrange.to=Math.floor(yrange.axis.p2c(yrange.to));if(xequal||yequal){var lineWidth=m.lineWidth||options.grid.markingsLineWidth,subPixel=lineWidth%2?.5:0;ctx.beginPath();ctx.strokeStyle=m.color||options.grid.markingsColor;ctx.lineWidth=lineWidth;if(xequal){ctx.moveTo(xrange.to+subPixel,yrange.from);ctx.lineTo(xrange.to+subPixel,yrange.to)}else{ctx.moveTo(xrange.from,yrange.to+subPixel);ctx.lineTo(xrange.to,yrange.to+subPixel)}ctx.stroke()}else{ctx.fillStyle=m.color||options.grid.markingsColor;ctx.fillRect(xrange.from,yrange.to,xrange.to-xrange.from,yrange.from-yrange.to)}}}}function findEdges(axis){var box=axis.box,x=0,y=0;if(axis.direction==="x"){x=0;y=box.top-plotOffset.top+(axis.position==="top"?box.height:0)}else{y=0;x=box.left-plotOffset.left+(axis.position==="left"?box.width:0)+axis.boxPosition.centerX}return{x:x,y:y}}function alignPosition(lineWidth,pos){return lineWidth%2!==0?Math.floor(pos)+.5:pos}function drawTickBar(axis){ctx.lineWidth=1;var edges=findEdges(axis),x=edges.x,y=edges.y;if(axis.show){var xoff=0,yoff=0;ctx.strokeStyle=axis.options.color;ctx.beginPath();if(axis.direction==="x"){xoff=plotWidth+1}else{yoff=plotHeight+1}if(axis.direction==="x"){y=alignPosition(ctx.lineWidth,y)}else{x=alignPosition(ctx.lineWidth,x)}ctx.moveTo(x,y);ctx.lineTo(x+xoff,y+yoff);ctx.stroke()}}function drawTickMarks(axis){var t=axis.tickLength,minorTicks=axis.showMinorTicks,minorTicksNr=MINOR_TICKS_COUNT_CONSTANT,edges=findEdges(axis),x=edges.x,y=edges.y,i=0;ctx.strokeStyle=axis.options.color;ctx.beginPath();for(i=0;i<axis.ticks.length;++i){var v=axis.ticks[i].v,xoff=0,yoff=0,xminor=0,yminor=0,j;if(!isNaN(v)&&v>=axis.min&&v<=axis.max){if(axis.direction==="x"){x=axis.p2c(v);yoff=t;if(axis.position==="top"){yoff=-yoff}}else{y=axis.p2c(v);xoff=t;if(axis.position==="left"){xoff=-xoff}}if(axis.direction==="x"){x=alignPosition(ctx.lineWidth,x)}else{y=alignPosition(ctx.lineWidth,y)}ctx.moveTo(x,y);ctx.lineTo(x+xoff,y+yoff)}if(minorTicks===true&&i<axis.ticks.length-1){var v1=axis.ticks[i].v,v2=axis.ticks[i+1].v,step=(v2-v1)/(minorTicksNr+1);for(j=1;j<=minorTicksNr;j++){if(axis.direction==="x"){yminor=t/2;x=alignPosition(ctx.lineWidth,axis.p2c(v1+j*step));if(axis.position==="top"){yminor=-yminor}if(x<0||x>plotWidth){continue}}else{xminor=t/2;y=alignPosition(ctx.lineWidth,axis.p2c(v1+j*step));if(axis.position==="left"){xminor=-xminor}if(y<0||y>plotHeight){continue}}ctx.moveTo(x,y);ctx.lineTo(x+xminor,y+yminor)}}}ctx.stroke()}function drawGridLines(axis){var overlappedWithBorder=function overlappedWithBorder(value){var bw=options.grid.borderWidth;return(_typeof(bw)==="object"&&bw[axis.position]>0||bw>0)&&(value===axis.min||value===axis.max)};ctx.strokeStyle=options.grid.tickColor;ctx.beginPath();var i;for(i=0;i<axis.ticks.length;++i){var v=axis.ticks[i].v,xoff=0,yoff=0,x=0,y=0;if(isNaN(v)||v<axis.min||v>axis.max)continue;if(overlappedWithBorder(v))continue;if(axis.direction==="x"){x=axis.p2c(v);y=plotHeight;yoff=-plotHeight}else{x=0;y=axis.p2c(v);xoff=plotWidth}if(axis.direction==="x"){x=alignPosition(ctx.lineWidth,x)}else{y=alignPosition(ctx.lineWidth,y)}ctx.moveTo(x,y);ctx.lineTo(x+xoff,y+yoff)}ctx.stroke()}function drawBorder(){var bw=options.grid.borderWidth,bc=options.grid.borderColor;if(_typeof(bw)==="object"||_typeof(bc)==="object"){if(_typeof(bw)!=="object"){bw={top:bw,right:bw,bottom:bw,left:bw}}if(_typeof(bc)!=="object"){bc={top:bc,right:bc,bottom:bc,left:bc}}if(bw.top>0){ctx.strokeStyle=bc.top;ctx.lineWidth=bw.top;ctx.beginPath();ctx.moveTo(0-bw.left,0-bw.top/2);ctx.lineTo(plotWidth,0-bw.top/2);ctx.stroke()}if(bw.right>0){ctx.strokeStyle=bc.right;ctx.lineWidth=bw.right;ctx.beginPath();ctx.moveTo(plotWidth+bw.right/2,0-bw.top);ctx.lineTo(plotWidth+bw.right/2,plotHeight);ctx.stroke()}if(bw.bottom>0){ctx.strokeStyle=bc.bottom;ctx.lineWidth=bw.bottom;ctx.beginPath();ctx.moveTo(plotWidth+bw.right,plotHeight+bw.bottom/2);ctx.lineTo(0,plotHeight+bw.bottom/2);ctx.stroke()}if(bw.left>0){ctx.strokeStyle=bc.left;ctx.lineWidth=bw.left;ctx.beginPath();ctx.moveTo(0-bw.left/2,plotHeight+bw.bottom);ctx.lineTo(0-bw.left/2,0);ctx.stroke()}}else{ctx.lineWidth=bw;ctx.strokeStyle=options.grid.borderColor;ctx.strokeRect(-bw/2,-bw/2,plotWidth+bw,plotHeight+bw)}}function drawGrid(){var axes,bw;ctx.save();ctx.translate(plotOffset.left,plotOffset.top);drawMarkings();axes=allAxes();bw=options.grid.borderWidth;for(var j=0;j<axes.length;++j){var axis=axes[j];if(!axis.show){continue}drawTickBar(axis);if(axis.showTicks===true){drawTickMarks(axis)}if(axis.gridLines===true){drawGridLines(axis,bw)}}if(bw){drawBorder()}ctx.restore()}function drawAxisLabels(){$.each(allAxes(),function(_,axis){var box=axis.box,legacyStyles=axis.direction+"Axis "+axis.direction+axis.n+"Axis",layer="flot-"+axis.direction+"-axis flot-"+axis.direction+axis.n+"-axis "+legacyStyles,font=axis.options.font||"flot-tick-label tickLabel",i,x,y,halign,valign,info,margin=3,nullBox={x:NaN,y:NaN,width:NaN,height:NaN},newLabelBox,labelBoxes=[],overlapping=function overlapping(x11,y11,x12,y12,x21,y21,x22,y22){return(x11<=x21&&x21<=x12||x21<=x11&&x11<=x22)&&(y11<=y21&&y21<=y12||y21<=y11&&y11<=y22)},overlapsOtherLabels=function overlapsOtherLabels(newLabelBox,previousLabelBoxes){return previousLabelBoxes.some(function(labelBox){return overlapping(newLabelBox.x,newLabelBox.y,newLabelBox.x+newLabelBox.width,newLabelBox.y+newLabelBox.height,labelBox.x,labelBox.y,labelBox.x+labelBox.width,labelBox.y+labelBox.height)})},drawAxisLabel=function drawAxisLabel(tick,labelBoxes){if(!tick||!tick.label||tick.v<axis.min||tick.v>axis.max){return nullBox}info=surface.getTextInfo(layer,tick.label,font);if(axis.direction==="x"){halign="center";x=plotOffset.left+axis.p2c(tick.v);if(axis.position==="bottom"){y=box.top+box.padding-axis.boxPosition.centerY}else{y=box.top+box.height-box.padding+axis.boxPosition.centerY;valign="bottom"}newLabelBox={x:x-info.width/2-margin,y:y-margin,width:info.width+2*margin,height:info.height+2*margin}}else{valign="middle";y=plotOffset.top+axis.p2c(tick.v);if(axis.position==="left"){x=box.left+box.width-box.padding-axis.boxPosition.centerX;halign="right"}else{x=box.left+box.padding+axis.boxPosition.centerX}newLabelBox={x:x-info.width/2-margin,y:y-margin,width:info.width+2*margin,height:info.height+2*margin}}if(overlapsOtherLabels(newLabelBox,labelBoxes)){return nullBox}surface.addText(layer,x,y,tick.label,font,null,null,halign,valign);return newLabelBox};surface.removeText(layer);executeHooks(hooks.drawAxis,[axis,surface]);if(!axis.show){return}switch(axis.options.showTickLabels){case"none":break;case"endpoints":labelBoxes.push(drawAxisLabel(axis.ticks[0],labelBoxes));labelBoxes.push(drawAxisLabel(axis.ticks[axis.ticks.length-1],labelBoxes));break;case"major":labelBoxes.push(drawAxisLabel(axis.ticks[0],labelBoxes));labelBoxes.push(drawAxisLabel(axis.ticks[axis.ticks.length-1],labelBoxes));for(i=1;i<axis.ticks.length-1;++i){labelBoxes.push(drawAxisLabel(axis.ticks[i],labelBoxes))}break;case"all":labelBoxes.push(drawAxisLabel(axis.ticks[0],[]));labelBoxes.push(drawAxisLabel(axis.ticks[axis.ticks.length-1],labelBoxes));for(i=1;i<axis.ticks.length-1;++i){labelBoxes.push(drawAxisLabel(axis.ticks[i],labelBoxes))}break}})}function drawSeries(series){if(series.lines.show){$.plot.drawSeries.drawSeriesLines(series,ctx,plotOffset,plotWidth,plotHeight,plot.drawSymbol,getColorOrGradient)}if(series.bars.show){$.plot.drawSeries.drawSeriesBars(series,ctx,plotOffset,plotWidth,plotHeight,plot.drawSymbol,getColorOrGradient)}if(series.points.show){$.plot.drawSeries.drawSeriesPoints(series,ctx,plotOffset,plotWidth,plotHeight,plot.drawSymbol,getColorOrGradient)}}function computeRangeForDataSeries(series,force,isValid){var points=series.datapoints.points,ps=series.datapoints.pointsize,format=series.datapoints.format,topSentry=Number.POSITIVE_INFINITY,bottomSentry=Number.NEGATIVE_INFINITY,range={xmin:topSentry,ymin:topSentry,xmax:bottomSentry,ymax:bottomSentry};for(var j=0;j<points.length;j+=ps){if(points[j]===null){continue}if(typeof isValid==="function"&&!isValid(points[j])){continue}for(var m=0;m<ps;++m){var val=points[j+m],f=format[m];if(f===null||f===undefined){continue}if(typeof isValid==="function"&&!isValid(val)){continue}if(!force&&!f.computeRange||val===Infinity||val===-Infinity){continue}if(f.x===true){if(val<range.xmin){range.xmin=val}if(val>range.xmax){range.xmax=val}}if(f.y===true){if(val<range.ymin){range.ymin=val}if(val>range.ymax){range.ymax=val}}}}return range}function adjustSeriesDataRange(series,range){if(series.bars.show){var delta;var useAbsoluteBarWidth=series.bars.barWidth[1];if(series.datapoints&&series.datapoints.points&&!useAbsoluteBarWidth){computeBarWidth(series)}var barWidth=series.bars.barWidth[0]||series.bars.barWidth;switch(series.bars.align){case"left":delta=0;break;case"right":delta=-barWidth;break;default:delta=-barWidth/2}if(series.bars.horizontal){range.ymin+=delta;range.ymax+=delta+barWidth}else{range.xmin+=delta;range.xmax+=delta+barWidth}}if(series.bars.show&&series.bars.zero||series.lines.show&&series.lines.zero){var ps=series.datapoints.pointsize;if(ps<=2){range.ymin=Math.min(0,range.ymin);range.ymax=Math.max(0,range.ymax)}}return range}function computeBarWidth(series){var xValues=[];var pointsize=series.datapoints.pointsize,minDistance=Number.MAX_VALUE;if(series.datapoints.points.length<=pointsize){minDistance=1}var start=series.bars.horizontal?1:0;for(var j=start;j<series.datapoints.points.length;j+=pointsize){if(isFinite(series.datapoints.points[j])&&series.datapoints.points[j]!==null){xValues.push(series.datapoints.points[j])}}function onlyUnique(value,index,self){return self.indexOf(value)===index}xValues=xValues.filter(onlyUnique);xValues.sort(function(a,b){return a-b});for(var _j=1;_j<xValues.length;_j++){var distance=Math.abs(xValues[_j]-xValues[_j-1]);if(distance<minDistance&&isFinite(distance)){minDistance=distance}}if(typeof series.bars.barWidth==="number"){series.bars.barWidth=series.bars.barWidth*minDistance}else{series.bars.barWidth[0]=series.bars.barWidth[0]*minDistance}}function findNearbyItems(mouseX,mouseY,seriesFilter,radius,computeDistance){var items=findItems(mouseX,mouseY,seriesFilter,radius,computeDistance);for(var i=0;i<series.length;++i){if(seriesFilter(i)){executeHooks(hooks.findNearbyItems,[mouseX,mouseY,series,i,radius,computeDistance,items])}}return items.sort(function(a,b){if(b.distance===undefined){return-1}else if(a.distance===undefined&&b.distance!==undefined){return 1}return a.distance-b.distance})}function findNearbyItem(mouseX,mouseY,seriesFilter,radius,computeDistance){var items=findNearbyItems(mouseX,mouseY,seriesFilter,radius,computeDistance);return items[0]!==undefined?items[0]:null}function findItems(mouseX,mouseY,seriesFilter,radius,computeDistance){var i,foundItems=[],items=[],smallestDistance=radius*radius+1;for(i=series.length-1;i>=0;--i){if(!seriesFilter(i))continue;var s=series[i];if(!s.datapoints)return;var foundPoint=false;if(s.lines.show||s.points.show){var found=findNearbyPoint(s,mouseX,mouseY,radius,computeDistance);if(found){items.push({seriesIndex:i,dataIndex:found.dataIndex,distance:found.distance});foundPoint=true}}if(s.bars.show&&!foundPoint){var foundIndex=findNearbyBar(s,mouseX,mouseY);if(foundIndex>=0){items.push({seriesIndex:i,dataIndex:foundIndex,distance:smallestDistance})}}}for(i=0;i<items.length;i++){var seriesIndex=items[i].seriesIndex;var dataIndex=items[i].dataIndex;var itemDistance=items[i].distance;var ps=series[seriesIndex].datapoints.pointsize;foundItems.push({datapoint:series[seriesIndex].datapoints.points.slice(dataIndex*ps,(dataIndex+1)*ps),dataIndex:dataIndex,series:series[seriesIndex],seriesIndex:seriesIndex,distance:Math.sqrt(itemDistance)})}return foundItems}function findNearbyPoint(series,mouseX,mouseY,maxDistance,computeDistance){var mx=series.xaxis.c2p(mouseX),my=series.yaxis.c2p(mouseY),maxx=maxDistance/series.xaxis.scale,maxy=maxDistance/series.yaxis.scale,points=series.datapoints.points,ps=series.datapoints.pointsize,smallestDistance=Number.POSITIVE_INFINITY;if(series.xaxis.options.inverseTransform){maxx=Number.MAX_VALUE}if(series.yaxis.options.inverseTransform){maxy=Number.MAX_VALUE}var found=null;for(var j=0;j<points.length;j+=ps){var x=points[j];var y=points[j+1];if(x==null){continue}if(x-mx>maxx||x-mx<-maxx||y-my>maxy||y-my<-maxy){continue}var dx=Math.abs(series.xaxis.p2c(x)-mouseX);var dy=Math.abs(series.yaxis.p2c(y)-mouseY);var dist=computeDistance?computeDistance(dx,dy):dx*dx+dy*dy;if(dist<smallestDistance){smallestDistance=dist;found={dataIndex:j/ps,distance:dist}}}return found}function findNearbyBar(series,mouseX,mouseY){var barLeft,barRight,barWidth=series.bars.barWidth[0]||series.bars.barWidth,mx=series.xaxis.c2p(mouseX),my=series.yaxis.c2p(mouseY),points=series.datapoints.points,ps=series.datapoints.pointsize;switch(series.bars.align){case"left":barLeft=0;break;case"right":barLeft=-barWidth;break;default:barLeft=-barWidth/2}barRight=barLeft+barWidth;var fillTowards=series.bars.fillTowards||0;var defaultBottom=fillTowards>series.yaxis.min?Math.min(series.yaxis.max,fillTowards):series.yaxis.min;var foundIndex=-1;for(var j=0;j<points.length;j+=ps){var x=points[j],y=points[j+1];if(x==null){continue}var bottom=ps===3?points[j+2]:defaultBottom;if(series.bars.horizontal?mx<=Math.max(bottom,x)&&mx>=Math.min(bottom,x)&&my>=y+barLeft&&my<=y+barRight:mx>=x+barLeft&&mx<=x+barRight&&my>=Math.min(bottom,y)&&my<=Math.max(bottom,y)){foundIndex=j/ps}}return foundIndex}function findNearbyInterpolationPoint(posX,posY,seriesFilter){var i,j,dist,dx,dy,ps,item,smallestDistance=Number.MAX_VALUE;for(i=0;i<series.length;++i){if(!seriesFilter(i)){continue}var points=series[i].datapoints.points;ps=series[i].datapoints.pointsize;var comparer=points[points.length-ps]<points[0]?function(x1,x2){return x1>x2}:function(x1,x2){return x2>x1};if(comparer(posX,points[0])){continue}for(j=ps;j<points.length;j+=ps){if(comparer(posX,points[j])){break}}var y,p1x=points[j-ps],p1y=points[j-ps+1],p2x=points[j],p2y=points[j+1];if(p1x===undefined||p2x===undefined||p1y===undefined||p2y===undefined){continue}if(p1x===p2x){y=p2y}else{y=p1y+(p2y-p1y)*(posX-p1x)/(p2x-p1x)}posY=y;dx=Math.abs(series[i].xaxis.p2c(p2x)-posX);dy=Math.abs(series[i].yaxis.p2c(p2y)-posY);dist=dx*dx+dy*dy;if(dist<smallestDistance){smallestDistance=dist;item=[posX,posY,i,j]}}if(item){i=item[2];j=item[3];ps=series[i].datapoints.pointsize;points=series[i].datapoints.points;p1x=points[j-ps];p1y=points[j-ps+1];p2x=points[j];p2y=points[j+1];return{datapoint:[item[0],item[1]],leftPoint:[p1x,p1y],rightPoint:[p2x,p2y],seriesIndex:i}}return null}function triggerRedrawOverlay(){var t=options.interaction.redrawOverlayInterval;if(t===-1){drawOverlay();return}if(!redrawTimeout){redrawTimeout=setTimeout(function(){drawOverlay(plot)},t)}}function drawOverlay(plot){redrawTimeout=null;if(!octx){return}overlay.clear();executeHooks(hooks.drawOverlay,[octx,overlay]);var event=new CustomEvent("onDrawingDone");plot.getEventHolder().dispatchEvent(event);plot.getPlaceholder().trigger("drawingdone")}function getColorOrGradient(spec,bottom,top,defaultColor){if(typeof spec==="string"){return spec}else{var gradient=ctx.createLinearGradient(0,top,0,bottom);for(var i=0,l=spec.colors.length;i<l;++i){var c=spec.colors[i];if(typeof c!=="string"){var co=$.color.parse(defaultColor);if(c.brightness!=null){co=co.scale("rgb",c.brightness)}if(c.opacity!=null){co.a*=c.opacity}c=co.toString()}gradient.addColorStop(i/(l-1),c)}return gradient}}}$.plot=function(placeholder,data,options){var plot=new Plot($(placeholder),data,options,$.plot.plugins);return plot};$.plot.version="3.0.0";$.plot.plugins=[];$.fn.plot=function(data,options){return this.each(function(){$.plot(this,data,options)})};$.plot.linearTickGenerator=defaultTickGenerator;$.plot.defaultTickFormatter=defaultTickFormatter;$.plot.expRepTickFormatter=expRepTickFormatter})(jQuery);"use strict";(function($){"use strict";var saturated={saturate:function saturate(a){if(a===Infinity){return Number.MAX_VALUE}if(a===-Infinity){return-Number.MAX_VALUE}return a},delta:function delta(min,max,noTicks){return(max-min)/noTicks===Infinity?max/noTicks-min/noTicks:(max-min)/noTicks},multiply:function multiply(a,b){return saturated.saturate(a*b)},multiplyAdd:function multiplyAdd(a,bInt,c){if(isFinite(a*bInt)){return saturated.saturate(a*bInt+c)}else{var result=c;for(var i=0;i<bInt;i++){result+=a}return saturated.saturate(result)}},floorInBase:function floorInBase(n,base){return base*Math.floor(n/base)}};$.plot.saturated=saturated})(jQuery);"use strict";(function($){"use strict";var browser={getPageXY:function getPageXY(e){var doc=document.documentElement,pageX=e.clientX+(window.pageXOffset||doc.scrollLeft)-(doc.clientLeft||0),pageY=e.clientY+(window.pageYOffset||doc.scrollTop)-(doc.clientTop||0);return{X:pageX,Y:pageY}},getPixelRatio:function getPixelRatio(context){var devicePixelRatio=window.devicePixelRatio||1,backingStoreRatio=context.webkitBackingStorePixelRatio||context.mozBackingStorePixelRatio||context.msBackingStorePixelRatio||context.oBackingStorePixelRatio||context.backingStorePixelRatio||1;return devicePixelRatio/backingStoreRatio},isSafari:function isSafari(){return/constructor/i.test(window.top.HTMLElement)||function(p){return p.toString()==="[object SafariRemoteNotification]"}(!window.top["safari"]||typeof window.top.safari!=="undefined"&&window.top.safari.pushNotification)},isMobileSafari:function isMobileSafari(){return navigator.userAgent.match(/(iPod|iPhone|iPad)/)&&navigator.userAgent.match(/AppleWebKit/)},isOpera:function isOpera(){return!!window.opr&&!!opr.addons||!!window.opera||navigator.userAgent.indexOf(" OPR/")>=0},isFirefox:function isFirefox(){return typeof InstallTrigger!=="undefined"},isIE:function isIE(){return false||!!document.documentMode},isEdge:function isEdge(){return!browser.isIE()&&!!window.StyleMedia},isChrome:function isChrome(){return!!window.chrome&&!!window.chrome.webstore},isBlink:function isBlink(){return(browser.isChrome()||browser.isOpera())&&!!window.CSS}};$.plot.browser=browser})(jQuery);"use strict";(function($){"use strict";function DrawSeries(){function plotLine(datapoints,xoffset,yoffset,axisx,axisy,ctx,steps){var points=datapoints.points,ps=datapoints.pointsize,prevx=null,prevy=null;var x1=0,y1=0,x2=0,y2=0,mx=null,my=null,i=0;ctx.beginPath();for(i=ps;i<points.length;i+=ps){x1=points[i-ps];y1=points[i-ps+1];x2=points[i];y2=points[i+1];if(x1===null||x2===null){mx=null;my=null;continue}if(isNaN(x1)||isNaN(x2)||isNaN(y1)||isNaN(y2)){prevx=null;prevy=null;continue}if(steps){if(mx!==null&&my!==null){x2=x1;y2=y1;x1=mx;y1=my;mx=null;my=null;i-=ps}else if(y1!==y2&&x1!==x2){y2=y1;mx=x2;my=y1}}if(y1<=y2&&y1<axisy.min){if(y2<axisy.min){continue}x1=(axisy.min-y1)/(y2-y1)*(x2-x1)+x1;y1=axisy.min}else if(y2<=y1&&y2<axisy.min){if(y1<axisy.min){continue}x2=(axisy.min-y1)/(y2-y1)*(x2-x1)+x1;y2=axisy.min}if(y1>=y2&&y1>axisy.max){if(y2>axisy.max){continue}x1=(axisy.max-y1)/(y2-y1)*(x2-x1)+x1;y1=axisy.max}else if(y2>=y1&&y2>axisy.max){if(y1>axisy.max){continue}x2=(axisy.max-y1)/(y2-y1)*(x2-x1)+x1;y2=axisy.max}if(x1<=x2&&x1<axisx.min){if(x2<axisx.min){continue}y1=(axisx.min-x1)/(x2-x1)*(y2-y1)+y1;x1=axisx.min}else if(x2<=x1&&x2<axisx.min){if(x1<axisx.min){continue}y2=(axisx.min-x1)/(x2-x1)*(y2-y1)+y1;x2=axisx.min}if(x1>=x2&&x1>axisx.max){if(x2>axisx.max){continue}y1=(axisx.max-x1)/(x2-x1)*(y2-y1)+y1;x1=axisx.max}else if(x2>=x1&&x2>axisx.max){if(x1>axisx.max){continue}y2=(axisx.max-x1)/(x2-x1)*(y2-y1)+y1;x2=axisx.max}if(x1!==prevx||y1!==prevy){ctx.moveTo(axisx.p2c(x1)+xoffset,axisy.p2c(y1)+yoffset)}prevx=x2;prevy=y2;ctx.lineTo(axisx.p2c(x2)+xoffset,axisy.p2c(y2)+yoffset)}ctx.stroke()}function plotLineArea(datapoints,axisx,axisy,fillTowards,ctx,steps){var points=datapoints.points,ps=datapoints.pointsize,bottom=fillTowards>axisy.min?Math.min(axisy.max,fillTowards):axisy.min,i=0,ypos=1,areaOpen=false,segmentStart=0,segmentEnd=0,mx=null,my=null;while(true){if(ps>0&&i>points.length+ps){break}i+=ps;var x1=points[i-ps],y1=points[i-ps+ypos],x2=points[i],y2=points[i+ypos];if(ps===-2){y1=y2=bottom}if(areaOpen){if(ps>0&&x1!=null&&x2==null){segmentEnd=i;ps=-ps;ypos=2;continue}if(ps<0&&i===segmentStart+ps){ctx.fill();areaOpen=false;ps=-ps;ypos=1;i=segmentStart=segmentEnd+ps;continue}}if(x1==null||x2==null){mx=null;my=null;continue}if(steps){if(mx!==null&&my!==null){x2=x1;y2=y1;x1=mx;y1=my;mx=null;my=null;i-=ps}else if(y1!==y2&&x1!==x2){y2=y1;mx=x2;my=y1}}if(x1<=x2&&x1<axisx.min){if(x2<axisx.min){continue}y1=(axisx.min-x1)/(x2-x1)*(y2-y1)+y1;x1=axisx.min}else if(x2<=x1&&x2<axisx.min){if(x1<axisx.min){continue}y2=(axisx.min-x1)/(x2-x1)*(y2-y1)+y1;x2=axisx.min}if(x1>=x2&&x1>axisx.max){if(x2>axisx.max){continue}y1=(axisx.max-x1)/(x2-x1)*(y2-y1)+y1;x1=axisx.max}else if(x2>=x1&&x2>axisx.max){if(x1>axisx.max){continue}y2=(axisx.max-x1)/(x2-x1)*(y2-y1)+y1;x2=axisx.max}if(!areaOpen){ctx.beginPath();ctx.moveTo(axisx.p2c(x1),axisy.p2c(bottom));areaOpen=true}if(y1>=axisy.max&&y2>=axisy.max){ctx.lineTo(axisx.p2c(x1),axisy.p2c(axisy.max));ctx.lineTo(axisx.p2c(x2),axisy.p2c(axisy.max));continue}else if(y1<=axisy.min&&y2<=axisy.min){ctx.lineTo(axisx.p2c(x1),axisy.p2c(axisy.min));ctx.lineTo(axisx.p2c(x2),axisy.p2c(axisy.min));continue}var x1old=x1,x2old=x2;if(y1<=y2&&y1<axisy.min&&y2>=axisy.min){x1=(axisy.min-y1)/(y2-y1)*(x2-x1)+x1;y1=axisy.min}else if(y2<=y1&&y2<axisy.min&&y1>=axisy.min){x2=(axisy.min-y1)/(y2-y1)*(x2-x1)+x1;y2=axisy.min}if(y1>=y2&&y1>axisy.max&&y2<=axisy.max){x1=(axisy.max-y1)/(y2-y1)*(x2-x1)+x1;y1=axisy.max}else if(y2>=y1&&y2>axisy.max&&y1<=axisy.max){x2=(axisy.max-y1)/(y2-y1)*(x2-x1)+x1;y2=axisy.max}if(x1!==x1old){ctx.lineTo(axisx.p2c(x1old),axisy.p2c(y1))}ctx.lineTo(axisx.p2c(x1),axisy.p2c(y1));ctx.lineTo(axisx.p2c(x2),axisy.p2c(y2));if(x2!==x2old){ctx.lineTo(axisx.p2c(x2),axisy.p2c(y2));ctx.lineTo(axisx.p2c(x2old),axisy.p2c(y2))}}}function drawSeriesLines(series,ctx,plotOffset,plotWidth,plotHeight,drawSymbol,getColorOrGradient){ctx.save();ctx.translate(plotOffset.left,plotOffset.top);ctx.lineJoin="round";if(series.lines.dashes&&ctx.setLineDash){ctx.setLineDash(series.lines.dashes)}var datapoints={format:series.datapoints.format,points:series.datapoints.points,pointsize:series.datapoints.pointsize};if(series.decimate){datapoints.points=series.decimate(series,series.xaxis.min,series.xaxis.max,plotWidth,series.yaxis.min,series.yaxis.max,plotHeight)}var lw=series.lines.lineWidth;ctx.lineWidth=lw;ctx.strokeStyle=series.color;var fillStyle=getFillStyle(series.lines,series.color,0,plotHeight,getColorOrGradient);if(fillStyle){ctx.fillStyle=fillStyle;plotLineArea(datapoints,series.xaxis,series.yaxis,series.lines.fillTowards||0,ctx,series.lines.steps)}if(lw>0){plotLine(datapoints,0,0,series.xaxis,series.yaxis,ctx,series.lines.steps)}ctx.restore()}function drawSeriesPoints(series,ctx,plotOffset,plotWidth,plotHeight,drawSymbol,getColorOrGradient){function drawCircle(ctx,x,y,radius,shadow,fill){ctx.moveTo(x+radius,y);ctx.arc(x,y,radius,0,shadow?Math.PI:Math.PI*2,false)}drawCircle.fill=true;function plotPoints(datapoints,radius,fill,offset,shadow,axisx,axisy,drawSymbolFn){var points=datapoints.points,ps=datapoints.pointsize;ctx.beginPath();for(var i=0;i<points.length;i+=ps){var x=points[i],y=points[i+1];if(x==null||x<axisx.min||x>axisx.max||y<axisy.min||y>axisy.max){continue}x=axisx.p2c(x);y=axisy.p2c(y)+offset;drawSymbolFn(ctx,x,y,radius,shadow,fill)}if(drawSymbolFn.fill&&!shadow){ctx.fill()}ctx.stroke()}ctx.save();ctx.translate(plotOffset.left,plotOffset.top);var datapoints={format:series.datapoints.format,points:series.datapoints.points,pointsize:series.datapoints.pointsize};if(series.decimatePoints){datapoints.points=series.decimatePoints(series,series.xaxis.min,series.xaxis.max,plotWidth,series.yaxis.min,series.yaxis.max,plotHeight)}var lw=series.points.lineWidth,radius=series.points.radius,symbol=series.points.symbol,drawSymbolFn;if(symbol==="circle"){drawSymbolFn=drawCircle}else if(typeof symbol==="string"&&drawSymbol&&drawSymbol[symbol]){drawSymbolFn=drawSymbol[symbol]}else if(typeof drawSymbol==="function"){drawSymbolFn=drawSymbol}if(lw===0){lw=1e-4}ctx.lineWidth=lw;ctx.fillStyle=getFillStyle(series.points,series.color,null,null,getColorOrGradient);ctx.strokeStyle=series.color;plotPoints(datapoints,radius,true,0,false,series.xaxis,series.yaxis,drawSymbolFn);ctx.restore()}function drawBar(x,y,b,barLeft,barRight,fillStyleCallback,axisx,axisy,c,horizontal,lineWidth){var left=x+barLeft,right=x+barRight,bottom=b,top=y,drawLeft,drawRight,drawTop,drawBottom=false,tmp;drawLeft=drawRight=drawTop=true;if(horizontal){drawBottom=drawRight=drawTop=true;drawLeft=false;left=b;right=x;top=y+barLeft;bottom=y+barRight;if(right<left){tmp=right;right=left;left=tmp;drawLeft=true;drawRight=false}}else{drawLeft=drawRight=drawTop=true;drawBottom=false;left=x+barLeft;right=x+barRight;bottom=b;top=y;if(top<bottom){tmp=top;top=bottom;bottom=tmp;drawBottom=true;drawTop=false}}if(right<axisx.min||left>axisx.max||top<axisy.min||bottom>axisy.max){return}if(left<axisx.min){left=axisx.min;drawLeft=false}if(right>axisx.max){right=axisx.max;drawRight=false}if(bottom<axisy.min){bottom=axisy.min;drawBottom=false}if(top>axisy.max){top=axisy.max;drawTop=false}left=axisx.p2c(left);bottom=axisy.p2c(bottom);right=axisx.p2c(right);top=axisy.p2c(top);if(fillStyleCallback){c.fillStyle=fillStyleCallback(bottom,top);c.fillRect(left,top,right-left,bottom-top)}if(lineWidth>0&&(drawLeft||drawRight||drawTop||drawBottom)){c.beginPath();c.moveTo(left,bottom);if(drawLeft){c.lineTo(left,top)}else{c.moveTo(left,top)}if(drawTop){c.lineTo(right,top)}else{c.moveTo(right,top)}if(drawRight){c.lineTo(right,bottom)}else{c.moveTo(right,bottom)}if(drawBottom){c.lineTo(left,bottom)}else{c.moveTo(left,bottom)}c.stroke()}}function drawSeriesBars(series,ctx,plotOffset,plotWidth,plotHeight,drawSymbol,getColorOrGradient){function plotBars(datapoints,barLeft,barRight,fillStyleCallback,axisx,axisy){var points=datapoints.points,ps=datapoints.pointsize,fillTowards=series.bars.fillTowards||0,defaultBottom=fillTowards>axisy.min?Math.min(axisy.max,fillTowards):axisy.min;for(var i=0;i<points.length;i+=ps){if(points[i]==null){continue}var bottom=ps===3?points[i+2]:defaultBottom;drawBar(points[i],points[i+1],bottom,barLeft,barRight,fillStyleCallback,axisx,axisy,ctx,series.bars.horizontal,series.bars.lineWidth)}}ctx.save();ctx.translate(plotOffset.left,plotOffset.top);var datapoints={format:series.datapoints.format,points:series.datapoints.points,pointsize:series.datapoints.pointsize};if(series.decimate){datapoints.points=series.decimate(series,series.xaxis.min,series.xaxis.max,plotWidth)}ctx.lineWidth=series.bars.lineWidth;ctx.strokeStyle=series.color;var barLeft;var barWidth=series.bars.barWidth[0]||series.bars.barWidth;switch(series.bars.align){case"left":barLeft=0;break;case"right":barLeft=-barWidth;break;default:barLeft=-barWidth/2}var fillStyleCallback=series.bars.fill?function(bottom,top){return getFillStyle(series.bars,series.color,bottom,top,getColorOrGradient)}:null;plotBars(datapoints,barLeft,barLeft+barWidth,fillStyleCallback,series.xaxis,series.yaxis);ctx.restore()}function getFillStyle(filloptions,seriesColor,bottom,top,getColorOrGradient){var fill=filloptions.fill;if(!fill){return null}if(filloptions.fillColor){return getColorOrGradient(filloptions.fillColor,bottom,top,seriesColor)}var c=$.color.parse(seriesColor);c.a=typeof fill==="number"?fill:.4;c.normalize();return c.toString()}this.drawSeriesLines=drawSeriesLines;this.drawSeriesPoints=drawSeriesPoints;this.drawSeriesBars=drawSeriesBars;this.drawBar=drawBar}$.plot.drawSeries=new DrawSeries})(jQuery);"use strict";(function($){var options={series:{points:{errorbars:null,xerr:{err:"x",show:null,asymmetric:null,upperCap:null,lowerCap:null,color:null,radius:null},yerr:{err:"y",show:null,asymmetric:null,upperCap:null,lowerCap:null,color:null,radius:null}}}};function processRawData(plot,series,data,datapoints){if(!series.points.errorbars){return}var format=[{x:true,number:true,required:true},{y:true,number:true,required:true}];var errors=series.points.errorbars;if(errors==="x"||errors==="xy"){if(series.points.xerr.asymmetric){format.push({x:true,number:true,required:true});format.push({x:true,number:true,required:true})}else{format.push({x:true,number:true,required:true})}}if(errors==="y"||errors==="xy"){if(series.points.yerr.asymmetric){format.push({y:true,number:true,required:true});format.push({y:true,number:true,required:true})}else{format.push({y:true,number:true,required:true})}}datapoints.format=format}function parseErrors(series,i){var points=series.datapoints.points;var exl=null,exu=null,eyl=null,eyu=null;var xerr=series.points.xerr,yerr=series.points.yerr;var eb=series.points.errorbars;if(eb==="x"||eb==="xy"){if(xerr.asymmetric){exl=points[i+2];exu=points[i+3];if(eb==="xy"){if(yerr.asymmetric){eyl=points[i+4];eyu=points[i+5]}else{eyl=points[i+4]}}}else{exl=points[i+2];if(eb==="xy"){if(yerr.asymmetric){eyl=points[i+3];eyu=points[i+4]}else{eyl=points[i+3]}}}}else{if(eb==="y"){if(yerr.asymmetric){eyl=points[i+2];eyu=points[i+3]}else{eyl=points[i+2]}}}if(exu==null)exu=exl;if(eyu==null)eyu=eyl;var errRanges=[exl,exu,eyl,eyu];if(!xerr.show){errRanges[0]=null;errRanges[1]=null}if(!yerr.show){errRanges[2]=null;errRanges[3]=null}return errRanges}function drawSeriesErrors(plot,ctx,s){var points=s.datapoints.points,ps=s.datapoints.pointsize,ax=[s.xaxis,s.yaxis],radius=s.points.radius,err=[s.points.xerr,s.points.yerr],tmp;var invertX=false;if(ax[0].p2c(ax[0].max)<ax[0].p2c(ax[0].min)){invertX=true;tmp=err[0].lowerCap;err[0].lowerCap=err[0].upperCap;err[0].upperCap=tmp}var invertY=false;if(ax[1].p2c(ax[1].min)<ax[1].p2c(ax[1].max)){invertY=true;tmp=err[1].lowerCap;err[1].lowerCap=err[1].upperCap;err[1].upperCap=tmp}for(var i=0;i<s.datapoints.points.length;i+=ps){var errRanges=parseErrors(s,i);for(var e=0;e<err.length;e++){var minmax=[ax[e].min,ax[e].max];if(errRanges[e*err.length]){var x=points[i],y=points[i+1];var upper=[x,y][e]+errRanges[e*err.length+1],lower=[x,y][e]-errRanges[e*err.length];if(err[e].err==="x"){if(y>ax[1].max||y<ax[1].min||upper<ax[0].min||lower>ax[0].max){continue}}if(err[e].err==="y"){if(x>ax[0].max||x<ax[0].min||upper<ax[1].min||lower>ax[1].max){continue}}var drawUpper=true,drawLower=true;if(upper>minmax[1]){drawUpper=false;upper=minmax[1]}if(lower<minmax[0]){drawLower=false;lower=minmax[0]}if(err[e].err==="x"&&invertX||err[e].err==="y"&&invertY){tmp=lower;lower=upper;upper=tmp;tmp=drawLower;drawLower=drawUpper;drawUpper=tmp;tmp=minmax[0];minmax[0]=minmax[1];minmax[1]=tmp}x=ax[0].p2c(x);y=ax[1].p2c(y);upper=ax[e].p2c(upper);lower=ax[e].p2c(lower);minmax[0]=ax[e].p2c(minmax[0]);minmax[1]=ax[e].p2c(minmax[1]);var lw=err[e].lineWidth?err[e].lineWidth:s.points.lineWidth,sw=s.points.shadowSize!=null?s.points.shadowSize:s.shadowSize;if(lw>0&&sw>0){var w=sw/2;ctx.lineWidth=w;ctx.strokeStyle="rgba(0,0,0,0.1)";drawError(ctx,err[e],x,y,upper,lower,drawUpper,drawLower,radius,w+w/2,minmax);ctx.strokeStyle="rgba(0,0,0,0.2)";drawError(ctx,err[e],x,y,upper,lower,drawUpper,drawLower,radius,w/2,minmax)}ctx.strokeStyle=err[e].color?err[e].color:s.color;ctx.lineWidth=lw;drawError(ctx,err[e],x,y,upper,lower,drawUpper,drawLower,radius,0,minmax)}}}}function drawError(ctx,err,x,y,upper,lower,drawUpper,drawLower,radius,offset,minmax){y+=offset;upper+=offset;lower+=offset;if(err.err==="x"){if(upper>x+radius)drawPath(ctx,[[upper,y],[Math.max(x+radius,minmax[0]),y]]);else drawUpper=false;if(lower<x-radius)drawPath(ctx,[[Math.min(x-radius,minmax[1]),y],[lower,y]]);else drawLower=false}else{if(upper<y-radius)drawPath(ctx,[[x,upper],[x,Math.min(y-radius,minmax[0])]]);else drawUpper=false;if(lower>y+radius)drawPath(ctx,[[x,Math.max(y+radius,minmax[1])],[x,lower]]);else drawLower=false}radius=err.radius!=null?err.radius:radius;if(drawUpper){if(err.upperCap==="-"){if(err.err==="x")drawPath(ctx,[[upper,y-radius],[upper,y+radius]]);else drawPath(ctx,[[x-radius,upper],[x+radius,upper]])}else if($.isFunction(err.upperCap)){if(err.err==="x")err.upperCap(ctx,upper,y,radius);else err.upperCap(ctx,x,upper,radius)}}if(drawLower){if(err.lowerCap==="-"){if(err.err==="x")drawPath(ctx,[[lower,y-radius],[lower,y+radius]]);else drawPath(ctx,[[x-radius,lower],[x+radius,lower]])}else if($.isFunction(err.lowerCap)){if(err.err==="x")err.lowerCap(ctx,lower,y,radius);else err.lowerCap(ctx,x,lower,radius)}}}function drawPath(ctx,pts){ctx.beginPath();ctx.moveTo(pts[0][0],pts[0][1]);for(var p=1;p<pts.length;p++){ctx.lineTo(pts[p][0],pts[p][1])}ctx.stroke()}function draw(plot,ctx){var plotOffset=plot.getPlotOffset();ctx.save();ctx.translate(plotOffset.left,plotOffset.top);$.each(plot.getData(),function(i,s){if(s.points.errorbars&&(s.points.xerr.show||s.points.yerr.show)){drawSeriesErrors(plot,ctx,s)}});ctx.restore()}function init(plot){plot.hooks.processRawData.push(processRawData);plot.hooks.draw.push(draw)}$.plot.plugins.push({init:init,options:options,name:"errorbars",version:"1.0"})})(jQuery);"use strict";(function($){"use strict";$.plot.uiConstants={SNAPPING_CONSTANT:20,PANHINT_LENGTH_CONSTANT:10,MINOR_TICKS_COUNT_CONSTANT:4,TICK_LENGTH_CONSTANT:10,ZOOM_DISTANCE_MARGIN:25}})(jQuery);"use strict";(function($){"use strict";var options={xaxis:{}};var PREFERRED_LOG_TICK_VALUES=computePreferedLogTickValues(Number.MAX_VALUE,10),EXTENDED_LOG_TICK_VALUES=computePreferedLogTickValues(Number.MAX_VALUE,4);function computePreferedLogTickValues(endLimit,rangeStep){var log10End=Math.floor(Math.log(endLimit)*Math.LOG10E)-1,log10Start=-log10End,val,range,vals=[];for(var power=log10Start;power<=log10End;power++){range=parseFloat("1e"+power);for(var mult=1;mult<9;mult+=rangeStep){val=range*mult;vals.push(val)}}return vals}var logTickGenerator=function logTickGenerator(plot,axis,noTicks){var ticks=[],minIdx=-1,maxIdx=-1,surface=plot.getCanvas(),logTickValues=PREFERRED_LOG_TICK_VALUES,min=clampAxis(axis,plot),max=axis.max;if(!noTicks){noTicks=.3*Math.sqrt(axis.direction==="x"?surface.width:surface.height)}PREFERRED_LOG_TICK_VALUES.some(function(val,i){if(val>=min){minIdx=i;return true}else{return false}});PREFERRED_LOG_TICK_VALUES.some(function(val,i){if(val>=max){maxIdx=i;return true}else{return false}});if(maxIdx===-1){maxIdx=PREFERRED_LOG_TICK_VALUES.length-1}if(maxIdx-minIdx<=noTicks/4&&logTickValues.length!==EXTENDED_LOG_TICK_VALUES.length){logTickValues=EXTENDED_LOG_TICK_VALUES;minIdx*=2;maxIdx*=2}var lastDisplayed=null,inverseNoTicks=1/noTicks,tickValue,pixelCoord,tick;if(maxIdx-minIdx>=noTicks/4){for(var idx=maxIdx;idx>=minIdx;idx--){tickValue=logTickValues[idx];pixelCoord=(Math.log(tickValue)-Math.log(min))/(Math.log(max)-Math.log(min));tick=tickValue;if(lastDisplayed===null){lastDisplayed={pixelCoord:pixelCoord,idealPixelCoord:pixelCoord}}else{if(Math.abs(pixelCoord-lastDisplayed.pixelCoord)>=inverseNoTicks){lastDisplayed={pixelCoord:pixelCoord,idealPixelCoord:lastDisplayed.idealPixelCoord-inverseNoTicks}}else{tick=null}}if(tick){ticks.push(tick)}}ticks.reverse()}else{var tickSize=plot.computeTickSize(min,max,noTicks),customAxis={min:min,max:max,tickSize:tickSize};ticks=$.plot.linearTickGenerator(customAxis)}return ticks};var clampAxis=function clampAxis(axis,plot){var min=axis.min,max=axis.max;if(min<=0){if(axis.datamin===null){min=axis.min=.1}else{min=processAxisOffset(plot,axis)}if(max<min){axis.max=axis.datamax!==null?axis.datamax:axis.options.max;axis.options.offset.below=0;axis.options.offset.above=0}}return min};var logTickFormatter=function logTickFormatter(value,axis,precision){var tenExponent=value>0?Math.floor(Math.log(value)/Math.LN10):0;if(precision){if(tenExponent>=-4&&tenExponent<=7){return $.plot.defaultTickFormatter(value,axis,precision)}else{return $.plot.expRepTickFormatter(value,axis,precision)}}if(tenExponent>=-4&&tenExponent<=7){var formattedValue=tenExponent<0?value.toFixed(-tenExponent):value.toFixed(tenExponent+2);if(formattedValue.indexOf(".")!==-1){var lastZero=formattedValue.lastIndexOf("0");while(lastZero===formattedValue.length-1){formattedValue=formattedValue.slice(0,-1);lastZero=formattedValue.lastIndexOf("0")}if(formattedValue.indexOf(".")===formattedValue.length-1){formattedValue=formattedValue.slice(0,-1)}}return formattedValue}else{return $.plot.expRepTickFormatter(value,axis)}};var logTransform=function logTransform(v){if(v<PREFERRED_LOG_TICK_VALUES[0]){v=PREFERRED_LOG_TICK_VALUES[0]}return Math.log(v)};var logInverseTransform=function logInverseTransform(v){return Math.exp(v)};var invertedTransform=function invertedTransform(v){return-v};var invertedLogTransform=function invertedLogTransform(v){return-logTransform(v)};var invertedLogInverseTransform=function invertedLogInverseTransform(v){return logInverseTransform(-v)};function setDataminRange(plot,axis){if(axis.options.mode==="log"&&axis.datamin<=0){if(axis.datamin===null){axis.datamin=.1}else{axis.datamin=processAxisOffset(plot,axis)}}}function processAxisOffset(plot,axis){var series=plot.getData(),range=series.filter(function(series){return series.xaxis===axis||series.yaxis===axis}).map(function(series){return plot.computeRangeForDataSeries(series,null,isValid)}),min=axis.direction==="x"?Math.min(.1,range&&range[0]?range[0].xmin:.1):Math.min(.1,range&&range[0]?range[0].ymin:.1);axis.min=min;return min}function isValid(a){return a>0}function init(plot){plot.hooks.processOptions.push(function(plot){$.each(plot.getAxes(),function(axisName,axis){var opts=axis.options;if(opts.mode==="log"){axis.tickGenerator=function(axis){var noTicks=11;return logTickGenerator(plot,axis,noTicks)};if(typeof axis.options.tickFormatter!=="function"){axis.options.tickFormatter=logTickFormatter}axis.options.transform=opts.inverted?invertedLogTransform:logTransform;axis.options.inverseTransform=opts.inverted?invertedLogInverseTransform:logInverseTransform;axis.options.autoScaleMargin=0;plot.hooks.setRange.push(setDataminRange)}else if(opts.inverted){axis.options.transform=invertedTransform;axis.options.inverseTransform=invertedTransform}})})}$.plot.plugins.push({init:init,options:options,name:"log",version:"0.1"});$.plot.logTicksGenerator=logTickGenerator;$.plot.logTickFormatter=logTickFormatter})(jQuery);"use strict";(function($){var square=function square(ctx,x,y,radius,shadow){var size=radius*Math.sqrt(Math.PI)/2;ctx.rect(x-size,y-size,size+size,size+size)},rectangle=function rectangle(ctx,x,y,radius,shadow){var size=radius*Math.sqrt(Math.PI)/2;ctx.rect(x-size,y-size,size+size,size+size)},diamond=function diamond(ctx,x,y,radius,shadow){var size=radius*Math.sqrt(Math.PI/2);ctx.moveTo(x-size,y);ctx.lineTo(x,y-size);ctx.lineTo(x+size,y);ctx.lineTo(x,y+size);ctx.lineTo(x-size,y);ctx.lineTo(x,y-size)},triangle=function triangle(ctx,x,y,radius,shadow){var size=radius*Math.sqrt(2*Math.PI/Math.sin(Math.PI/3));var height=size*Math.sin(Math.PI/3);ctx.moveTo(x-size/2,y+height/2);ctx.lineTo(x+size/2,y+height/2);if(!shadow){ctx.lineTo(x,y-height/2);ctx.lineTo(x-size/2,y+height/2);ctx.lineTo(x+size/2,y+height/2)}},cross=function cross(ctx,x,y,radius,shadow){var size=radius*Math.sqrt(Math.PI)/2;ctx.moveTo(x-size,y-size);ctx.lineTo(x+size,y+size);ctx.moveTo(x-size,y+size);ctx.lineTo(x+size,y-size)},ellipse=function ellipse(ctx,x,y,radius,shadow,fill){if(!shadow){ctx.moveTo(x+radius,y);ctx.arc(x,y,radius,0,Math.PI*2,false)}},plus=function plus(ctx,x,y,radius,shadow){var size=radius*Math.sqrt(Math.PI/2);ctx.moveTo(x-size,y);ctx.lineTo(x+size,y);ctx.moveTo(x,y+size);ctx.lineTo(x,y-size)},handlers={square:square,rectangle:rectangle,diamond:diamond,triangle:triangle,cross:cross,ellipse:ellipse,plus:plus};square.fill=true;rectangle.fill=true;diamond.fill=true;triangle.fill=true;ellipse.fill=true;function init(plot){plot.drawSymbol=handlers}$.plot.plugins.push({init:init,name:"symbols",version:"1.0"})})(jQuery);"use strict";(function($){"use strict";function process1DRawData(plot,series,data,datapoints){if(series.flatdata===true){var start=series.start||0;var step=typeof series.step==="number"?series.step:1;datapoints.pointsize=2;for(var i=0,j=0;i<data.length;i++,j+=2){datapoints.points[j]=start+i*step;datapoints.points[j+1]=data[i]}if(datapoints.points!==undefined){datapoints.points.length=data.length*2}else{datapoints.points=[]}}}$.plot.plugins.push({init:function init(plot){plot.hooks.processRawData.push(process1DRawData)},name:"flatdata",version:"0.0.2"})})(jQuery);"use strict";(function($){"use strict";var options={zoom:{interactive:false,active:false,amount:1.5},pan:{interactive:false,active:false,cursor:"move",frameRate:60,mode:"smart"},recenter:{interactive:true},xaxis:{axisZoom:true,plotZoom:true,axisPan:true,plotPan:true,panRange:[undefined,undefined],zoomRange:[undefined,undefined]},yaxis:{axisZoom:true,plotZoom:true,axisPan:true,plotPan:true,panRange:[undefined,undefined],zoomRange:[undefined,undefined]}};var saturated=$.plot.saturated;var browser=$.plot.browser;var SNAPPING_CONSTANT=$.plot.uiConstants.SNAPPING_CONSTANT;var PANHINT_LENGTH_CONSTANT=$.plot.uiConstants.PANHINT_LENGTH_CONSTANT;function init(plot){plot.hooks.processOptions.push(initNevigation)}function initNevigation(plot,options){var panAxes=null;var canDrag=false;var useManualPan=options.pan.mode==="manual",smartPanLock=options.pan.mode==="smartLock",useSmartPan=smartPanLock||options.pan.mode==="smart";function onZoomClick(e,zoomOut,amount){var page=browser.getPageXY(e);var c=plot.offset();c.left=page.X-c.left;c.top=page.Y-c.top;var ec=plot.getPlaceholder().offset();ec.left=page.X-ec.left;ec.top=page.Y-ec.top;var axes=plot.getXAxes().concat(plot.getYAxes()).filter(function(axis){var box=axis.box;if(box!==undefined){return ec.left>box.left&&ec.left<box.left+box.width&&ec.top>box.top&&ec.top<box.top+box.height}});if(axes.length===0){axes=undefined}if(zoomOut){plot.zoomOut({center:c,axes:axes,amount:amount})}else{plot.zoom({center:c,axes:axes,amount:amount})}}var prevCursor="default",panHint=null,panTimeout=null,plotState,prevDragPosition={x:0,y:0},isPanAction=false;function onMouseWheel(e,delta){var maxAbsoluteDeltaOnMac=1,isMacScroll=Math.abs(e.originalEvent.deltaY)<=maxAbsoluteDeltaOnMac,defaultNonMacScrollAmount=null,macMagicRatio=50,amount=isMacScroll?1+Math.abs(e.originalEvent.deltaY)/macMagicRatio:defaultNonMacScrollAmount;if(isPanAction){onDragEnd(e)}if(plot.getOptions().zoom.active){e.preventDefault();onZoomClick(e,delta<0,amount);return false}}plot.navigationState=function(startPageX,startPageY){var axes=this.getAxes();var result={};Object.keys(axes).forEach(function(axisName){var axis=axes[axisName];result[axisName]={navigationOffset:{below:axis.options.offset.below||0,above:axis.options.offset.above||0},axisMin:axis.min,axisMax:axis.max,diagMode:false}});result.startPageX=startPageX||0;result.startPageY=startPageY||0;return result};function onMouseDown(e){canDrag=true}function onMouseUp(e){canDrag=false}function isLeftMouseButtonPressed(e){return e.button===0}function onDragStart(e){if(!canDrag||!isLeftMouseButtonPressed(e)){return false}isPanAction=true;var page=browser.getPageXY(e);var ec=plot.getPlaceholder().offset();ec.left=page.X-ec.left;ec.top=page.Y-ec.top;panAxes=plot.getXAxes().concat(plot.getYAxes()).filter(function(axis){var box=axis.box;if(box!==undefined){return ec.left>box.left&&ec.left<box.left+box.width&&ec.top>box.top&&ec.top<box.top+box.height}});if(panAxes.length===0){panAxes=undefined}var c=plot.getPlaceholder().css("cursor");if(c){prevCursor=c}plot.getPlaceholder().css("cursor",plot.getOptions().pan.cursor);if(useSmartPan){plotState=plot.navigationState(page.X,page.Y)}else if(useManualPan){prevDragPosition.x=page.X;prevDragPosition.y=page.Y}}function onDrag(e){if(!isPanAction){return}var page=browser.getPageXY(e);var frameRate=plot.getOptions().pan.frameRate;if(frameRate===-1){if(useSmartPan){plot.smartPan({x:plotState.startPageX-page.X,y:plotState.startPageY-page.Y},plotState,panAxes,false,smartPanLock)}else if(useManualPan){plot.pan({left:prevDragPosition.x-page.X,top:prevDragPosition.y-page.Y,axes:panAxes});prevDragPosition.x=page.X;prevDragPosition.y=page.Y}return}if(panTimeout||!frameRate)return;panTimeout=setTimeout(function(){if(useSmartPan){plot.smartPan({x:plotState.startPageX-page.X,y:plotState.startPageY-page.Y},plotState,panAxes,false,smartPanLock)}else if(useManualPan){plot.pan({left:prevDragPosition.x-page.X,top:prevDragPosition.y-page.Y,axes:panAxes});prevDragPosition.x=page.X;prevDragPosition.y=page.Y}panTimeout=null},1/frameRate*1e3)}function onDragEnd(e){if(!isPanAction){return}if(panTimeout){clearTimeout(panTimeout);panTimeout=null}isPanAction=false;var page=browser.getPageXY(e);plot.getPlaceholder().css("cursor",prevCursor);if(useSmartPan){plot.smartPan({x:plotState.startPageX-page.X,y:plotState.startPageY-page.Y},plotState,panAxes,false,smartPanLock);plot.smartPan.end()}else if(useManualPan){plot.pan({left:prevDragPosition.x-page.X,top:prevDragPosition.y-page.Y,axes:panAxes});prevDragPosition.x=0;prevDragPosition.y=0}}function onDblClick(e){plot.activate();var o=plot.getOptions();if(!o.recenter.interactive){return}var axes=plot.getTouchedAxis(e.clientX,e.clientY),event;plot.recenter({axes:axes[0]?axes:null});if(axes[0]){event=new $.Event("re-center",{detail:{axisTouched:axes[0]}})}else{event=new $.Event("re-center",{detail:e})}plot.getPlaceholder().trigger(event)}function onClick(e){plot.activate();if(isPanAction){onDragEnd(e)}return false}plot.activate=function(){var o=plot.getOptions();if(!o.pan.active||!o.zoom.active){o.pan.active=true;o.zoom.active=true;plot.getPlaceholder().trigger("plotactivated",[plot])}};function bindEvents(plot,eventHolder){var o=plot.getOptions();if(o.zoom.interactive){eventHolder.mousewheel(onMouseWheel)}if(o.pan.interactive){plot.addEventHandler("dragstart",onDragStart,eventHolder,0);plot.addEventHandler("drag",onDrag,eventHolder,0);plot.addEventHandler("dragend",onDragEnd,eventHolder,0);eventHolder.bind("mousedown",onMouseDown);eventHolder.bind("mouseup",onMouseUp)}eventHolder.dblclick(onDblClick);eventHolder.click(onClick)}plot.zoomOut=function(args){if(!args){args={}}if(!args.amount){args.amount=plot.getOptions().zoom.amount}args.amount=1/args.amount;plot.zoom(args)};plot.zoom=function(args){if(!args){args={}}var c=args.center,amount=args.amount||plot.getOptions().zoom.amount,w=plot.width(),h=plot.height(),axes=args.axes||plot.getAxes();if(!c){c={left:w/2,top:h/2}}var xf=c.left/w,yf=c.top/h,minmax={x:{min:c.left-xf*w/amount,max:c.left+(1-xf)*w/amount},y:{min:c.top-yf*h/amount,max:c.top+(1-yf)*h/amount}};for(var key in axes){if(!axes.hasOwnProperty(key)){continue}var axis=axes[key],opts=axis.options,min=minmax[axis.direction].min,max=minmax[axis.direction].max,navigationOffset=axis.options.offset;if(!opts.axisZoom&&args.axes||!args.axes&&!opts.plotZoom){continue}min=$.plot.saturated.saturate(axis.c2p(min));max=$.plot.saturated.saturate(axis.c2p(max));if(min>max){var tmp=min;min=max;max=tmp}if(opts.zoomRange){if(max-min<opts.zoomRange[0]){continue}if(max-min>opts.zoomRange[1]){continue}}var offsetBelow=$.plot.saturated.saturate(navigationOffset.below-(axis.min-min));var offsetAbove=$.plot.saturated.saturate(navigationOffset.above-(axis.max-max));opts.offset={below:offsetBelow,above:offsetAbove}}plot.setupGrid(true);plot.draw();if(!args.preventEvent){plot.getPlaceholder().trigger("plotzoom",[plot,args])}};plot.pan=function(args){var delta={x:+args.left,y:+args.top};if(isNaN(delta.x))delta.x=0;if(isNaN(delta.y))delta.y=0;$.each(args.axes||plot.getAxes(),function(_,axis){var opts=axis.options,d=delta[axis.direction];if(!opts.axisPan&&args.axes||!opts.plotPan&&!args.axes){return}var minD=axis.p2c(opts.panRange[0])-axis.p2c(axis.min);var maxD=axis.p2c(opts.panRange[1])-axis.p2c(axis.max);if(opts.panRange[0]!==undefined&&d>=maxD)d=maxD;if(opts.panRange[1]!==undefined&&d<=minD)d=minD;if(d!==0){var navigationOffsetBelow=saturated.saturate(axis.c2p(axis.p2c(axis.min)+d)-axis.c2p(axis.p2c(axis.min))),navigationOffsetAbove=saturated.saturate(axis.c2p(axis.p2c(axis.max)+d)-axis.c2p(axis.p2c(axis.max)));if(!isFinite(navigationOffsetBelow)){navigationOffsetBelow=0}if(!isFinite(navigationOffsetAbove)){navigationOffsetAbove=0}opts.offset={below:saturated.saturate(navigationOffsetBelow+(opts.offset.below||0)),above:saturated.saturate(navigationOffsetAbove+(opts.offset.above||0))}}});plot.setupGrid(true);plot.draw();if(!args.preventEvent){plot.getPlaceholder().trigger("plotpan",[plot,args])}};plot.recenter=function(args){$.each(args.axes||plot.getAxes(),function(_,axis){if(args.axes){if(this.direction==="x"){axis.options.offset={below:0}}else if(this.direction==="y"){axis.options.offset={above:0}}}else{axis.options.offset={below:0,above:0}}});plot.setupGrid(true);plot.draw()};var shouldSnap=function shouldSnap(delta){return Math.abs(delta.y)<SNAPPING_CONSTANT&&Math.abs(delta.x)>=SNAPPING_CONSTANT||Math.abs(delta.x)<SNAPPING_CONSTANT&&Math.abs(delta.y)>=SNAPPING_CONSTANT};var adjustDeltaToSnap=function adjustDeltaToSnap(delta){if(Math.abs(delta.x)<SNAPPING_CONSTANT&&Math.abs(delta.y)>=SNAPPING_CONSTANT){return{x:0,y:delta.y}}if(Math.abs(delta.y)<SNAPPING_CONSTANT&&Math.abs(delta.x)>=SNAPPING_CONSTANT){return{x:delta.x,y:0}}return delta};var lockedDirection=null;var lockDeltaDirection=function lockDeltaDirection(delta){if(!lockedDirection&&Math.max(Math.abs(delta.x),Math.abs(delta.y))>=SNAPPING_CONSTANT){lockedDirection=Math.abs(delta.x)<Math.abs(delta.y)?"y":"x"}switch(lockedDirection){case"x":return{x:delta.x,y:0};case"y":return{x:0,y:delta.y};default:return{x:0,y:0}}};var isDiagonalMode=function isDiagonalMode(delta){if(Math.abs(delta.x)>0&&Math.abs(delta.y)>0){return true}return false};var restoreAxisOffset=function restoreAxisOffset(axes,initialState,delta){var axis;Object.keys(axes).forEach(function(axisName){axis=axes[axisName];if(delta[axis.direction]===0){axis.options.offset.below=initialState[axisName].navigationOffset.below;axis.options.offset.above=initialState[axisName].navigationOffset.above}})};var prevDelta={x:0,y:0};plot.smartPan=function(delta,initialState,panAxes,preventEvent,smartLock){var snap=smartLock?true:shouldSnap(delta),axes=plot.getAxes(),opts;delta=smartLock?lockDeltaDirection(delta):adjustDeltaToSnap(delta);if(isDiagonalMode(delta)){initialState.diagMode=true}if(snap&&initialState.diagMode===true){initialState.diagMode=false;restoreAxisOffset(axes,initialState,delta)}if(snap){panHint={start:{x:initialState.startPageX-plot.offset().left+plot.getPlotOffset().left,y:initialState.startPageY-plot.offset().top+plot.getPlotOffset().top},end:{x:initialState.startPageX-delta.x-plot.offset().left+plot.getPlotOffset().left,y:initialState.startPageY-delta.y-plot.offset().top+plot.getPlotOffset().top}}}else{panHint={start:{x:initialState.startPageX-plot.offset().left+plot.getPlotOffset().left,y:initialState.startPageY-plot.offset().top+plot.getPlotOffset().top},end:false}}if(isNaN(delta.x))delta.x=0;if(isNaN(delta.y))delta.y=0;if(panAxes){axes=panAxes}var axis,axisMin,axisMax,p,d;Object.keys(axes).forEach(function(axisName){axis=axes[axisName];axisMin=axis.min;axisMax=axis.max;opts=axis.options;d=delta[axis.direction];p=prevDelta[axis.direction];if(!opts.axisPan&&panAxes||!panAxes&&!opts.plotPan){return}var minD=p+axis.p2c(opts.panRange[0])-axis.p2c(axisMin);var maxD=p+axis.p2c(opts.panRange[1])-axis.p2c(axisMax);if(opts.panRange[0]!==undefined&&d>=maxD)d=maxD;if(opts.panRange[1]!==undefined&&d<=minD)d=minD;if(d!==0){var navigationOffsetBelow=saturated.saturate(axis.c2p(axis.p2c(axisMin)-(p-d))-axis.c2p(axis.p2c(axisMin))),navigationOffsetAbove=saturated.saturate(axis.c2p(axis.p2c(axisMax)-(p-d))-axis.c2p(axis.p2c(axisMax)));if(!isFinite(navigationOffsetBelow)){navigationOffsetBelow=0}if(!isFinite(navigationOffsetAbove)){navigationOffsetAbove=0}axis.options.offset.below=saturated.saturate(navigationOffsetBelow+(axis.options.offset.below||0));axis.options.offset.above=saturated.saturate(navigationOffsetAbove+(axis.options.offset.above||0))}});prevDelta=delta;plot.setupGrid(true);plot.draw();if(!preventEvent){plot.getPlaceholder().trigger("plotpan",[plot,delta,panAxes,initialState])}};plot.smartPan.end=function(){panHint=null;lockedDirection=null;prevDelta={x:0,y:0};plot.triggerRedrawOverlay()};function shutdown(plot,eventHolder){eventHolder.unbind("mousewheel",onMouseWheel);eventHolder.unbind("mousedown",onMouseDown);eventHolder.unbind("mouseup",onMouseUp);eventHolder.unbind("dragstart",onDragStart);eventHolder.unbind("drag",onDrag);eventHolder.unbind("dragend",onDragEnd);eventHolder.unbind("dblclick",onDblClick);eventHolder.unbind("click",onClick);if(panTimeout)clearTimeout(panTimeout)}function drawOverlay(plot,ctx){if(panHint){ctx.strokeStyle="rgba(96, 160, 208, 0.7)";ctx.lineWidth=2;ctx.lineJoin="round";var startx=Math.round(panHint.start.x),starty=Math.round(panHint.start.y),endx,endy;if(panAxes){if(panAxes[0].direction==="x"){endy=Math.round(panHint.start.y);endx=Math.round(panHint.end.x)}else if(panAxes[0].direction==="y"){endx=Math.round(panHint.start.x);endy=Math.round(panHint.end.y)}}else{endx=Math.round(panHint.end.x);endy=Math.round(panHint.end.y)}ctx.beginPath();if(panHint.end===false){ctx.moveTo(startx,starty-PANHINT_LENGTH_CONSTANT);ctx.lineTo(startx,starty+PANHINT_LENGTH_CONSTANT);ctx.moveTo(startx+PANHINT_LENGTH_CONSTANT,starty);ctx.lineTo(startx-PANHINT_LENGTH_CONSTANT,starty)}else{var dirX=starty===endy;ctx.moveTo(startx-(dirX?0:PANHINT_LENGTH_CONSTANT),starty-(dirX?PANHINT_LENGTH_CONSTANT:0));ctx.lineTo(startx+(dirX?0:PANHINT_LENGTH_CONSTANT),starty+(dirX?PANHINT_LENGTH_CONSTANT:0));ctx.moveTo(startx,starty);ctx.lineTo(endx,endy);ctx.moveTo(endx-(dirX?0:PANHINT_LENGTH_CONSTANT),endy-(dirX?PANHINT_LENGTH_CONSTANT:0));ctx.lineTo(endx+(dirX?0:PANHINT_LENGTH_CONSTANT),endy+(dirX?PANHINT_LENGTH_CONSTANT:0))}ctx.stroke()}}plot.getTouchedAxis=function(touchPointX,touchPointY){var ec=plot.getPlaceholder().offset();ec.left=touchPointX-ec.left;ec.top=touchPointY-ec.top;var axis=plot.getXAxes().concat(plot.getYAxes()).filter(function(axis){var box=axis.box;if(box!==undefined){return ec.left>box.left&&ec.left<box.left+box.width&&ec.top>box.top&&ec.top<box.top+box.height}});return axis};plot.hooks.drawOverlay.push(drawOverlay);plot.hooks.bindEvents.push(bindEvents);plot.hooks.shutdown.push(shutdown)}$.plot.plugins.push({init:init,options:options,name:"navigate",version:"1.3"})})(jQuery);"use strict";(function($){var options={series:{fillBetween:null}};function init(plot){function findBottomSeries(s,allseries){var i;for(i=0;i<allseries.length;++i){if(allseries[i].id===s.fillBetween){return allseries[i]}}if(typeof s.fillBetween==="number"){if(s.fillBetween<0||s.fillBetween>=allseries.length){return null}return allseries[s.fillBetween]}return null}function computeFormat(plot,s,data,datapoints){if(s.fillBetween==null){return}var format=datapoints.format;var plotHasId=function plotHasId(id){var plotData=plot.getData();for(var i=0;i<plotData.length;i++){if(plotData[i].id===id){return true}}return false};if(!format){format=[];format.push({x:true,number:true,computeRange:s.xaxis.options.autoScale!=="none",required:true});format.push({y:true,number:true,computeRange:s.yaxis.options.autoScale!=="none",required:true});if(s.fillBetween!==undefined&&s.fillBetween!==""&&plotHasId(s.fillBetween)&&s.fillBetween!==s.id){format.push({x:false,y:true,number:true,required:false,computeRange:s.yaxis.options.autoScale!=="none",defaultValue:0})}datapoints.format=format}}function computeFillBottoms(plot,s,datapoints){if(s.fillBetween==null){return}var other=findBottomSeries(s,plot.getData());if(!other){return}var ps=datapoints.pointsize,points=datapoints.points,otherps=other.datapoints.pointsize,otherpoints=other.datapoints.points,newpoints=[],px,py,intery,qx,qy,bottom,withlines=s.lines.show,withbottom=ps>2&&datapoints.format[2].y,withsteps=withlines&&s.lines.steps,fromgap=true,i=0,j=0,l,m;while(true){if(i>=points.length){break}l=newpoints.length;if(points[i]==null){for(m=0;m<ps;++m){newpoints.push(points[i+m])}i+=ps}else if(j>=otherpoints.length){if(!withlines){for(m=0;m<ps;++m){newpoints.push(points[i+m])}}i+=ps}else if(otherpoints[j]==null){for(m=0;m<ps;++m){newpoints.push(null)}fromgap=true;j+=otherps}else{px=points[i];py=points[i+1];qx=otherpoints[j];qy=otherpoints[j+1];bottom=0;if(px===qx){for(m=0;m<ps;++m){newpoints.push(points[i+m])}bottom=qy;i+=ps;j+=otherps}else if(px>qx){if(withlines&&i>0&&points[i-ps]!=null){intery=py+(points[i-ps+1]-py)*(qx-px)/(points[i-ps]-px);newpoints.push(qx);newpoints.push(intery);for(m=2;m<ps;++m){newpoints.push(points[i+m])}bottom=qy}j+=otherps}else{if(fromgap&&withlines){i+=ps;continue}for(m=0;m<ps;++m){newpoints.push(points[i+m])}if(withlines&&j>0&&otherpoints[j-otherps]!=null){bottom=qy+(otherpoints[j-otherps+1]-qy)*(px-qx)/(otherpoints[j-otherps]-qx)}i+=ps}fromgap=false;if(l!==newpoints.length&&withbottom){newpoints[l+2]=bottom}}if(withsteps&&l!==newpoints.length&&l>0&&newpoints[l]!==null&&newpoints[l]!==newpoints[l-ps]&&newpoints[l+1]!==newpoints[l-ps+1]){for(m=0;m<ps;++m){newpoints[l+ps+m]=newpoints[l+m]}newpoints[l+1]=newpoints[l-ps+1]}}datapoints.points=newpoints}plot.hooks.processRawData.push(computeFormat);plot.hooks.processDatapoints.push(computeFillBottoms)}$.plot.plugins.push({init:init,options:options,name:"fillbetween",version:"1.0"})})(jQuery);"use strict";(function($){var options={xaxis:{categories:null},yaxis:{categories:null}};function processRawData(plot,series,data,datapoints){var xCategories=series.xaxis.options.mode==="categories",yCategories=series.yaxis.options.mode==="categories";if(!(xCategories||yCategories)){return}var format=datapoints.format;if(!format){var s=series;format=[];format.push({x:true,number:true,required:true,computeRange:true});format.push({y:true,number:true,required:true,computeRange:true});if(s.bars.show||s.lines.show&&s.lines.fill){var autoScale=!!(s.bars.show&&s.bars.zero||s.lines.show&&s.lines.zero);format.push({y:true,number:true,required:false,defaultValue:0,computeRange:autoScale});if(s.bars.horizontal){delete format[format.length-1].y;format[format.length-1].x=true}}datapoints.format=format}for(var m=0;m<format.length;++m){if(format[m].x&&xCategories){format[m].number=false}if(format[m].y&&yCategories){format[m].number=false;format[m].computeRange=false}}}function getNextIndex(categories){var index=-1;for(var v in categories){if(categories[v]>index){index=categories[v]}}return index+1}function categoriesTickGenerator(axis){var res=[];for(var label in axis.categories){var v=axis.categories[label];if(v>=axis.min&&v<=axis.max){res.push([v,label])}}res.sort(function(a,b){return a[0]-b[0]});return res}function setupCategoriesForAxis(series,axis,datapoints){if(series[axis].options.mode!=="categories"){return}if(!series[axis].categories){var c={},o=series[axis].options.categories||{};if($.isArray(o)){for(var i=0;i<o.length;++i){c[o[i]]=i}}else{for(var v in o){c[v]=o[v]}}series[axis].categories=c}if(!series[axis].options.ticks){series[axis].options.ticks=categoriesTickGenerator}transformPointsOnAxis(datapoints,axis,series[axis].categories)}function transformPointsOnAxis(datapoints,axis,categories){var points=datapoints.points,ps=datapoints.pointsize,format=datapoints.format,formatColumn=axis.charAt(0),index=getNextIndex(categories);for(var i=0;i<points.length;i+=ps){if(points[i]==null){continue}for(var m=0;m<ps;++m){var val=points[i+m];if(val==null||!format[m][formatColumn]){continue}if(!(val in categories)){categories[val]=index;++index}points[i+m]=categories[val]}}}function processDatapoints(plot,series,datapoints){setupCategoriesForAxis(series,"xaxis",datapoints);setupCategoriesForAxis(series,"yaxis",datapoints)}function init(plot){plot.hooks.processRawData.push(processRawData);plot.hooks.processDatapoints.push(processDatapoints)}$.plot.plugins.push({init:init,options:options,name:"categories",version:"1.0"})})(jQuery);"use strict";(function($){var options={series:{stack:null}};function init(plot){function findMatchingSeries(s,allseries){var res=null;for(var i=0;i<allseries.length;++i){if(s===allseries[i])break;if(allseries[i].stack===s.stack){res=allseries[i]}}return res}function addBottomPoints(s,datapoints){var formattedPoints=[];for(var i=0;i<datapoints.points.length;i+=2){formattedPoints.push(datapoints.points[i]);formattedPoints.push(datapoints.points[i+1]);formattedPoints.push(0)}datapoints.format.push({x:false,y:true,number:true,required:false,computeRange:s.yaxis.options.autoScale!=="none",defaultValue:0});datapoints.points=formattedPoints;datapoints.pointsize=3}function stackData(plot,s,datapoints){if(s.stack==null||s.stack===false)return;var needsBottom=s.bars.show||s.lines.show&&s.lines.fill;var hasBottom=datapoints.pointsize>2&&(s.bars.horizontal?datapoints.format[2].x:datapoints.format[2].y);if(needsBottom&&!hasBottom){addBottomPoints(s,datapoints)}var other=findMatchingSeries(s,plot.getData());if(!other)return;var ps=datapoints.pointsize,points=datapoints.points,otherps=other.datapoints.pointsize,otherpoints=other.datapoints.points,newpoints=[],px,py,intery,qx,qy,bottom,withlines=s.lines.show,horizontal=s.bars.horizontal,withsteps=withlines&&s.lines.steps,fromgap=true,keyOffset=horizontal?1:0,accumulateOffset=horizontal?0:1,i=0,j=0,l,m;while(true){if(i>=points.length)break;l=newpoints.length;if(points[i]==null){for(m=0;m<ps;++m){newpoints.push(points[i+m])}i+=ps}else if(j>=otherpoints.length){if(!withlines){for(m=0;m<ps;++m){newpoints.push(points[i+m])}}i+=ps}else if(otherpoints[j]==null){for(m=0;m<ps;++m){newpoints.push(null)}fromgap=true;j+=otherps}else{px=points[i+keyOffset];py=points[i+accumulateOffset];qx=otherpoints[j+keyOffset];qy=otherpoints[j+accumulateOffset];bottom=0;if(px===qx){for(m=0;m<ps;++m){newpoints.push(points[i+m])}newpoints[l+accumulateOffset]+=qy;bottom=qy;i+=ps;j+=otherps}else if(px>qx){if(withlines&&i>0&&points[i-ps]!=null){intery=py+(points[i-ps+accumulateOffset]-py)*(qx-px)/(points[i-ps+keyOffset]-px);newpoints.push(qx);newpoints.push(intery+qy);for(m=2;m<ps;++m){newpoints.push(points[i+m])}bottom=qy}j+=otherps}else{if(fromgap&&withlines){i+=ps;continue}for(m=0;m<ps;++m){newpoints.push(points[i+m])}if(withlines&&j>0&&otherpoints[j-otherps]!=null){bottom=qy+(otherpoints[j-otherps+accumulateOffset]-qy)*(px-qx)/(otherpoints[j-otherps+keyOffset]-qx)}newpoints[l+accumulateOffset]+=bottom;i+=ps}fromgap=false;if(l!==newpoints.length&&needsBottom){newpoints[l+2]+=bottom}}if(withsteps&&l!==newpoints.length&&l>0&&newpoints[l]!==null&&newpoints[l]!==newpoints[l-ps]&&newpoints[l+1]!==newpoints[l-ps+1]){for(m=0;m<ps;++m){newpoints[l+ps+m]=newpoints[l+m]}newpoints[l+1]=newpoints[l-ps+1]}}datapoints.points=newpoints}plot.hooks.processDatapoints.push(stackData)}$.plot.plugins.push({init:init,options:options,name:"stack",version:"1.2"})})(jQuery);"use strict";(function($){"use strict";var options={zoom:{enableTouch:false},pan:{enableTouch:false,touchMode:"manual"},recenter:{enableTouch:true}};var ZOOM_DISTANCE_MARGIN=$.plot.uiConstants.ZOOM_DISTANCE_MARGIN;function init(plot){plot.hooks.processOptions.push(initTouchNavigation)}function initTouchNavigation(plot,options){var gestureState={zoomEnable:false,prevDistance:null,prevTapTime:0,prevPanPosition:{x:0,y:0},prevTapPosition:{x:0,y:0}},navigationState={prevTouchedAxis:"none",currentTouchedAxis:"none",touchedAxis:null,navigationConstraint:"unconstrained",initialState:null},useManualPan=options.pan.interactive&&options.pan.touchMode==="manual",smartPanLock=options.pan.touchMode==="smartLock",useSmartPan=options.pan.interactive&&(smartPanLock||options.pan.touchMode==="smart"),pan,pinch,doubleTap;function bindEvents(plot,eventHolder){var o=plot.getOptions();if(o.zoom.interactive&&o.zoom.enableTouch){eventHolder[0].addEventListener("pinchstart",pinch.start,false);eventHolder[0].addEventListener("pinchdrag",pinch.drag,false);eventHolder[0].addEventListener("pinchend",pinch.end,false)}if(o.pan.interactive&&o.pan.enableTouch){eventHolder[0].addEventListener("panstart",pan.start,false);eventHolder[0].addEventListener("pandrag",pan.drag,false);eventHolder[0].addEventListener("panend",pan.end,false)}if(o.recenter.interactive&&o.recenter.enableTouch){eventHolder[0].addEventListener("doubletap",doubleTap.recenterPlot,false)}}function shutdown(plot,eventHolder){eventHolder[0].removeEventListener("panstart",pan.start);eventHolder[0].removeEventListener("pandrag",pan.drag);eventHolder[0].removeEventListener("panend",pan.end);eventHolder[0].removeEventListener("pinchstart",pinch.start);eventHolder[0].removeEventListener("pinchdrag",pinch.drag);eventHolder[0].removeEventListener("pinchend",pinch.end);eventHolder[0].removeEventListener("doubletap",doubleTap.recenterPlot)}pan={start:function start(e){presetNavigationState(e,"pan",gestureState);updateData(e,"pan",gestureState,navigationState);if(useSmartPan){var point=getPoint(e,"pan");navigationState.initialState=plot.navigationState(point.x,point.y)}},drag:function drag(e){presetNavigationState(e,"pan",gestureState);if(useSmartPan){var point=getPoint(e,"pan");plot.smartPan({x:navigationState.initialState.startPageX-point.x,y:navigationState.initialState.startPageY-point.y},navigationState.initialState,navigationState.touchedAxis,false,smartPanLock)}else if(useManualPan){plot.pan({left:-delta(e,"pan",gestureState).x,top:-delta(e,"pan",gestureState).y,axes:navigationState.touchedAxis});updatePrevPanPosition(e,"pan",gestureState,navigationState)}},end:function end(e){presetNavigationState(e,"pan",gestureState);if(useSmartPan){plot.smartPan.end()}if(wasPinchEvent(e,gestureState)){updateprevPanPosition(e,"pan",gestureState,navigationState)}}};var pinchDragTimeout;pinch={start:function start(e){if(pinchDragTimeout){clearTimeout(pinchDragTimeout);pinchDragTimeout=null}presetNavigationState(e,"pinch",gestureState);setPrevDistance(e,gestureState);updateData(e,"pinch",gestureState,navigationState)},drag:function drag(e){if(pinchDragTimeout){return}pinchDragTimeout=setTimeout(function(){presetNavigationState(e,"pinch",gestureState);plot.pan({left:-delta(e,"pinch",gestureState).x,top:-delta(e,"pinch",gestureState).y,axes:navigationState.touchedAxis});updatePrevPanPosition(e,"pinch",gestureState,navigationState);var dist=pinchDistance(e);if(gestureState.zoomEnable||Math.abs(dist-gestureState.prevDistance)>ZOOM_DISTANCE_MARGIN){zoomPlot(plot,e,gestureState,navigationState);gestureState.zoomEnable=true}pinchDragTimeout=null},1e3/60)},end:function end(e){if(pinchDragTimeout){clearTimeout(pinchDragTimeout);pinchDragTimeout=null}presetNavigationState(e,"pinch",gestureState);gestureState.prevDistance=null}};doubleTap={recenterPlot:function recenterPlot(e){if(e&&e.detail&&e.detail.type==="touchstart"){recenterPlotOnDoubleTap(plot,e,gestureState,navigationState)}}};if(options.pan.enableTouch===true||options.zoom.enableTouch===true){plot.hooks.bindEvents.push(bindEvents);plot.hooks.shutdown.push(shutdown)}function presetNavigationState(e,gesture,gestureState){navigationState.touchedAxis=getAxis(plot,e,gesture,navigationState);if(noAxisTouched(navigationState)){navigationState.navigationConstraint="unconstrained"}else{navigationState.navigationConstraint="axisConstrained"}}}$.plot.plugins.push({init:init,options:options,name:"navigateTouch",version:"0.3"});function recenterPlotOnDoubleTap(plot,e,gestureState,navigationState){checkAxesForDoubleTap(plot,e,navigationState);if(navigationState.currentTouchedAxis==="x"&&navigationState.prevTouchedAxis==="x"||navigationState.currentTouchedAxis==="y"&&navigationState.prevTouchedAxis==="y"||navigationState.currentTouchedAxis==="none"&&navigationState.prevTouchedAxis==="none"){var event;plot.recenter({axes:navigationState.touchedAxis});if(navigationState.touchedAxis){event=new $.Event("re-center",{detail:{axisTouched:navigationState.touchedAxis}})}else{event=new $.Event("re-center",{detail:e})}plot.getPlaceholder().trigger(event)}}function checkAxesForDoubleTap(plot,e,navigationState){var axis=plot.getTouchedAxis(e.detail.firstTouch.x,e.detail.firstTouch.y);if(axis[0]!==undefined){navigationState.prevTouchedAxis=axis[0].direction}axis=plot.getTouchedAxis(e.detail.secondTouch.x,e.detail.secondTouch.y);if(axis[0]!==undefined){navigationState.touchedAxis=axis;navigationState.currentTouchedAxis=axis[0].direction}if(noAxisTouched(navigationState)){navigationState.touchedAxis=null;navigationState.prevTouchedAxis="none";navigationState.currentTouchedAxis="none"}}function zoomPlot(plot,e,gestureState,navigationState){var offset=plot.offset(),center={left:0,top:0},zoomAmount=pinchDistance(e)/gestureState.prevDistance,dist=pinchDistance(e);center.left=getPoint(e,"pinch").x-offset.left;center.top=getPoint(e,"pinch").y-offset.top;plot.zoom({center:center,amount:zoomAmount,axes:navigationState.touchedAxis});gestureState.prevDistance=dist}function wasPinchEvent(e,gestureState){return gestureState.zoomEnable&&e.detail.touches.length===1}function getAxis(plot,e,gesture,navigationState){if(e.type==="pinchstart"){var axisTouch1=plot.getTouchedAxis(e.detail.touches[0].pageX,e.detail.touches[0].pageY);var axisTouch2=plot.getTouchedAxis(e.detail.touches[1].pageX,e.detail.touches[1].pageY);if(axisTouch1.length===axisTouch2.length&&axisTouch1.toString()===axisTouch2.toString()){return axisTouch1}}else if(e.type==="panstart"){return plot.getTouchedAxis(e.detail.touches[0].pageX,e.detail.touches[0].pageY)}else if(e.type==="pinchend"){return plot.getTouchedAxis(e.detail.touches[0].pageX,e.detail.touches[0].pageY)}else{return navigationState.touchedAxis}}function noAxisTouched(navigationState){return!navigationState.touchedAxis||navigationState.touchedAxis.length===0}function setPrevDistance(e,gestureState){gestureState.prevDistance=pinchDistance(e)}function updateData(e,gesture,gestureState,navigationState){var axisDir,point=getPoint(e,gesture);switch(navigationState.navigationConstraint){case"unconstrained":navigationState.touchedAxis=null;gestureState.prevTapPosition={x:gestureState.prevPanPosition.x,y:gestureState.prevPanPosition.y};gestureState.prevPanPosition={x:point.x,y:point.y};break;case"axisConstrained":axisDir=navigationState.touchedAxis[0].direction;navigationState.currentTouchedAxis=axisDir;gestureState.prevTapPosition[axisDir]=gestureState.prevPanPosition[axisDir];gestureState.prevPanPosition[axisDir]=point[axisDir];break;default:break}}function distance(x1,y1,x2,y2){return Math.sqrt((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2))}function pinchDistance(e){var t1=e.detail.touches[0],t2=e.detail.touches[1];return distance(t1.pageX,t1.pageY,t2.pageX,t2.pageY)}function updatePrevPanPosition(e,gesture,gestureState,navigationState){var point=getPoint(e,gesture);switch(navigationState.navigationConstraint){case"unconstrained":gestureState.prevPanPosition.x=point.x;gestureState.prevPanPosition.y=point.y;break;case"axisConstrained":gestureState.prevPanPosition[navigationState.currentTouchedAxis]=point[navigationState.currentTouchedAxis];break;default:break}}function delta(e,gesture,gestureState){var point=getPoint(e,gesture);return{x:point.x-gestureState.prevPanPosition.x,y:point.y-gestureState.prevPanPosition.y}}function getPoint(e,gesture){if(gesture==="pinch"){return{x:(e.detail.touches[0].pageX+e.detail.touches[1].pageX)/2,y:(e.detail.touches[0].pageY+e.detail.touches[1].pageY)/2}}else{return{x:e.detail.touches[0].pageX,y:e.detail.touches[0].pageY}}}})(jQuery);"use strict";(function($){"use strict";var options={grid:{hoverable:false,clickable:false}};var browser=$.plot.browser;var eventType={click:"click",hover:"hover"};function init(plot){var lastMouseMoveEvent;var highlights=[];function bindEvents(plot,eventHolder){var o=plot.getOptions();if(o.grid.hoverable||o.grid.clickable){eventHolder[0].addEventListener("touchevent",triggerCleanupEvent,false);eventHolder[0].addEventListener("tap",generatePlothoverEvent,false)}if(o.grid.clickable){eventHolder.bind("click",onClick)}if(o.grid.hoverable){eventHolder.bind("mousemove",onMouseMove);eventHolder.bind("mouseleave",onMouseLeave)}}function shutdown(plot,eventHolder){eventHolder[0].removeEventListener("tap",generatePlothoverEvent);eventHolder[0].removeEventListener("touchevent",triggerCleanupEvent);eventHolder.unbind("mousemove",onMouseMove);eventHolder.unbind("mouseleave",onMouseLeave);eventHolder.unbind("click",onClick);highlights=[]}function generatePlothoverEvent(e){var o=plot.getOptions(),newEvent=new CustomEvent("mouseevent");newEvent.pageX=e.detail.changedTouches[0].pageX;newEvent.pageY=e.detail.changedTouches[0].pageY;newEvent.clientX=e.detail.changedTouches[0].clientX;newEvent.clientY=e.detail.changedTouches[0].clientY;if(o.grid.hoverable){doTriggerClickHoverEvent(newEvent,eventType.hover,30)}return false}function doTriggerClickHoverEvent(event,eventType,searchDistance){var series=plot.getData();if(event!==undefined&&series.length>0&&series[0].xaxis.c2p!==undefined&&series[0].yaxis.c2p!==undefined){var eventToTrigger="plot"+eventType;var seriesFlag=eventType+"able";triggerClickHoverEvent(eventToTrigger,event,function(i){return series[i][seriesFlag]!==false},searchDistance)}}function onMouseMove(e){lastMouseMoveEvent=e;plot.getPlaceholder()[0].lastMouseMoveEvent=e;doTriggerClickHoverEvent(e,eventType.hover)}function onMouseLeave(e){lastMouseMoveEvent=undefined;plot.getPlaceholder()[0].lastMouseMoveEvent=undefined;triggerClickHoverEvent("plothover",e,function(i){return false})}function onClick(e){doTriggerClickHoverEvent(e,eventType.click)}function triggerCleanupEvent(){plot.unhighlight();plot.getPlaceholder().trigger("plothovercleanup")}function triggerClickHoverEvent(eventname,event,seriesFilter,searchDistance){var options=plot.getOptions(),offset=plot.offset(),page=browser.getPageXY(event),canvasX=page.X-offset.left,canvasY=page.Y-offset.top,pos=plot.c2p({left:canvasX,top:canvasY}),distance=searchDistance!==undefined?searchDistance:options.grid.mouseActiveRadius;pos.pageX=page.X;pos.pageY=page.Y;var items=plot.findNearbyItems(canvasX,canvasY,seriesFilter,distance);var item=items[0];for(var i=1;i<items.length;++i){if(item.distance===undefined||items[i].distance<item.distance){item=items[i]}}if(item){item.pageX=parseInt(item.series.xaxis.p2c(item.datapoint[0])+offset.left,10);item.pageY=parseInt(item.series.yaxis.p2c(item.datapoint[1])+offset.top,10)}else{item=null}if(options.grid.autoHighlight){for(var _i=0;_i<highlights.length;++_i){var h=highlights[_i];if(h.auto===eventname&&!(item&&h.series===item.series&&h.point[0]===item.datapoint[0]&&h.point[1]===item.datapoint[1])||!item){unhighlight(h.series,h.point)}}if(item){highlight(item.series,item.datapoint,eventname)}}plot.getPlaceholder().trigger(eventname,[pos,item,items])}function highlight(s,point,auto){if(typeof s==="number"){s=plot.getData()[s]}if(typeof point==="number"){var ps=s.datapoints.pointsize;point=s.datapoints.points.slice(ps*point,ps*(point+1))}var i=indexOfHighlight(s,point);if(i===-1){highlights.push({series:s,point:point,auto:auto});plot.triggerRedrawOverlay()}else if(!auto){highlights[i].auto=false}}function unhighlight(s,point){if(s==null&&point==null){highlights=[];plot.triggerRedrawOverlay();return}if(typeof s==="number"){s=plot.getData()[s]}if(typeof point==="number"){var ps=s.datapoints.pointsize;point=s.datapoints.points.slice(ps*point,ps*(point+1))}var i=indexOfHighlight(s,point);if(i!==-1){highlights.splice(i,1);plot.triggerRedrawOverlay()}}function indexOfHighlight(s,p){for(var i=0;i<highlights.length;++i){var h=highlights[i];if(h.series===s&&h.point[0]===p[0]&&h.point[1]===p[1]){return i}}return-1}function processDatapoints(){triggerCleanupEvent();doTriggerClickHoverEvent(lastMouseMoveEvent,eventType.hover)}function setupGrid(){doTriggerClickHoverEvent(lastMouseMoveEvent,eventType.hover)}function drawOverlay(plot,octx,overlay){var plotOffset=plot.getPlotOffset(),i,hi;octx.save();octx.translate(plotOffset.left,plotOffset.top);for(i=0;i<highlights.length;++i){hi=highlights[i];if(hi.series.bars.show)drawBarHighlight(hi.series,hi.point,octx);else drawPointHighlight(hi.series,hi.point,octx,plot)}octx.restore()}function drawPointHighlight(series,point,octx,plot){var x=point[0],y=point[1],axisx=series.xaxis,axisy=series.yaxis,highlightColor=typeof series.highlightColor==="string"?series.highlightColor:$.color.parse(series.color).scale("a",.5).toString();if(x<axisx.min||x>axisx.max||y<axisy.min||y>axisy.max){return}var pointRadius=series.points.radius+series.points.lineWidth/2;octx.lineWidth=pointRadius;octx.strokeStyle=highlightColor;var radius=1.5*pointRadius;x=axisx.p2c(x);y=axisy.p2c(y);octx.beginPath();var symbol=series.points.symbol;if(symbol==="circle"){octx.arc(x,y,radius,0,2*Math.PI,false)}else if(typeof symbol==="string"&&plot.drawSymbol&&plot.drawSymbol[symbol]){plot.drawSymbol[symbol](octx,x,y,radius,false)}octx.closePath();octx.stroke()}function drawBarHighlight(series,point,octx){var highlightColor=typeof series.highlightColor==="string"?series.highlightColor:$.color.parse(series.color).scale("a",.5).toString(),fillStyle=highlightColor,barLeft;var barWidth=series.bars.barWidth[0]||series.bars.barWidth;switch(series.bars.align){case"left":barLeft=0;break;case"right":barLeft=-barWidth;break;default:barLeft=-barWidth/2}octx.lineWidth=series.bars.lineWidth;octx.strokeStyle=highlightColor;var fillTowards=series.bars.fillTowards||0,bottom=fillTowards>series.yaxis.min?Math.min(series.yaxis.max,fillTowards):series.yaxis.min;$.plot.drawSeries.drawBar(point[0],point[1],point[2]||bottom,barLeft,barLeft+barWidth,function(){return fillStyle},series.xaxis,series.yaxis,octx,series.bars.horizontal,series.bars.lineWidth)}function initHover(plot,options){plot.highlight=highlight;plot.unhighlight=unhighlight;if(options.grid.hoverable||options.grid.clickable){plot.hooks.drawOverlay.push(drawOverlay);plot.hooks.processDatapoints.push(processDatapoints);plot.hooks.setupGrid.push(setupGrid)}lastMouseMoveEvent=plot.getPlaceholder()[0].lastMouseMoveEvent}plot.hooks.bindEvents.push(bindEvents);plot.hooks.shutdown.push(shutdown);plot.hooks.processOptions.push(initHover)}$.plot.plugins.push({init:init,options:options,name:"hover",version:"0.1"})})(jQuery);"use strict";(function($){"use strict";var options={propagateSupportedGesture:false};function init(plot){plot.hooks.processOptions.push(initTouchNavigation)}function initTouchNavigation(plot,options){var gestureState={twoTouches:false,currentTapStart:{x:0,y:0},currentTapEnd:{x:0,y:0},prevTap:{x:0,y:0},currentTap:{x:0,y:0},interceptedLongTap:false,isUnsupportedGesture:false,prevTapTime:null,tapStartTime:null,longTapTriggerId:null},maxDistanceBetweenTaps=20,maxIntervalBetweenTaps=500,maxLongTapDistance=20,minLongTapDuration=1500,pressedTapDuration=125,mainEventHolder;function interpretGestures(e){var o=plot.getOptions();if(!o.pan.active&&!o.zoom.active){return}updateOnMultipleTouches(e);mainEventHolder.dispatchEvent(new CustomEvent("touchevent",{detail:e}));if(isPinchEvent(e)){executeAction(e,"pinch")}else{executeAction(e,"pan");if(!wasPinchEvent(e)){if(isDoubleTap(e)){executeAction(e,"doubleTap")}executeAction(e,"tap");executeAction(e,"longTap")}}}function executeAction(e,gesture){switch(gesture){case"pan":pan[e.type](e);break;case"pinch":pinch[e.type](e);break;case"doubleTap":doubleTap.onDoubleTap(e);break;case"longTap":longTap[e.type](e);break;case"tap":tap[e.type](e);break}}function bindEvents(plot,eventHolder){mainEventHolder=eventHolder[0];eventHolder[0].addEventListener("touchstart",interpretGestures,false);eventHolder[0].addEventListener("touchmove",interpretGestures,false);eventHolder[0].addEventListener("touchend",interpretGestures,false)}function shutdown(plot,eventHolder){eventHolder[0].removeEventListener("touchstart",interpretGestures);eventHolder[0].removeEventListener("touchmove",interpretGestures);eventHolder[0].removeEventListener("touchend",interpretGestures);if(gestureState.longTapTriggerId){clearTimeout(gestureState.longTapTriggerId);gestureState.longTapTriggerId=null}}var pan={touchstart:function touchstart(e){updatePrevForDoubleTap();updateCurrentForDoubleTap(e);updateStateForLongTapStart(e);mainEventHolder.dispatchEvent(new CustomEvent("panstart",{detail:e}))},touchmove:function touchmove(e){preventEventBehaviors(e);updateCurrentForDoubleTap(e);updateStateForLongTapEnd(e);if(!gestureState.isUnsupportedGesture){mainEventHolder.dispatchEvent(new CustomEvent("pandrag",{detail:e}))}},touchend:function touchend(e){preventEventBehaviors(e);if(wasPinchEvent(e)){mainEventHolder.dispatchEvent(new CustomEvent("pinchend",{detail:e}));mainEventHolder.dispatchEvent(new CustomEvent("panstart",{detail:e}))}else if(noTouchActive(e)){mainEventHolder.dispatchEvent(new CustomEvent("panend",{detail:e}))}}};var pinch={touchstart:function touchstart(e){mainEventHolder.dispatchEvent(new CustomEvent("pinchstart",{detail:e}))},touchmove:function touchmove(e){preventEventBehaviors(e);gestureState.twoTouches=isPinchEvent(e);if(!gestureState.isUnsupportedGesture){mainEventHolder.dispatchEvent(new CustomEvent("pinchdrag",{detail:e}))}},touchend:function touchend(e){preventEventBehaviors(e)}};var doubleTap={onDoubleTap:function onDoubleTap(e){preventEventBehaviors(e);mainEventHolder.dispatchEvent(new CustomEvent("doubletap",{detail:e}))}};var longTap={touchstart:function touchstart(e){longTap.waitForLongTap(e)},touchmove:function touchmove(e){},touchend:function touchend(e){if(gestureState.longTapTriggerId){clearTimeout(gestureState.longTapTriggerId);gestureState.longTapTriggerId=null}},isLongTap:function isLongTap(e){var currentTime=(new Date).getTime(),tapDuration=currentTime-gestureState.tapStartTime;if(tapDuration>=minLongTapDuration&&!gestureState.interceptedLongTap){if(distance(gestureState.currentTapStart.x,gestureState.currentTapStart.y,gestureState.currentTapEnd.x,gestureState.currentTapEnd.y)<maxLongTapDistance){gestureState.interceptedLongTap=true;return true}}return false},waitForLongTap:function waitForLongTap(e){var longTapTrigger=function longTapTrigger(){if(longTap.isLongTap(e)){mainEventHolder.dispatchEvent(new CustomEvent("longtap",{detail:e}))}gestureState.longTapTriggerId=null};if(!gestureState.longTapTriggerId){gestureState.longTapTriggerId=setTimeout(longTapTrigger,minLongTapDuration)}}};var tap={touchstart:function touchstart(e){gestureState.tapStartTime=(new Date).getTime()},touchmove:function touchmove(e){},touchend:function touchend(e){if(tap.isTap(e)){mainEventHolder.dispatchEvent(new CustomEvent("tap",{detail:e}));preventEventBehaviors(e)}},isTap:function isTap(e){var currentTime=(new Date).getTime(),tapDuration=currentTime-gestureState.tapStartTime;if(tapDuration<=pressedTapDuration){if(distance(gestureState.currentTapStart.x,gestureState.currentTapStart.y,gestureState.currentTapEnd.x,gestureState.currentTapEnd.y)<maxLongTapDistance){return true}}return false}};if(options.pan.enableTouch===true||options.zoom.enableTouch){plot.hooks.bindEvents.push(bindEvents);plot.hooks.shutdown.push(shutdown)}function updatePrevForDoubleTap(){gestureState.prevTap={x:gestureState.currentTap.x,y:gestureState.currentTap.y}}function updateCurrentForDoubleTap(e){gestureState.currentTap={x:e.touches[0].pageX,y:e.touches[0].pageY}}function updateStateForLongTapStart(e){gestureState.tapStartTime=(new Date).getTime();gestureState.interceptedLongTap=false;gestureState.currentTapStart={x:e.touches[0].pageX,y:e.touches[0].pageY};gestureState.currentTapEnd={x:e.touches[0].pageX,y:e.touches[0].pageY}}function updateStateForLongTapEnd(e){gestureState.currentTapEnd={x:e.touches[0].pageX,y:e.touches[0].pageY}}function isDoubleTap(e){var currentTime=(new Date).getTime(),intervalBetweenTaps=currentTime-gestureState.prevTapTime;if(intervalBetweenTaps>=0&&intervalBetweenTaps<maxIntervalBetweenTaps){if(distance(gestureState.prevTap.x,gestureState.prevTap.y,gestureState.currentTap.x,gestureState.currentTap.y)<maxDistanceBetweenTaps){e.firstTouch=gestureState.prevTap;e.secondTouch=gestureState.currentTap;return true}}gestureState.prevTapTime=currentTime;return false}function preventEventBehaviors(e){if(!gestureState.isUnsupportedGesture){e.preventDefault();if(!plot.getOptions().propagateSupportedGesture){e.stopPropagation()}}}function distance(x1,y1,x2,y2){return Math.sqrt((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2))}function noTouchActive(e){return e.touches&&e.touches.length===0}function wasPinchEvent(e){return gestureState.twoTouches&&e.touches.length===1}function updateOnMultipleTouches(e){if(e.touches.length>=3){gestureState.isUnsupportedGesture=true}else{gestureState.isUnsupportedGesture=false}}function isPinchEvent(e){if(e.touches&&e.touches.length>=2){if(e.touches[0].target===plot.getEventHolder()&&e.touches[1].target===plot.getEventHolder()){return true}}return false}}$.plot.plugins.push({init:init,options:options,name:"navigateTouch",version:"0.3"})})(jQuery);"use strict";(function($){"use strict";var options={xaxis:{timezone:null,timeformat:null,twelveHourClock:false,monthNames:null,timeBase:"seconds"},yaxis:{timeBase:"seconds"}};var floorInBase=$.plot.saturated.floorInBase;var CreateMicroSecondDate=function CreateMicroSecondDate(DateType,microEpoch){var newDate=new DateType(microEpoch);var oldSetTime=newDate.setTime.bind(newDate);newDate.update=function(microEpoch){oldSetTime(microEpoch);microEpoch=Math.round(microEpoch*1e3)/1e3;this.microseconds=1e3*(microEpoch-Math.floor(microEpoch))};var oldGetTime=newDate.getTime.bind(newDate);newDate.getTime=function(){var microEpoch=oldGetTime()+this.microseconds/1e3;return microEpoch};newDate.setTime=function(microEpoch){this.update(microEpoch)};newDate.getMicroseconds=function(){return this.microseconds};newDate.setMicroseconds=function(microseconds){var epochWithoutMicroseconds=oldGetTime();var newEpoch=epochWithoutMicroseconds+microseconds/1e3;this.update(newEpoch)};newDate.setUTCMicroseconds=function(microseconds){this.setMicroseconds(microseconds)};newDate.getUTCMicroseconds=function(){return this.getMicroseconds()};newDate.microseconds=null;newDate.microEpoch=null;newDate.update(microEpoch);return newDate};function formatDate(d,fmt,monthNames,dayNames){if(typeof d.strftime==="function"){return d.strftime(fmt)}var leftPad=function leftPad(n,pad){n=""+n;pad=""+(pad==null?"0":pad);return n.length===1?pad+n:n};var formatSubSeconds=function formatSubSeconds(milliseconds,microseconds,numberDecimalPlaces){var totalMicroseconds=milliseconds*1e3+microseconds;var formattedString;if(numberDecimalPlaces<6&&numberDecimalPlaces>0){var magnitude=parseFloat("1e"+(numberDecimalPlaces-6));totalMicroseconds=Math.round(Math.round(totalMicroseconds*magnitude)/magnitude);formattedString=("00000"+totalMicroseconds).slice(-6,-(6-numberDecimalPlaces))}else{totalMicroseconds=Math.round(totalMicroseconds);formattedString=("00000"+totalMicroseconds).slice(-6)}return formattedString};var r=[];var escape=false;var hours=d.getHours();var isAM=hours<12;if(!monthNames){monthNames=["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"]}if(!dayNames){dayNames=["Sun","Mon","Tue","Wed","Thu","Fri","Sat"]}var hours12;if(hours>12){hours12=hours-12}else if(hours===0){hours12=12}else{hours12=hours}var decimals=-1;for(var i=0;i<fmt.length;++i){var c=fmt.charAt(i);if(!isNaN(Number(c))&&Number(c)>0){decimals=Number(c)}else if(escape){switch(c){case"a":c=""+dayNames[d.getDay()];break;case"b":c=""+monthNames[d.getMonth()];break;case"d":c=leftPad(d.getDate());break;case"e":c=leftPad(d.getDate()," ");break;case"h":case"H":c=leftPad(hours);break;case"I":c=leftPad(hours12);break;case"l":c=leftPad(hours12," ");break;case"m":c=leftPad(d.getMonth()+1);break;case"M":c=leftPad(d.getMinutes());break;case"q":c=""+(Math.floor(d.getMonth()/3)+1);break;case"S":c=leftPad(d.getSeconds());break;case"s":c=""+formatSubSeconds(d.getMilliseconds(),d.getMicroseconds(),decimals);break;case"y":c=leftPad(d.getFullYear()%100);break;case"Y":c=""+d.getFullYear();break;case"p":c=isAM?""+"am":""+"pm";break;case"P":c=isAM?""+"AM":""+"PM";break;case"w":c=""+d.getDay();break}r.push(c);escape=false}else{if(c==="%"){escape=true}else{r.push(c)}}}return r.join("")}function makeUtcWrapper(d){function addProxyMethod(sourceObj,sourceMethod,targetObj,targetMethod){sourceObj[sourceMethod]=function(){return targetObj[targetMethod].apply(targetObj,arguments)}}var utc={date:d};if(d.strftime!==undefined){addProxyMethod(utc,"strftime",d,"strftime")}addProxyMethod(utc,"getTime",d,"getTime");addProxyMethod(utc,"setTime",d,"setTime");var props=["Date","Day","FullYear","Hours","Minutes","Month","Seconds","Milliseconds","Microseconds"];for(var p=0;p<props.length;p++){addProxyMethod(utc,"get"+props[p],d,"getUTC"+props[p]);addProxyMethod(utc,"set"+props[p],d,"setUTC"+props[p])}return utc}function dateGenerator(ts,opts){var maxDateValue=864e13;if(opts&&opts.timeBase==="seconds"){ts*=1e3}else if(opts.timeBase==="microseconds"){ts/=1e3}if(ts>maxDateValue){ts=maxDateValue}else if(ts<-maxDateValue){ts=-maxDateValue}if(opts.timezone==="browser"){return CreateMicroSecondDate(Date,ts)}else if(!opts.timezone||opts.timezone==="utc"){return makeUtcWrapper(CreateMicroSecondDate(Date,ts))}else if(typeof timezoneJS!=="undefined"&&typeof timezoneJS.Date!=="undefined"){var d=CreateMicroSecondDate(timezoneJS.Date,ts);d.setTimezone(opts.timezone);d.setTime(ts);return d}else{return makeUtcWrapper(CreateMicroSecondDate(Date,ts))}}var timeUnitSizeSeconds={microsecond:1e-6,millisecond:.001,second:1,minute:60,hour:60*60,day:24*60*60,month:30*24*60*60,quarter:3*30*24*60*60,year:365.2425*24*60*60};var timeUnitSizeMilliseconds={microsecond:.001,millisecond:1,second:1e3,minute:60*1e3,hour:60*60*1e3,day:24*60*60*1e3,month:30*24*60*60*1e3,quarter:3*30*24*60*60*1e3,year:365.2425*24*60*60*1e3};var timeUnitSizeMicroseconds={microsecond:1,millisecond:1e3,second:1e6,minute:60*1e6,hour:60*60*1e6,day:24*60*60*1e6,month:30*24*60*60*1e6,quarter:3*30*24*60*60*1e6,year:365.2425*24*60*60*1e6};var baseSpec=[[1,"microsecond"],[2,"microsecond"],[5,"microsecond"],[10,"microsecond"],[25,"microsecond"],[50,"microsecond"],[100,"microsecond"],[250,"microsecond"],[500,"microsecond"],[1,"millisecond"],[2,"millisecond"],[5,"millisecond"],[10,"millisecond"],[25,"millisecond"],[50,"millisecond"],[100,"millisecond"],[250,"millisecond"],[500,"millisecond"],[1,"second"],[2,"second"],[5,"second"],[10,"second"],[30,"second"],[1,"minute"],[2,"minute"],[5,"minute"],[10,"minute"],[30,"minute"],[1,"hour"],[2,"hour"],[4,"hour"],[8,"hour"],[12,"hour"],[1,"day"],[2,"day"],[3,"day"],[.25,"month"],[.5,"month"],[1,"month"],[2,"month"]];var specMonths=baseSpec.concat([[3,"month"],[6,"month"],[1,"year"]]);var specQuarters=baseSpec.concat([[1,"quarter"],[2,"quarter"],[1,"year"]]);function dateTickGenerator(axis){var opts=axis.options,ticks=[],d=dateGenerator(axis.min,opts),minSize=0;var spec=opts.tickSize&&opts.tickSize[1]==="quarter"||opts.minTickSize&&opts.minTickSize[1]==="quarter"?specQuarters:specMonths;var timeUnitSize;if(opts.timeBase==="seconds"){timeUnitSize=timeUnitSizeSeconds}else if(opts.timeBase==="microseconds"){timeUnitSize=timeUnitSizeMicroseconds}else{timeUnitSize=timeUnitSizeMilliseconds}if(opts.minTickSize!==null&&opts.minTickSize!==undefined){if(typeof opts.tickSize==="number"){minSize=opts.tickSize}else{minSize=opts.minTickSize[0]*timeUnitSize[opts.minTickSize[1]]}}for(var i=0;i<spec.length-1;++i){if(axis.delta<(spec[i][0]*timeUnitSize[spec[i][1]]+spec[i+1][0]*timeUnitSize[spec[i+1][1]])/2&&spec[i][0]*timeUnitSize[spec[i][1]]>=minSize){break}}var size=spec[i][0];var unit=spec[i][1];if(unit==="year"){if(opts.minTickSize!==null&&opts.minTickSize!==undefined&&opts.minTickSize[1]==="year"){size=Math.floor(opts.minTickSize[0])}else{var magn=parseFloat("1e"+Math.floor(Math.log(axis.delta/timeUnitSize.year)/Math.LN10));var norm=axis.delta/timeUnitSize.year/magn;if(norm<1.5){size=1}else if(norm<3){size=2}else if(norm<7.5){size=5}else{size=10}size*=magn}if(size<1){size=1}}axis.tickSize=opts.tickSize||[size,unit];var tickSize=axis.tickSize[0];unit=axis.tickSize[1];var step=tickSize*timeUnitSize[unit];if(unit==="microsecond"){d.setMicroseconds(floorInBase(d.getMicroseconds(),tickSize))}else if(unit==="millisecond"){d.setMilliseconds(floorInBase(d.getMilliseconds(),tickSize))}else if(unit==="second"){d.setSeconds(floorInBase(d.getSeconds(),tickSize))}else if(unit==="minute"){d.setMinutes(floorInBase(d.getMinutes(),tickSize))}else if(unit==="hour"){d.setHours(floorInBase(d.getHours(),tickSize))}else if(unit==="month"){d.setMonth(floorInBase(d.getMonth(),tickSize))}else if(unit==="quarter"){d.setMonth(3*floorInBase(d.getMonth()/3,tickSize))}else if(unit==="year"){d.setFullYear(floorInBase(d.getFullYear(),tickSize))}if(step>=timeUnitSize.millisecond){if(step>=timeUnitSize.second){d.setMicroseconds(0)}else{d.setMicroseconds(d.getMilliseconds()*1e3)}}if(step>=timeUnitSize.minute){d.setSeconds(0)}if(step>=timeUnitSize.hour){d.setMinutes(0)}if(step>=timeUnitSize.day){d.setHours(0)}if(step>=timeUnitSize.day*4){d.setDate(1)}if(step>=timeUnitSize.month*2){d.setMonth(floorInBase(d.getMonth(),3))}if(step>=timeUnitSize.quarter*2){d.setMonth(floorInBase(d.getMonth(),6))}if(step>=timeUnitSize.year){d.setMonth(0)}var carry=0;var v=Number.NaN;var v1000;var prev;do{prev=v;v1000=d.getTime();if(opts&&opts.timeBase==="seconds"){v=v1000/1e3}else if(opts&&opts.timeBase==="microseconds"){v=v1000*1e3}else{v=v1000}ticks.push(v);if(unit==="month"||unit==="quarter"){if(tickSize<1){d.setDate(1);var start=d.getTime();d.setMonth(d.getMonth()+(unit==="quarter"?3:1));var end=d.getTime();d.setTime(v+carry*timeUnitSize.hour+(end-start)*tickSize);carry=d.getHours();d.setHours(0)}else{d.setMonth(d.getMonth()+tickSize*(unit==="quarter"?3:1))}}else if(unit==="year"){d.setFullYear(d.getFullYear()+tickSize)}else{if(opts.timeBase==="seconds"){d.setTime((v+step)*1e3)}else if(opts.timeBase==="microseconds"){d.setTime((v+step)/1e3)}else{d.setTime(v+step)}}}while(v<axis.max&&v!==prev);return ticks}function init(plot){plot.hooks.processOptions.push(function(plot){$.each(plot.getAxes(),function(axisName,axis){var opts=axis.options;if(opts.mode==="time"){axis.tickGenerator=dateTickGenerator;if("tickFormatter"in opts&&typeof opts.tickFormatter==="function")return;axis.tickFormatter=function(v,axis){var d=dateGenerator(v,axis.options);if(opts.timeformat!=null){return formatDate(d,opts.timeformat,opts.monthNames,opts.dayNames)}var useQuarters=axis.options.tickSize&&axis.options.tickSize[1]==="quarter"||axis.options.minTickSize&&axis.options.minTickSize[1]==="quarter";var timeUnitSize;if(opts.timeBase==="seconds"){timeUnitSize=timeUnitSizeSeconds}else if(opts.timeBase==="microseconds"){timeUnitSize=timeUnitSizeMicroseconds}else{timeUnitSize=timeUnitSizeMilliseconds}var t=axis.tickSize[0]*timeUnitSize[axis.tickSize[1]];var span=axis.max-axis.min;var suffix=opts.twelveHourClock?" %p":"";var hourCode=opts.twelveHourClock?"%I":"%H";var factor;var fmt;if(opts.timeBase==="seconds"){factor=1}else if(opts.timeBase==="microseconds"){factor=1e6}else{factor=1e3}if(t<timeUnitSize.second){var decimals=-Math.floor(Math.log10(t/factor));if(String(t).indexOf("25")>-1){decimals++}fmt="%S.%"+decimals+"s"}else if(t<timeUnitSize.minute){fmt=hourCode+":%M:%S"+suffix}else if(t<timeUnitSize.day){if(span<2*timeUnitSize.day){fmt=hourCode+":%M"+suffix}else{fmt="%b %d "+hourCode+":%M"+suffix}}else if(t<timeUnitSize.month){fmt="%b %d"}else if(useQuarters&&t<timeUnitSize.quarter||!useQuarters&&t<timeUnitSize.year){if(span<timeUnitSize.year){fmt="%b"}else{fmt="%b %Y"}}else if(useQuarters&&t<timeUnitSize.year){if(span<timeUnitSize.year){fmt="Q%q"}else{fmt="Q%q %Y"}}else{fmt="%Y"}var rt=formatDate(d,fmt,opts.monthNames,opts.dayNames);return rt}}})})}$.plot.plugins.push({init:init,options:options,name:"time",version:"1.0"});$.plot.formatDate=formatDate;$.plot.dateGenerator=dateGenerator;$.plot.dateTickGenerator=dateTickGenerator;$.plot.makeUtcWrapper=makeUtcWrapper})(jQuery);"use strict";(function($){"use strict";var options={axisLabels:{show:true}};function AxisLabel(axisName,position,padding,placeholder,axisLabel,surface){this.axisName=axisName;this.position=position;this.padding=padding;this.placeholder=placeholder;this.axisLabel=axisLabel;this.surface=surface;this.width=0;this.height=0;this.elem=null}AxisLabel.prototype.calculateSize=function(){var axisId=this.axisName+"Label",layerId=axisId+"Layer",className=axisId+" axisLabels";var info=this.surface.getTextInfo(layerId,this.axisLabel,className);this.labelWidth=info.width;this.labelHeight=info.height;if(this.position==="left"||this.position==="right"){this.width=this.labelHeight+this.padding;this.height=0}else{this.width=0;this.height=this.labelHeight+this.padding}};AxisLabel.prototype.transforms=function(degrees,x,y,svgLayer){var transforms=[],translate,rotate;if(x!==0||y!==0){translate=svgLayer.createSVGTransform();translate.setTranslate(x,y);transforms.push(translate)}if(degrees!==0){rotate=svgLayer.createSVGTransform();var centerX=Math.round(this.labelWidth/2),centerY=0;rotate.setRotate(degrees,centerX,centerY);transforms.push(rotate)}return transforms};AxisLabel.prototype.calculateOffsets=function(box){var offsets={x:0,y:0,degrees:0};if(this.position==="bottom"){offsets.x=box.left+box.width/2-this.labelWidth/2;offsets.y=box.top+box.height-this.labelHeight}else if(this.position==="top"){offsets.x=box.left+box.width/2-this.labelWidth/2;offsets.y=box.top}else if(this.position==="left"){offsets.degrees=-90;offsets.x=box.left-this.labelWidth/2;offsets.y=box.height/2+box.top}else if(this.position==="right"){offsets.degrees=90;offsets.x=box.left+box.width-this.labelWidth/2;offsets.y=box.height/2+box.top}offsets.x=Math.round(offsets.x);offsets.y=Math.round(offsets.y);return offsets};AxisLabel.prototype.cleanup=function(){var axisId=this.axisName+"Label",layerId=axisId+"Layer",className=axisId+" axisLabels";this.surface.removeText(layerId,0,0,this.axisLabel,className)};AxisLabel.prototype.draw=function(box){var axisId=this.axisName+"Label",layerId=axisId+"Layer",className=axisId+" axisLabels",offsets=this.calculateOffsets(box),style={position:"absolute",bottom:"",right:"",display:"inline-block","white-space":"nowrap"};var layer=this.surface.getSVGLayer(layerId);var transforms=this.transforms(offsets.degrees,offsets.x,offsets.y,layer.parentNode);this.surface.addText(layerId,0,0,this.axisLabel,className,undefined,undefined,undefined,undefined,transforms);this.surface.render();Object.keys(style).forEach(function(key){layer.style[key]=style[key]})};function init(plot){plot.hooks.processOptions.push(function(plot,options){if(!options.axisLabels.show){return}var axisLabels={};var defaultPadding=2;plot.hooks.axisReserveSpace.push(function(plot,axis){var opts=axis.options;var axisName=axis.direction+axis.n;axis.labelHeight+=axis.boxPosition.centerY;axis.labelWidth+=axis.boxPosition.centerX;if(!opts||!opts.axisLabel||!axis.show){return}var padding=opts.axisLabelPadding===undefined?defaultPadding:opts.axisLabelPadding;var axisLabel=axisLabels[axisName];if(!axisLabel){axisLabel=new AxisLabel(axisName,opts.position,padding,plot.getPlaceholder()[0],opts.axisLabel,plot.getSurface());axisLabels[axisName]=axisLabel}axisLabel.calculateSize();axis.labelHeight+=axisLabel.height;axis.labelWidth+=axisLabel.width});plot.hooks.draw.push(function(plot,ctx){$.each(plot.getAxes(),function(flotAxisName,axis){var opts=axis.options;if(!opts||!opts.axisLabel||!axis.show){return}var axisName=axis.direction+axis.n;axisLabels[axisName].draw(axis.box)})});plot.hooks.shutdown.push(function(plot,eventHolder){for(var axisName in axisLabels){axisLabels[axisName].cleanup()}})})}$.plot.plugins.push({init:init,options:options,name:"axisLabels",version:"3.0"})})(jQuery);"use strict";(function($){function init(plot){var selection={first:{x:-1,y:-1},second:{x:-1,y:-1},show:false,currentMode:"xy",active:false};var SNAPPING_CONSTANT=$.plot.uiConstants.SNAPPING_CONSTANT;var savedhandlers={};function onDrag(e){if(selection.active){updateSelection(e);plot.getPlaceholder().trigger("plotselecting",[getSelection()])}}function onDragStart(e){var o=plot.getOptions();if(e.which!==1||o.selection.mode===null)return;selection.currentMode="xy";document.body.focus();if(document.onselectstart!==undefined&&savedhandlers.onselectstart==null){savedhandlers.onselectstart=document.onselectstart;document.onselectstart=function(){return false}}if(document.ondrag!==undefined&&savedhandlers.ondrag==null){savedhandlers.ondrag=document.ondrag;document.ondrag=function(){return false}}setSelectionPos(selection.first,e);selection.active=true}function onDragEnd(e){if(document.onselectstart!==undefined){document.onselectstart=savedhandlers.onselectstart}if(document.ondrag!==undefined){document.ondrag=savedhandlers.ondrag}selection.active=false;updateSelection(e);if(selectionIsSane()){triggerSelectedEvent()}else{plot.getPlaceholder().trigger("plotunselected",[]);plot.getPlaceholder().trigger("plotselecting",[null])}return false}function getSelection(){if(!selectionIsSane())return null;if(!selection.show)return null;var r={},c1={x:selection.first.x,y:selection.first.y},c2={x:selection.second.x,y:selection.second.y};if(selectionDirection(plot)==="x"){c1.y=0;c2.y=plot.height()}if(selectionDirection(plot)==="y"){c1.x=0;c2.x=plot.width()}$.each(plot.getAxes(),function(name,axis){if(axis.used){var p1=axis.c2p(c1[axis.direction]),p2=axis.c2p(c2[axis.direction]);r[name]={from:Math.min(p1,p2),to:Math.max(p1,p2)}}});return r}function triggerSelectedEvent(){var r=getSelection();plot.getPlaceholder().trigger("plotselected",[r]);if(r.xaxis&&r.yaxis){plot.getPlaceholder().trigger("selected",[{x1:r.xaxis.from,y1:r.yaxis.from,x2:r.xaxis.to,y2:r.yaxis.to}])}}function clamp(min,value,max){return value<min?min:value>max?max:value}function selectionDirection(plot){var o=plot.getOptions();if(o.selection.mode==="smart"){return selection.currentMode}else{return o.selection.mode}}function updateMode(pos){if(selection.first){var delta={x:pos.x-selection.first.x,y:pos.y-selection.first.y};if(Math.abs(delta.x)<SNAPPING_CONSTANT){selection.currentMode="y"}else if(Math.abs(delta.y)<SNAPPING_CONSTANT){selection.currentMode="x"}else{selection.currentMode="xy"}}}function setSelectionPos(pos,e){var offset=plot.getPlaceholder().offset();var plotOffset=plot.getPlotOffset();pos.x=clamp(0,e.pageX-offset.left-plotOffset.left,plot.width());pos.y=clamp(0,e.pageY-offset.top-plotOffset.top,plot.height());if(pos!==selection.first)updateMode(pos);if(selectionDirection(plot)==="y"){pos.x=pos===selection.first?0:plot.width()}if(selectionDirection(plot)==="x"){pos.y=pos===selection.first?0:plot.height()}}function updateSelection(pos){if(pos.pageX==null)return;setSelectionPos(selection.second,pos);if(selectionIsSane()){selection.show=true;plot.triggerRedrawOverlay()}else clearSelection(true)}function clearSelection(preventEvent){if(selection.show){selection.show=false;selection.currentMode="";plot.triggerRedrawOverlay();if(!preventEvent){plot.getPlaceholder().trigger("plotunselected",[])}}}function extractRange(ranges,coord){var axis,from,to,key,axes=plot.getAxes();for(var k in axes){axis=axes[k];if(axis.direction===coord){key=coord+axis.n+"axis";if(!ranges[key]&&axis.n===1){key=coord+"axis"}if(ranges[key]){from=ranges[key].from;to=ranges[key].to;break}}}if(!ranges[key]){axis=coord==="x"?plot.getXAxes()[0]:plot.getYAxes()[0];from=ranges[coord+"1"];to=ranges[coord+"2"]}if(from!=null&&to!=null&&from>to){var tmp=from;from=to;to=tmp}return{from:from,to:to,axis:axis}}function setSelection(ranges,preventEvent){var range;if(selectionDirection(plot)==="y"){selection.first.x=0;selection.second.x=plot.width()}else{range=extractRange(ranges,"x");selection.first.x=range.axis.p2c(range.from);selection.second.x=range.axis.p2c(range.to)}if(selectionDirection(plot)==="x"){selection.first.y=0;selection.second.y=plot.height()}else{range=extractRange(ranges,"y");selection.first.y=range.axis.p2c(range.from);selection.second.y=range.axis.p2c(range.to)}selection.show=true;plot.triggerRedrawOverlay();if(!preventEvent&&selectionIsSane()){triggerSelectedEvent()}}function selectionIsSane(){var minSize=plot.getOptions().selection.minSize;return Math.abs(selection.second.x-selection.first.x)>=minSize&&Math.abs(selection.second.y-selection.first.y)>=minSize}plot.clearSelection=clearSelection;plot.setSelection=setSelection;plot.getSelection=getSelection;plot.hooks.bindEvents.push(function(plot,eventHolder){var o=plot.getOptions();if(o.selection.mode!=null){plot.addEventHandler("dragstart",onDragStart,eventHolder,0);plot.addEventHandler("drag",onDrag,eventHolder,0);plot.addEventHandler("dragend",onDragEnd,eventHolder,0)}});function drawSelectionDecorations(ctx,x,y,w,h,oX,oY,mode){var spacing=3;var fullEarWidth=15;var earWidth=Math.max(0,Math.min(fullEarWidth,w/2-2,h/2-2));ctx.fillStyle="#ffffff";if(mode==="xy"){ctx.beginPath();ctx.moveTo(x,y+earWidth);ctx.lineTo(x-3,y+earWidth);ctx.lineTo(x-3,y-3);ctx.lineTo(x+earWidth,y-3);ctx.lineTo(x+earWidth,y);ctx.lineTo(x,y);ctx.closePath();ctx.moveTo(x,y+h-earWidth);ctx.lineTo(x-3,y+h-earWidth);ctx.lineTo(x-3,y+h+3);ctx.lineTo(x+earWidth,y+h+3);ctx.lineTo(x+earWidth,y+h);ctx.lineTo(x,y+h);ctx.closePath();ctx.moveTo(x+w,y+earWidth);ctx.lineTo(x+w+3,y+earWidth);ctx.lineTo(x+w+3,y-3);ctx.lineTo(x+w-earWidth,y-3);ctx.lineTo(x+w-earWidth,y);ctx.lineTo(x+w,y);ctx.closePath();ctx.moveTo(x+w,y+h-earWidth);ctx.lineTo(x+w+3,y+h-earWidth);ctx.lineTo(x+w+3,y+h+3);ctx.lineTo(x+w-earWidth,y+h+3);ctx.lineTo(x+w-earWidth,y+h);ctx.lineTo(x+w,y+h);ctx.closePath();ctx.stroke();ctx.fill()}x=oX;y=oY;if(mode==="x"){ctx.beginPath();ctx.moveTo(x,y+fullEarWidth);ctx.lineTo(x,y-fullEarWidth);ctx.lineTo(x-spacing,y-fullEarWidth);ctx.lineTo(x-spacing,y+fullEarWidth);ctx.closePath();ctx.moveTo(x+w,y+fullEarWidth);ctx.lineTo(x+w,y-fullEarWidth);ctx.lineTo(x+w+spacing,y-fullEarWidth);ctx.lineTo(x+w+spacing,y+fullEarWidth);ctx.closePath();ctx.stroke();ctx.fill()}if(mode==="y"){ctx.beginPath();ctx.moveTo(x-fullEarWidth,y);ctx.lineTo(x+fullEarWidth,y);ctx.lineTo(x+fullEarWidth,y-spacing);ctx.lineTo(x-fullEarWidth,y-spacing);ctx.closePath();ctx.moveTo(x-fullEarWidth,y+h);ctx.lineTo(x+fullEarWidth,y+h);ctx.lineTo(x+fullEarWidth,y+h+spacing);ctx.lineTo(x-fullEarWidth,y+h+spacing);ctx.closePath();ctx.stroke();ctx.fill()}}plot.hooks.drawOverlay.push(function(plot,ctx){if(selection.show&&selectionIsSane()){var plotOffset=plot.getPlotOffset();var o=plot.getOptions();ctx.save();ctx.translate(plotOffset.left,plotOffset.top);var c=$.color.parse(o.selection.color);var visualization=o.selection.visualization;var displaySelectionDecorations=o.selection.displaySelectionDecorations;var scalingFactor=1;if(visualization==="fill"){scalingFactor=.8}ctx.strokeStyle=c.scale("a",scalingFactor).toString();ctx.lineWidth=1;ctx.lineJoin=o.selection.shape;ctx.fillStyle=c.scale("a",.4).toString();var x=Math.min(selection.first.x,selection.second.x)+.5,oX=x,y=Math.min(selection.first.y,selection.second.y)+.5,oY=y,w=Math.abs(selection.second.x-selection.first.x)-1,h=Math.abs(selection.second.y-selection.first.y)-1;if(selectionDirection(plot)==="x"){h+=y;y=0}if(selectionDirection(plot)==="y"){w+=x;x=0}if(visualization==="fill"){ctx.fillRect(x,y,w,h);ctx.strokeRect(x,y,w,h)}else{ctx.fillRect(0,0,plot.width(),plot.height());ctx.clearRect(x,y,w,h);if(displaySelectionDecorations){drawSelectionDecorations(ctx,x,y,w,h,oX,oY,selectionDirection(plot))}}ctx.restore()}});plot.hooks.shutdown.push(function(plot,eventHolder){eventHolder.unbind("dragstart",onDragStart);eventHolder.unbind("drag",onDrag);eventHolder.unbind("dragend",onDragEnd)})}$.plot.plugins.push({init:init,options:{selection:{mode:null,visualization:"focus",displaySelectionDecorations:true,color:"#888888",shape:"round",minSize:5}},name:"selection",version:"1.1"})})(jQuery);"use strict";(function($){"use strict";var GENERALFAILURECALLBACKERROR=-100;var SUCCESSFULIMAGEPREPARATION=0;var EMPTYARRAYOFIMAGESOURCES=-1;var NEGATIVEIMAGESIZE=-2;var pixelRatio=1;var browser=$.plot.browser;var getPixelRatio=browser.getPixelRatio;function composeImages(canvasOrSvgSources,destinationCanvas){var validCanvasOrSvgSources=canvasOrSvgSources.filter(isValidSource);pixelRatio=getPixelRatio(destinationCanvas.getContext("2d"));var allImgCompositionPromises=validCanvasOrSvgSources.map(function(validCanvasOrSvgSource){var tempImg=new Image;var currentPromise=new Promise(getGenerateTempImg(tempImg,validCanvasOrSvgSource));return currentPromise});var lastPromise=Promise.all(allImgCompositionPromises).then(getExecuteImgComposition(destinationCanvas),failureCallback);return lastPromise}function isValidSource(canvasOrSvgSource){var isValidFromCanvas=true;var isValidFromContent=true;if(canvasOrSvgSource===null||canvasOrSvgSource===undefined){isValidFromContent=false}else{if(canvasOrSvgSource.tagName==="CANVAS"){if(canvasOrSvgSource.getBoundingClientRect().right===canvasOrSvgSource.getBoundingClientRect().left||canvasOrSvgSource.getBoundingClientRect().bottom===canvasOrSvgSource.getBoundingClientRect().top){isValidFromCanvas=false}}}return isValidFromContent&&isValidFromCanvas&&window.getComputedStyle(canvasOrSvgSource).visibility==="visible"}function getGenerateTempImg(tempImg,canvasOrSvgSource){tempImg.sourceDescription='<info className="'+canvasOrSvgSource.className+'" tagName="'+canvasOrSvgSource.tagName+'" id="'+canvasOrSvgSource.id+'">';tempImg.sourceComponent=canvasOrSvgSource;return function doGenerateTempImg(successCallbackFunc,failureCallbackFunc){tempImg.onload=function(evt){tempImg.successfullyLoaded=true;successCallbackFunc(tempImg)};tempImg.onabort=function(evt){tempImg.successfullyLoaded=false;console.log("Can't generate temp image from "+tempImg.sourceDescription+". It is possible that it is missing some properties or its content is not supported by this browser. Source component:",tempImg.sourceComponent);successCallbackFunc(tempImg)};tempImg.onerror=function(evt){tempImg.successfullyLoaded=false;console.log("Can't generate temp image from "+tempImg.sourceDescription+". It is possible that it is missing some properties or its content is not supported by this browser. Source component:",tempImg.sourceComponent);successCallbackFunc(tempImg)};generateTempImageFromCanvasOrSvg(canvasOrSvgSource,tempImg)}}function getExecuteImgComposition(destinationCanvas){return function executeImgComposition(tempImgs){var compositionResult=copyImgsToCanvas(tempImgs,destinationCanvas);return compositionResult}}function copyCanvasToImg(canvas,img){img.src=canvas.toDataURL("image/png")}function getCSSRules(document){var styleSheets=document.styleSheets,rulesList=[];for(var i=0;i<styleSheets.length;i++){try{var rules=styleSheets[i].cssRules||[];for(var j=0;j<rules.length;j++){var rule=rules[j];rulesList.push(rule.cssText)}}catch(e){console.log("Failed to get some css rules")}}return rulesList}function embedCSSRulesInSVG(rules,svg){var text=['<svg class="snapshot '+svg.classList+'" width="'+svg.width.baseVal.value*pixelRatio+'" height="'+svg.height.baseVal.value*pixelRatio+'" viewBox="0 0 '+svg.width.baseVal.value+" "+svg.height.baseVal.value+'" xmlns="http://www.w3.org/2000/svg">',"<style>","/* <![CDATA[ */",rules.join("\n"),"/* ]]> */","</style>",svg.innerHTML,"</svg>"].join("\n");return text}function copySVGToImgMostBrowsers(svg,img){var rules=getCSSRules(document),source=embedCSSRulesInSVG(rules,svg);source=patchSVGSource(source);var blob=new Blob([source],{type:"image/svg+xml;charset=utf-8"}),domURL=self.URL||self.webkitURL||self,url=domURL.createObjectURL(blob);img.src=url}function copySVGToImgSafari(svg,img){function buildBinaryString(arrayBuffer){var binaryString="";var utf8Array=new Uint8Array(arrayBuffer);var blockSize=16384;for(var i=0;i<utf8Array.length;i=i+blockSize){var binarySubString=String.fromCharCode.apply(null,utf8Array.subarray(i,i+blockSize));binaryString=binaryString+binarySubString}return binaryString}var rules=getCSSRules(document),source=embedCSSRulesInSVG(rules,svg),data,utf8BinaryString;source=patchSVGSource(source);utf8BinaryString=buildBinaryString(new(TextEncoder||TextEncoderLite)("utf-8").encode(source));data="data:image/svg+xml;base64,"+btoa(utf8BinaryString);img.src=data}function patchSVGSource(svgSource){var source="";if(!svgSource.match(/^<svg[^>]+xmlns="http:\/\/www\.w3\.org\/2000\/svg"/)){source=svgSource.replace(/^<svg/,'<svg xmlns="http://www.w3.org/2000/svg"')}if(!svgSource.match(/^<svg[^>]+"http:\/\/www\.w3\.org\/1999\/xlink"/)){source=svgSource.replace(/^<svg/,'<svg xmlns:xlink="http://www.w3.org/1999/xlink"')}return'<?xml version="1.0" standalone="no"?>\r\n'+source}function copySVGToImg(svg,img){if(browser.isSafari()||browser.isMobileSafari()){copySVGToImgSafari(svg,img)}else{copySVGToImgMostBrowsers(svg,img)}}function adaptDestSizeToZoom(destinationCanvas,sources){function containsSVGs(source){return source.srcImgTagName==="svg"}if(sources.find(containsSVGs)!==undefined){if(pixelRatio<1){destinationCanvas.width=destinationCanvas.width*pixelRatio;destinationCanvas.height=destinationCanvas.height*pixelRatio}}}function prepareImagesToBeComposed(sources,destination){var result=SUCCESSFULIMAGEPREPARATION;if(sources.length===0){result=EMPTYARRAYOFIMAGESOURCES}else{var minX=sources[0].genLeft;var minY=sources[0].genTop;var maxX=sources[0].genRight;var maxY=sources[0].genBottom;var i=0;for(i=1;i<sources.length;i++){if(minX>sources[i].genLeft){minX=sources[i].genLeft}if(minY>sources[i].genTop){minY=sources[i].genTop}}for(i=1;i<sources.length;i++){if(maxX<sources[i].genRight){maxX=sources[i].genRight}if(maxY<sources[i].genBottom){maxY=sources[i].genBottom}}if(maxX-minX<=0||maxY-minY<=0){result=NEGATIVEIMAGESIZE}else{destination.width=Math.round(maxX-minX);destination.height=Math.round(maxY-minY);for(i=0;i<sources.length;i++){sources[i].xCompOffset=sources[i].genLeft-minX;sources[i].yCompOffset=sources[i].genTop-minY}adaptDestSizeToZoom(destination,sources)}}return result}function copyImgsToCanvas(sources,destination){var prepareImagesResult=prepareImagesToBeComposed(sources,destination);if(prepareImagesResult===SUCCESSFULIMAGEPREPARATION){var destinationCtx=destination.getContext("2d");for(var i=0;i<sources.length;i++){if(sources[i].successfullyLoaded===true){destinationCtx.drawImage(sources[i],sources[i].xCompOffset*pixelRatio,sources[i].yCompOffset*pixelRatio)}}}return prepareImagesResult}function adnotateDestImgWithBoundingClientRect(srcCanvasOrSvg,destImg){destImg.genLeft=srcCanvasOrSvg.getBoundingClientRect().left;destImg.genTop=srcCanvasOrSvg.getBoundingClientRect().top;if(srcCanvasOrSvg.tagName==="CANVAS"){destImg.genRight=destImg.genLeft+srcCanvasOrSvg.width;destImg.genBottom=destImg.genTop+srcCanvasOrSvg.height}if(srcCanvasOrSvg.tagName==="svg"){destImg.genRight=srcCanvasOrSvg.getBoundingClientRect().right;destImg.genBottom=srcCanvasOrSvg.getBoundingClientRect().bottom}}function generateTempImageFromCanvasOrSvg(srcCanvasOrSvg,destImg){if(srcCanvasOrSvg.tagName==="CANVAS"){copyCanvasToImg(srcCanvasOrSvg,destImg)}if(srcCanvasOrSvg.tagName==="svg"){copySVGToImg(srcCanvasOrSvg,destImg)}destImg.srcImgTagName=srcCanvasOrSvg.tagName;adnotateDestImgWithBoundingClientRect(srcCanvasOrSvg,destImg)}function failureCallback(){return GENERALFAILURECALLBACKERROR}$.plot.composeImages=composeImages;function init(plot){plot.composeImages=composeImages}$.plot.plugins.push({init:init,name:"composeImages",version:"1.0"})})(jQuery);"use strict";(function($){var defaultOptions={legend:{show:false,noColumns:1,labelFormatter:null,container:null,position:"ne",margin:5,sorted:null,backgroundColor:null,backgroundOpacity:0}};function insertLegend(plot,options,placeholder,legendEntries){if(options.legend.container!=null){$(options.legend.container).html("")}else{placeholder.find(".legend").remove()}if(!options.legend.show){return}var entries=options.legend.legendEntries=legendEntries,plotOffset=options.legend.plotOffset=plot.getPlotOffset(),html=[],entry,labelHtml,iconHtml,j=0,i,pos="",p=options.legend.position,m=options.legend.margin,shape={name:"",label:"",xPos:"",yPos:""};html[j++]='<svg class="legendLayer" style="width:inherit;height:inherit;">';html[j++]='<rect class="background" width="100%" height="100%"/>';html[j++]=svgShapeDefs;var left=0;var columnWidths=[];var style=window.getComputedStyle(document.querySelector("body"));for(i=0;i<entries.length;++i){var columnIndex=i%options.legend.noColumns;entry=entries[i];shape.label=entry.label;var info=plot.getSurface().getTextInfo("",shape.label,{style:style.fontStyle,variant:style.fontVariant,weight:style.fontWeight,size:parseInt(style.fontSize),lineHeight:parseInt(style.lineHeight),family:style.fontFamily});var labelWidth=info.width;var iconWidth=48;if(columnWidths[columnIndex]){if(labelWidth>columnWidths[columnIndex]){columnWidths[columnIndex]=labelWidth+iconWidth}}else{columnWidths[columnIndex]=labelWidth+iconWidth}}for(i=0;i<entries.length;++i){var _columnIndex=i%options.legend.noColumns;entry=entries[i];iconHtml="";shape.label=entry.label;shape.xPos=left+3+"px";left+=columnWidths[_columnIndex];if((i+1)%options.legend.noColumns===0){left=0}shape.yPos=Math.floor(i/options.legend.noColumns)*1.5+"em";if(entry.options.lines.show&&entry.options.lines.fill){shape.name="area";shape.fillColor=entry.color;iconHtml+=getEntryIconHtml(shape)}if(entry.options.bars.show){shape.name="bar";shape.fillColor=entry.color;iconHtml+=getEntryIconHtml(shape)}if(entry.options.lines.show&&!entry.options.lines.fill){shape.name="line";shape.strokeColor=entry.color;shape.strokeWidth=entry.options.lines.lineWidth;iconHtml+=getEntryIconHtml(shape)}if(entry.options.points.show){shape.name=entry.options.points.symbol;shape.strokeColor=entry.color;shape.fillColor=entry.options.points.fillColor;shape.strokeWidth=entry.options.points.lineWidth;iconHtml+=getEntryIconHtml(shape)}labelHtml='<text x="'+shape.xPos+'" y="'+shape.yPos+'" text-anchor="start"><tspan dx="2em" dy="1.2em">'+shape.label+"</tspan></text>";html[j++]="<g>"+iconHtml+labelHtml+"</g>"}html[j++]="</svg>";if(m[0]==null){m=[m,m]}if(p.charAt(0)==="n"){pos+="top:"+(m[1]+plotOffset.top)+"px;"}else if(p.charAt(0)==="s"){pos+="bottom:"+(m[1]+plotOffset.bottom)+"px;"}if(p.charAt(1)==="e"){pos+="right:"+(m[0]+plotOffset.right)+"px;"}else if(p.charAt(1)==="w"){pos+="left:"+(m[0]+plotOffset.left)+"px;"}var width=6;for(i=0;i<columnWidths.length;++i){width+=columnWidths[i]}var legendEl,height=Math.ceil(entries.length/options.legend.noColumns)*1.6;if(!options.legend.container){legendEl=$('<div class="legend" style="position:absolute;'+pos+'">'+html.join("")+"</div>").appendTo(placeholder);legendEl.css("width",width+"px");legendEl.css("height",height+"em");legendEl.css("pointerEvents","none")}else{legendEl=$(html.join("")).appendTo(options.legend.container)[0];options.legend.container.style.width=width+"px";options.legend.container.style.height=height+"em"}if(options.legend.backgroundColor){$(".legendLayer rect.background").css({fill:options.legend.backgroundColor,background:options.legend.backgroundColor})}$(".legendLayer rect.background").css("opacity",options.legend.backgroundOpacity?options.legend.backgroundOpacity:1)}function getEntryIconHtml(shape){var html="",name=shape.name,x=shape.xPos,y=shape.yPos,fill=shape.fillColor,stroke=shape.strokeColor,width=shape.strokeWidth;switch(name){case"circle":html='<use xlink:href="#circle" class="legendIcon" '+'x="'+x+'" '+'y="'+y+'" '+'fill="'+fill+'" '+'stroke="'+stroke+'" '+'stroke-width="'+width+'" '+'width="1.5em" height="1.5em"'+"/>";break;case"diamond":html='<use xlink:href="#diamond" class="legendIcon" '+'x="'+x+'" '+'y="'+y+'" '+'fill="'+fill+'" '+'stroke="'+stroke+'" '+'stroke-width="'+width+'" '+'width="1.5em" height="1.5em"'+"/>";break;case"cross":html='<use xlink:href="#cross" class="legendIcon" '+'x="'+x+'" '+'y="'+y+'" '+'stroke="'+stroke+'" '+'stroke-width="'+width+'" '+'width="1.5em" height="1.5em"'+"/>";break;case"rectangle":html='<use xlink:href="#rectangle" class="legendIcon" '+'x="'+x+'" '+'y="'+y+'" '+'fill="'+fill+'" '+'stroke="'+stroke+'" '+'stroke-width="'+width+'" '+'width="1.5em" height="1.5em"'+"/>";break;case"plus":html='<use xlink:href="#plus" class="legendIcon" '+'x="'+x+'" '+'y="'+y+'" '+'stroke="'+stroke+'" '+'stroke-width="'+width+'" '+'width="1.5em" height="1.5em"'+"/>";break;case"bar":html='<use xlink:href="#bars" class="legendIcon" '+'x="'+x+'" '+'y="'+y+'" '+'fill="'+fill+'" '+'width="1.5em" height="1.5em"'+"/>";break;case"area":html='<use xlink:href="#area" class="legendIcon" '+'x="'+x+'" '+'y="'+y+'" '+'fill="'+fill+'" '+'width="1.5em" height="1.5em"'+"/>";break;case"line":html='<use xlink:href="#line" class="legendIcon" '+'x="'+x+'" '+'y="'+y+'" '+'stroke="'+stroke+'" '+'stroke-width="'+width+'" '+'width="1.5em" height="1.5em"'+"/>";break;default:html='<use xlink:href="#circle" class="legendIcon" '+'x="'+x+'" '+'y="'+y+'" '+'fill="'+fill+'" '+'stroke="'+stroke+'" '+'stroke-width="'+width+'" '+'width="1.5em" height="1.5em"'+"/>"}return html}var svgShapeDefs=""+"<defs>"+'<symbol id="line" fill="none" viewBox="-5 -5 25 25">'+'<polyline points="0,15 5,5 10,10 15,0"/>'+"</symbol>"+'<symbol id="area" stroke-width="1" viewBox="-5 -5 25 25">'+'<polyline points="0,15 5,5 10,10 15,0, 15,15, 0,15"/>'+"</symbol>"+'<symbol id="bars" stroke-width="1" viewBox="-5 -5 25 25">'+'<polyline points="1.5,15.5 1.5,12.5, 4.5,12.5 4.5,15.5 6.5,15.5 6.5,3.5, 9.5,3.5 9.5,15.5 11.5,15.5 11.5,7.5 14.5,7.5 14.5,15.5 1.5,15.5"/>'+"</symbol>"+'<symbol id="circle" viewBox="-5 -5 25 25">'+'<circle cx="0" cy="15" r="2.5"/>'+'<circle cx="5" cy="5" r="2.5"/>'+'<circle cx="10" cy="10" r="2.5"/>'+'<circle cx="15" cy="0" r="2.5"/>'+"</symbol>"+'<symbol id="rectangle" viewBox="-5 -5 25 25">'+'<rect x="-2.1" y="12.9" width="4.2" height="4.2"/>'+'<rect x="2.9" y="2.9" width="4.2" height="4.2"/>'+'<rect x="7.9" y="7.9" width="4.2" height="4.2"/>'+'<rect x="12.9" y="-2.1" width="4.2" height="4.2"/>'+"</symbol>"+'<symbol id="diamond" viewBox="-5 -5 25 25">'+'<path d="M-3,15 L0,12 L3,15, L0,18 Z"/>'+'<path d="M2,5 L5,2 L8,5, L5,8 Z"/>'+'<path d="M7,10 L10,7 L13,10, L10,13 Z"/>'+'<path d="M12,0 L15,-3 L18,0, L15,3 Z"/>'+"</symbol>"+'<symbol id="cross" fill="none" viewBox="-5 -5 25 25">'+'<path d="M-2.1,12.9 L2.1,17.1, M2.1,12.9 L-2.1,17.1 Z"/>'+'<path d="M2.9,2.9 L7.1,7.1 M7.1,2.9 L2.9,7.1 Z"/>'+'<path d="M7.9,7.9 L12.1,12.1 M12.1,7.9 L7.9,12.1 Z"/>'+'<path d="M12.9,-2.1 L17.1,2.1 M17.1,-2.1 L12.9,2.1 Z"/>'+"</symbol>"+'<symbol id="plus" fill="none" viewBox="-5 -5 25 25">'+'<path d="M0,12 L0,18, M-3,15 L3,15 Z"/>'+'<path d="M5,2 L5,8 M2,5 L8,5 Z"/>'+'<path d="M10,7 L10,13 M7,10 L13,10 Z"/>'+'<path d="M15,-3 L15,3 M12,0 L18,0 Z"/>'+"</symbol>"+"</defs>";function getLegendEntries(series,labelFormatter,sorted){var lf=labelFormatter,legendEntries=series.reduce(function(validEntries,s,i){var labelEval=lf?lf(s.label,s):s.label;if(s.hasOwnProperty("label")?labelEval:true){var entry={label:labelEval||"Plot "+(i+1),color:s.color,options:{lines:s.lines,points:s.points,bars:s.bars}};validEntries.push(entry)}return validEntries},[]);if(sorted){if($.isFunction(sorted)){legendEntries.sort(sorted)}else if(sorted==="reverse"){legendEntries.reverse()}else{var ascending=sorted!=="descending";legendEntries.sort(function(a,b){return a.label===b.label?0:a.label<b.label!==ascending?1:-1})}}return legendEntries}function checkOptions(opts1,opts2){for(var prop in opts1){if(opts1.hasOwnProperty(prop)){if(opts1[prop]!==opts2[prop]){return true}}}return false}function shouldRedraw(oldEntries,newEntries){if(!oldEntries||!newEntries){return true}if(oldEntries.length!==newEntries.length){return true}var i,newEntry,oldEntry,newOpts,oldOpts;for(i=0;i<newEntries.length;i++){newEntry=newEntries[i];oldEntry=oldEntries[i];if(newEntry.label!==oldEntry.label){return true}if(newEntry.color!==oldEntry.color){return true}newOpts=newEntry.options.lines;oldOpts=oldEntry.options.lines;if(checkOptions(newOpts,oldOpts)){return true}newOpts=newEntry.options.points;oldOpts=oldEntry.options.points;if(checkOptions(newOpts,oldOpts)){return true}newOpts=newEntry.options.bars;oldOpts=oldEntry.options.bars;if(checkOptions(newOpts,oldOpts)){return true}}return false}function init(plot){plot.hooks.setupGrid.push(function(plot){var options=plot.getOptions();var series=plot.getData(),labelFormatter=options.legend.labelFormatter,oldEntries=options.legend.legendEntries,oldPlotOffset=options.legend.plotOffset,newEntries=getLegendEntries(series,labelFormatter,options.legend.sorted),newPlotOffset=plot.getPlotOffset();if(shouldRedraw(oldEntries,newEntries)||checkOptions(oldPlotOffset,newPlotOffset)){insertLegend(plot,options,plot.getPlaceholder(),newEntries)}})}$.plot.plugins.push({init:init,options:defaultOptions,name:"legend",version:"1.0"})})(jQuery);